using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Mail;
using System.IO;
using System.Data;
using System.Web;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.ReportSource;
using CrystalDecisions.Shared;
using System.Globalization;
using System.Collections;
using Cryptographys;
using System.Configuration;
namespace TimecheckReportSchedularService
{
    class Program
    {
        string strMonth, strYear, strDay, strFromDate;
        string ReportName1 = string.Empty;
        string ScheduleName = string.Empty;
        string CreatedBy = string.Empty;
        string Duration = string.Empty;
        string strLink;
        DataTable dsDateFormat = new DataTable();
        static void Main(string[] args)
        {
            Program objProgram = new Program();
            GetReports objGetReports = new GetReports();
            DataSet dsDateTimeFormat = new DataSet();
            dsDateTimeFormat = objGetReports.Select_DateandTimeFormat();
            Console.WriteLine("Daily");
            objProgram.GetEmailSchedule("Daily", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
            Console.WriteLine("Weekly");
            objProgram.GetEmailSchedule("Weekly", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
            Console.WriteLine("Monthly");
            objProgram.GetEmailSchedule("Monthly", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
        }
        public void GetEmailSchedule(string ScheduleBasis, string DateFormat, string TimeFormat)
        {
            GetReports objGetReports = new GetReports();
            DataSet dsEmailSchedule = new DataSet();
            dsEmailSchedule = objGetReports.GetEmailSchedule(ScheduleBasis);
            DataSet dsDate = new DataSet();
            if (dsEmailSchedule.Tables[0].Rows.Count > 0)
            {
                string FromDate = string.Empty;
                string ToDate = string.Empty;
                string FromDate_InReport = string.Empty;
                string ToDate_InReport = string.Empty;
                DataSet dsActiveLanguage = new DataSet();
                dsActiveLanguage = objGetReports.GetActiveLanguage();
                foreach (DataRow drRow in dsEmailSchedule.Tables[0].Rows)
                {
                    DataSet dsScheduleDetails = new DataSet();
                    dsScheduleDetails = objGetReports.GetEmailIdsForSendingEmail(Convert.ToInt32(drRow["ScheduleId"]));
                    if (dsScheduleDetails != null && dsScheduleDetails.Tables.Count > 0 && dsScheduleDetails.Tables[0].Rows.Count > 0)
                    {
                        if (ScheduleBasis == "Daily")
                        {
                            dsDate = objGetReports.GetDates(ScheduleBasis, 0, 0);
                            if (dsDate.Tables[0].Rows.Count > 0)
                            {
                                FromDate = dsDate.Tables[0].Rows[0][0].ToString();
                                ToDate = dsDate.Tables[0].Rows[0][1].ToString();
                            }
                            else
                            {
                                FromDate = DateTime.Now.ToString("yyyy-MM-dd");
                                ToDate = DateTime.Now.ToString("yyyy-MM-dd");
                            }
                        }
                        else if (ScheduleBasis == "Weekly")
                        {
                            string strDayFrom = dsScheduleDetails.Tables[0].Rows[0]["DayFrom"].ToString();
                            string strDayTo = dsScheduleDetails.Tables[0].Rows[0]["DayTo"].ToString();
                            DataSet dsPrev_WeekDates = new DataSet();
                            dsPrev_WeekDates = objGetReports.GetSampleWeekDays(2, SelectDropDownItem(Convert.ToString(strDayFrom)), SelectDropDownItem(Convert.ToString(strDayTo)), 0, 0);
                            if (dsPrev_WeekDates.Tables.Count > 0)
                            {
                                if (dsPrev_WeekDates.Tables[0].Rows.Count > 0)
                                {
                                    FromDate = dsPrev_WeekDates.Tables[0].Rows[0][1].ToString();
                                    ToDate = dsPrev_WeekDates.Tables[0].Rows[0][2].ToString();
                                }
                            }
                        }
                        else if (ScheduleBasis == "Monthly")
                        {
                            int Month = DateTime.Now.Date.Month;
                            int DateFrom = Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["DateFrom"]);
                            int DateTo = Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["DateTo"]);
                            int Year = DateTime.Now.Year;
                            dsDate = objGetReports.GetSampleWeekDays(3, "", "", DateFrom, DateTo);
                            if (dsDate.Tables[0].Rows.Count > 0)
                            {
                                FromDate = dsDate.Tables[0].Rows[0][1].ToString();
                                ToDate = dsDate.Tables[0].Rows[0][2].ToString();
                            }
                        }
                        if (dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString() == "Report_FirstInPunchDifference" || dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString() == "System_MultiLingual")
                        {
                            FromDate = (Convert.ToDateTime(FromDate).AddDays(-1)).ToShortDateString();
                            ToDate = (Convert.ToDateTime(ToDate).AddDays(-1)).ToShortDateString();
                        }
                        //FromDate_InReport = FromDate;
                        //ToDate_InReport = ToDate;
                        dsDateFormat = objGetReports.GetDatesWithFormat(FromDate, ToDate);
                        if (dsDateFormat.Rows.Count > 0)
                        {
                            FromDate_InReport = Convert.ToString(dsDateFormat.Rows[0][0]);
                            ToDate_InReport = Convert.ToString(dsDateFormat.Rows[0][1]);
                            FromDate_InReport = FromDate_InReport.Replace('/', '-');
                            ToDate_InReport = ToDate_InReport.Replace('/', '-');
                        }
                        else
                        {
                            FromDate_InReport = FromDate;
                            ToDate_InReport = ToDate;
                        }
                        if (ScheduleBasis == "Daily")
                        {
                            Duration = FromDate_InReport;
                            ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                            ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                            CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                        }
                        else if (ScheduleBasis == "Weekly")
                        {
                            Duration = FromDate_InReport + " - " + ToDate_InReport;
                            ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                            ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                            CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                        }
                        else if (ScheduleBasis == "Monthly")
                        {
                            Duration = FromDate_InReport + " - " + ToDate_InReport;
                            ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                            ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                            CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                        }
                        if (dsActiveLanguage.Tables.Count > 0)
                        {
                            if (dsActiveLanguage.Tables[0].Rows.Count > 0)
                            {
                                LoadReport(dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["Filters"].ToString(), FromDate, ToDate, dsScheduleDetails.Tables[0].Rows[0]["ToEmailList"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["CCEmailList"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["ScheduleId"]), DateFormat, TimeFormat, dsScheduleDetails.Tables[0].Rows[0]["Subject"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["EmailContent"].ToString(), FromDate_InReport, ToDate_InReport, dsActiveLanguage.Tables[0].Rows[0]["Language_Name"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["CompanyId"]), dsScheduleDetails.Tables[0].Rows[0]["ReportType"].ToString(), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["EmailSendType"]), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["Authentication"]), dsScheduleDetails.Tables[0].Rows[0]["FileType"].ToString());
                            }
                        }
                        else
                        {
                            LoadReport(dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["Filters"].ToString(), FromDate, ToDate, dsScheduleDetails.Tables[0].Rows[0]["ToEmailList"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["CCEmailList"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["ScheduleId"]), DateFormat, TimeFormat, dsScheduleDetails.Tables[0].Rows[0]["Subject"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["EmailContent"].ToString(), FromDate_InReport, ToDate_InReport, "", Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["CompanyId"]), dsScheduleDetails.Tables[0].Rows[0]["ReportType"].ToString(), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["EmailSendType"]), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["Authentication"]), dsScheduleDetails.Tables[0].Rows[0]["FileType"].ToString());
                        }
                    }
                }
            }
        }
        public void TriggerMail(string bodyContent, string subject, string ToEmail, string CCEmail, Attachment attachment)
        {
            GetReports objGetReports = new GetReports();
            DataSet dsMailConfiguration = new DataSet();
            dsMailConfiguration = objGetReports.GetMailConfiguration();
            string FromEmailId = string.Empty;
            string SMTPHost = string.Empty;
            string SMTPPort = string.Empty;
            if (dsMailConfiguration.Tables[0].Rows.Count > 0)
            {
                FromEmailId = dsMailConfiguration.Tables[0].Rows[0]["FromEmailId"].ToString();
                SMTPHost = dsMailConfiguration.Tables[0].Rows[0]["SMTPClientHost"].ToString();
                SMTPPort = dsMailConfiguration.Tables[0].Rows[0]["SMTPPort"].ToString();
            }
            else
            {
            }
            SmtpClient client = new SmtpClient();
            client.Host = SMTPHost;
            client.Port = Convert.ToInt32(SMTPPort);
            try
            {
                /*
                 * Code Added By Thilakraj.C
                 * Date : 20-Feb-2013
                 * For : create LINK for Authentication or UnAuthentication User
                 *                                          
                 */
                //Start
                //The following coding is used to change the Heading for multiple report in single windows like Exception report
                //if (ReportName == "Report_Late_Entry")
                //{
                //    if (ReportType == "LateEntry")
                //        ReportName = "Report_Late_Entry";
                //    else if (ReportType == "EarlyExit")
                //        ReportName = "Report_Early_Exit";
                //    else if (ReportType == "EarlyEntry")
                //        ReportName = "Report_EarltEntry";
                //    else if (ReportType == "LateExit")
                //        ReportName = "Report_Late_Exit";
                //}
                //End
                if (bodyContent.Contains("{Report Name}"))
                {
                    bodyContent = bodyContent.Replace("{Report Name}", ReportName1);
                }
                if (bodyContent.Contains("{Schedule Name}"))
                {
                    bodyContent = bodyContent.Replace("{Schedule Name}", ScheduleName);
                }
                if (bodyContent.Contains("{Duration}"))
                {
                    bodyContent = bodyContent.Replace("{Duration}", Duration);
                }
                if (bodyContent.Contains("{Created By}"))
                {
                    bodyContent = bodyContent.Replace("{Created By}", CreatedBy);
                }
                if (subject.Contains("{Report Name}"))
                {
                    subject = subject.Replace("{Report Name}", ReportName1);
                }
                if (subject.Contains("{Schedule Name}"))
                {
                    subject = subject.Replace("{Schedule Name}", ScheduleName);
                }
                if (subject.Contains("{Duration}"))
                {
                    subject = subject.Replace("{Duration}", Duration);
                }
                if (subject.Contains("{Created By}"))
                {
                    subject = subject.Replace("{Created By}", CreatedBy);
                }
                //End
                MailMessage message = new MailMessage();
                message.Body = bodyContent;
                message.IsBodyHtml = true;
                message.Subject = subject;
                message.From = new MailAddress(FromEmailId);
                char[] split = { ';' };
                string[] strToEmailIds = ToEmail.Split(split);
                foreach (string strToMail in strToEmailIds)
                {
                    if (strToMail != string.Empty)
                    {
                        message.To.Add(strToMail);
                    }
                }
                string[] strCCEmailIds = CCEmail.Split(split);
                foreach (string strCCMail in strCCEmailIds)
                {
                    if (strCCMail != string.Empty)
                    {
                        message.CC.Add(strCCMail);
                    }
                }
                if (attachment != null)
                {
                    message.Attachments.Add(attachment);
                }
                // Send the e-mail message via the specified SMTP server
                client.Send(message);
                //message.Dispose();
                //message = null;
            }
            catch (Exception errorInSendingMail)
            {
                throw errorInSendingMail;
            }
        }
        /*
            * Code Added By Thilakraj.C
            * Date : 20-Feb-2013
            * For : create LINK for Authentication or UnAuthentication User
            *                                          
        */
        //Start
        public string LinkCreation(string Mailbody, int Authentication, int ScheduleId, string FromDate, string Todate, string Language, string DateFormat, string TimeFormat)
        {
            string UpdatedMailbody = string.Empty;
            string strVirualDirectory = string.Empty;
            UpdatedMailbody = Mailbody;
            UpdatedMailbody = UpdatedMailbody + "{Link}";
            strVirualDirectory = ConfigurationSettings.AppSettings["VirualDirectory"].ToString();
            strVirualDirectory = "localhost:10316/Application/";
            if (Authentication == 1)
            {
                //Login Required
                if (UpdatedMailbody.Contains("{Link}"))
                {
                    string Link = string.Empty;
                    string LinkHref = string.Empty;
                    Link = @"<br/><br/><b><a runat=""server"" href=""{LinkHref}""><span>Click Here To Open the File</span></a></b> ";
                    if (Link.Contains("{LinkHref}"))
                    {
                        LinkHref = "http://" + strVirualDirectory.Trim() + "/Index.aspx?ScheduleId=" + Encryption.Encrypt(ScheduleId.ToString(), "") + "&FromDate=" + Encryption.Encrypt(FromDate.ToString(), "") + "&ToDate=" + Encryption.Encrypt(Todate.ToString(), "");
                        Link = Link.Replace("{LinkHref}", LinkHref);
                    }
                    UpdatedMailbody = UpdatedMailbody.Replace("{Link}", Link);
                }
            }
            else
            {
                //Show File
                if (UpdatedMailbody.Contains("{Link}"))
                {
                    string Link = string.Empty;
                    string LinkHref = string.Empty;
                    Link = @"<br/><br/><b><a runat=""server"" href=""{LinkHref}""><span>Click Here To Open the File</span></a></b> ";
                    if (Link.Contains("{LinkHref}"))
                    {
                        LinkHref = "http://" + strVirualDirectory.Trim() + "/Reports/TA_UI_Report_ReportViewer.aspx?ScheduleId=" + Encryption.Encrypt(ScheduleId.ToString(), "") + "&Language=" + Encryption.Encrypt(Language, "") + "&FromDate=" + Encryption.Encrypt(FromDate.ToString(), "") + "&ToDate=" + Encryption.Encrypt(Todate.ToString(), "") + "&DateFormat=" + Encryption.Encrypt(DateFormat.ToString(), "") + "&TimeFormat=" + Encryption.Encrypt(TimeFormat.ToString(), "");
                        Link = Link.Replace("{LinkHref}", LinkHref);
                    }
                    UpdatedMailbody = UpdatedMailbody.Replace("{Link}", Link);
                }
            }
            return UpdatedMailbody;
        }
        //End
        public string splitvalue(string Filter)
        {
            char[] split = { '=' };
            string[] strFilters = Filter.Split(split);
            return Convert.ToString(strFilters[1]);
        }
        public void LoadReport(string ReportName, string Filters, string FromDate, string ToDate, string ToEmail, string CCEmail, int ScheduleId, string DateFormat, string TimeFormat, string Subject, string EmailContent, string FromDateInReport, string ToDateInReport, string LanguageName, int CompanyId, string ReportType, int EmailSendType, int Authentication, string FileFormat)
        {
            GetReports objGetReports = new GetReports();
            ReportDocument rptDoc = new ReportDocument();
            HeaderInformation hdrTable = new HeaderInformation();
            DataSet dsHeader = new DataSet();
            dsHeader = objGetReports.getHeader(CompanyId);
            DataSet dsData = new DataSet();
            if (ReportName == "Report_FirstInPunchDifference" || ReportName == "System_MultiLingual")
            {
                FromDate = (Convert.ToDateTime(FromDate).AddDays(-1)).ToShortDateString();
                ToDate = (Convert.ToDateTime(ToDate).AddDays(-1)).ToShortDateString();
            }
            if (ReportName == "Report_Late_Entry")
            {
                if (ReportType == "LateEntry")
                {
                    ReportName = "Report_Late_Entry";
                    ReportName1 = "Report_Late_Entry";
                }
                else if (ReportType == "EarlyExit")
                {
                    ReportName = "Report_Early_Exit";
                    ReportName1 = "Report_Early_Exit";
                }
                else if (ReportType == "EarlyEntry")
                {
                    ReportName = "Report_EarlyEntry";
                    ReportName1 = "Report_EarlyEntry";
                }
                else if (ReportType == "LateExit")
                {
                    ReportName = "Report_Late_Exit";
                    ReportName1 = "Report_Late_Exit";
                }
            }
            Filters = Filters.Replace(" Duration_From ", FromDate);
            Filters = Filters.Replace(" Duration_To ", ToDate);
            Console.WriteLine(ReportName);
            switch (ReportName)
            {
                case "Report_WeeklyWorkHours":
                    #region Report_Monthly_Attendance
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Cumulative Minimum Work Week Hours";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Cumulative Minimum Work Week Hours";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "0")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\WeeklyWorkHours.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\WeeklyWorkHours.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\WeeklyWorkHoursSummary.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\WeeklyWorkHoursSummary.rpt"));
                                            }                                            
                                        }
                                        //MonthlyAttendanceDetailData2
                                        rptDoc.Database.Tables["dt_Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Weekly_Work_Hours"].SetDataSource(dsData.Tables[1]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.Database.Tables["WeekDayDetails"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        if (ReportType == "0")
                                        {
                                            rptDoc.SetParameterValue("DtFormat", DateFormat, "WeekDayDetails");
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat, "WeekDayDetails");
                                        }
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_RawData":
                    #region Report_RawData
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "RawData";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "RawData";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "0")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptRawData.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptRawData.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\rptRawDataLatestPunch.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\rptRawDataLatestPunch.rpt"));
                                            }
                                        }
                                        //MonthlyAttendanceDetailData2
                                        rptDoc.Database.Tables["dt_Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["RawData"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_GeneralMonthly_Attendance":
                    #region Report_Monthly_Attendance
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "General Monthly Attendance";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "General Monthly Attendance";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptGeneralMonthlyAttendance.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptGeneralMonthlyAttendance.rpt"));
                                        }
                                        //MonthlyAttendanceDetailData2
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_All_Swipes":
                    #region Report_All_Swipes
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "All Swipes";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "All Swipes Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectMovementsEntryReport("", "", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both", "12:00:00 AM", "11:59:59 PM");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        int AllSwipesReportType;
                                        AllSwipesReportType = objGetReports.ReturnAllSwiper();
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\MovementsEntry_AR.rpt"));
                                        }
                                        else
                                        {
                                            if (AllSwipesReportType == 1)
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptMovementEntry_FirstAndLast.rpt"));
                                            }
                                            else if (AllSwipesReportType == 2)
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\MatchedMovementsEntry.rpt"));
                                            }
                                            else if (AllSwipesReportType == 3)
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\MovementsEntryWithOutMatched.rpt"));
                                            }
                                            else if (AllSwipesReportType == 4)
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\OtherMovementsEntry.rpt"));
                                            }
                                            else if (AllSwipesReportType != 1)
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\MovementsEntry.rpt"));
                                            }
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Detailed_Attendance":
                    #region Report_Detailed_Attendance
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Detailed Attendance";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Detailed Attendance Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectDetailAttend(FromDate, ToDate, "", "", "", UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        dsData.Tables[0].Columns.Remove("EmployeeCategory");
                        dsData.Tables[0].Columns.Remove("EmpCategory");
                        dsData.Tables[0].Columns.Remove("EmployeeType");
                        int iField = 1;
                        int iInc = 0;
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        DataTable dtHeaderLabel = new DataTable();
                                        dtHeaderLabel.TableName = "HeaderLabels";
                                        DataTable dtNew = new DataTable();
                                        dtNew = dsData.Tables[0];
                                        //DataTable dtDetAttend = new DataTable();
                                        //dtDetAttend = dsData.Tables["Table"].Copy();
                                        DataTable dt = new DataTable();
                                        DataSet dsReportHeader = new DataSet();
                                        dsReportHeader = objGetReports.getHeader(CompanyId);
                                        if (dsData.Tables[0].Columns.Count > 11)
                                        {
                                            // total columns = 16
                                            if (dsData.Tables[0].Columns.Count < 21)
                                            {
                                                int iDiff = (20 - dsData.Tables[0].Columns.Count);
                                                for (int iDum = 0; iDum < iDiff; iDum++)
                                                {
                                                    dsData.Tables[0].Columns.Add(new DataColumn("iField" + iInc, System.Type.GetType("System.String")));
                                                    iInc = iInc + 1;
                                                }
                                            }
                                            DataRow dsRow = dtHeaderLabel.NewRow();
                                            int iIcont = 1;
                                            for (int iRow = 0; iRow < dsData.Tables[0].Columns.Count; iRow++)
                                            {
                                                dtHeaderLabel.Columns.Add(new DataColumn("Header" + iIcont, System.Type.GetType("System.String")));
                                                if (dsData.Tables[0].Columns[iRow].ColumnName != "Others")
                                                {
                                                    dsRow[iRow] = dsData.Tables[0].Columns[iRow].ColumnName;
                                                }
                                                else if (dsData.Tables[0].Columns[iRow].ColumnName == "Others")
                                                {
                                                    //dsRow[iRow] = rm.GetString("Employee_Others", ci);
                                                    dsRow[iRow] = dsData.Tables[0].Columns[iRow].ColumnName;
                                                }
                                                iIcont = iIcont + 1;
                                            }
                                            int iCheckFlag = 0;
                                            dtHeaderLabel.Rows.InsertAt(dsRow, 0);
                                            for (int iCol = 16; iCol < dsData.Tables[0].Columns.Count; iCol++)
                                            {
                                                if (dsData.Tables[0].Columns[iCol].ColumnName != "Others")
                                                {
                                                    dsData.Tables[0].Columns[iCol].ColumnName = "Field" + iField;
                                                    iField = iField + 1;
                                                }
                                                else
                                                {
                                                    iCheckFlag = 1;
                                                }
                                            }

                                            if (iCheckFlag == 0)
                                            {
                                                //dsEmp.Tables[0].Columns[16].ColumnName = "Others";
                                                //dsEmp.Tables[0].Columns[16].ColumnName = rm.GetString("Employee_Others", ci);
                                            }
                                        }
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\detailedAttendance_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\detailedAttendance.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsReportHeader.Tables[0]);
                                        rptDoc.Database.Tables["HeaderLabels"].SetDataSource(dtHeaderLabel);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Monthly_Attendance":
                    #region Report_Monthly_Attendance
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Monthly Attendance";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Monthly Attendance Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectMonthlyAttendanceReport("", FromDate, ToDate, "", "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both", 0);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "0")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptMonthlyAttendance_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptMonthlyAttendance.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptMonthlyAttendance_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptMonthlyAttendanceDetail.rpt"));
                                            }
                                            rptDoc.Database.Tables["Table1"].SetDataSource(dsData.Tables[1]);
                                        }
                                        //MonthlyAttendanceDetailData2
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Employee_Shift_Allocation":
                    #region Report_Employee_Shift_Allocation
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Shift Not Allocated Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        if (ReportType == "0")
                        {
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptShiftNotAllocatedReport_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EmployeeShiftAllocationReport.rpt"));
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[1]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                        }
                                        else
                                        {
                                            /*
                                             * Code Added By Thilakraj.C
                                             * Date : 20-Feb-2013
                                             * For : create LINK for Authentication or UnAuthentication User
                                             *                                          
                                             */
                                            //Start
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        else
                        {
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("RptShiftNotAllocatedReport_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptShiftNotAllocatedReport.rpt"));
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                        }
                                        else
                                        {
                                            /*
                                             * Code Added By Thilakraj.C
                                             * Date : 20-Feb-2013
                                             * For : create LINK for Authentication or UnAuthentication User
                                             *                                          
                                             */
                                            //Start
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_ShiftNotAllocated":
                    #region Report_ShiftNotAllocated
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Shift Not Allocated Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptShiftNotAllocatedReport_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptShiftNotAllocatedReport.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        /*
                                         * Code Added By Thilakraj.C
                                         * Date : 20-Feb-2013
                                         * For : create LINK for Authentication or UnAuthentication User
                                         *                                          
                                         */
                                        //Start
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "LeaveDetails":
                    #region "DailyReport"
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Absent";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Leave & Permission Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        DataSet dsDailyLeave = new DataSet();
                        DataSet dsDailyLeaveUnplanned = new DataSet();
                        DataSet dsDailyPermission = new DataSet();
                        DataSet dsDailyPermissionUnplanned = new DataSet();
                        dsDailyLeave = objGetReports.SelectReportData(Filters, "DailyReport-DailyLeave", ReportType);
                        dsDailyLeaveUnplanned = objGetReports.SelectReportData(Filters, "DailyReport-DailyLeaveUnplanned", ReportType);
                        dsDailyPermission = objGetReports.SelectReportData(Filters, "DailyReport-DailyPermission", ReportType);
                        dsDailyPermissionUnplanned = objGetReports.SelectReportData(Filters, "DailyReport-DailyPermissionUnplanned", ReportType);
                        if (dsDailyLeave != null && dsDailyLeaveUnplanned != null && dsDailyPermission != null && dsDailyPermissionUnplanned != null)
                        {
                            if (EmailSendType == 1)
                            {
                                if (LanguageName == "Arabic")
                                {
                                    rptDoc.Load(System.IO.Path.GetFullPath("Reports\\absent_AR.rpt"));
                                }
                                else
                                {
                                    rptDoc.Load(System.IO.Path.GetFullPath("Reports\\DailyReport.rpt"));
                                }
                                rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                rptDoc.Database.Tables["leave"].SetDataSource(dsDailyLeave.Tables[0]);
                                rptDoc.Database.Tables["unplanned"].SetDataSource(dsDailyLeaveUnplanned.Tables[0]);
                                rptDoc.Database.Tables["permission"].SetDataSource(dsDailyPermission.Tables[0]);
                                rptDoc.Database.Tables["permissionunplanned"].SetDataSource(dsDailyPermissionUnplanned.Tables[0]);
                                rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                            }
                            else
                            {
                                string UpdatedEmailContent = string.Empty;
                                UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                //End
                            }
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                        }
                        else
                        {
                            Subject = Subject + " - " + " No Records Found ";
                            TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                        }
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Absent":
                    #region Report_Absent
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Absent";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Absent Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\absent_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\absent.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_OnDutyEntry":
                    #region Report_Absent
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "OnDuty Entry Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\OnDutyEntry_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\OnDutyEntry.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_EarltEntry":
                case "Report_EarlyEntry":
                    #region Report_EarltEntry
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Early Entry";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Early Entry Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectEarlyEntryReport("", "0", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EarlyEntry_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EarlyEntry.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Late_Entry":
                    #region Report_Late_Entry
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Late Entry";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Late Entry Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectLateInstanceReport("", "0", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\LateInstanceReport_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\LateInstanceReport.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Early_Exit":
                    #region Report_Early_Exit
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Absent";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Early Exit Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectEarlyOutReportNew(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\earlyExit_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\earlyExit.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Late_Exit":
                    #region Report_Late_Exit
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Late Exit";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Late Exit Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectLateExit(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\lateExit_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\lateExit.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Leave":
                    #region Report_Leave
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Leave";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Leave Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectLeave(FromDate, ToDate, "", 0, "", "", "All", "All", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "0")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\leave_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\leave.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("RptLeaveSummary_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptLeaveSummary.rpt"));
                                            }
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Punctuality":
                    #region Report_Punctuality
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Punctuality";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Punctuality Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectPunctuality(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\punctuality_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\punctuality.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Discrepancy":
                    #region Report_Discrepancy
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Discrepancy";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Discrepancy Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectDiscrepancy(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\discrepancy_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\discrepancy.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Permission":
                    #region Report_Permission
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Permission";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Permission Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectPermissionReport(FromDate, ToDate, "", "", "", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\rptPermission_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\rptPermission.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_ManualTimeEntry":
                    #region Report_ManualTimeEntry
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Manual Time Entry";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Manual Time Entry Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dsData = objGetReports.SelectManualTimeEntryReport("", "", FromDate, ToDate, "", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both");
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\ManualTimeEntry_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\ManualTimeEntry.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "MustoRollReport":
                    #region MustoRollReport
                    try
                    {
                        int iWorkingDays = 0;
                        DataSet dsTot = new DataSet();
                        DataTable dt = new DataTable();
                        dt = objGetReports.GetDateMonth(FromDate, ToDate);
                        if (dt.Rows.Count > 0)
                        {
                            strMonth = Convert.ToString(dt.Rows[0]["Month"]);
                            strYear = Convert.ToString(dt.Rows[0]["Year"]);
                            strDay = Convert.ToString(dt.Rows[0]["TS"]);
                            strFromDate = Convert.ToString(dt.Rows[0]["Fromdate"]);
                        }
                        dsTot = objGetReports.SelectTotalWorkingDays(strMonth, strYear);
                        if (dsTot != null && dsTot.Tables.Count > 0 && dsTot.Tables[0].Rows.Count > 0 && dsTot.Tables[0].Rows[0]["TotalWokingDays"] != DBNull.Value)
                        {
                            iWorkingDays = Convert.ToInt32(dsTot.Tables[0].Rows[0]["TotalWokingDays"]);
                        }
                        //Filters = Filters.Replace("@fromDat", "@FromDate1");
                        //Filters = Filters.Replace("@ToDat", "@ToDate1");
                        DataTable dtRptHeader = new DataTable();
                        //start report//
                        //Create the datatable ,that holds the header information
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = iWorkingDays;
                        drHdr["ReportName"] = "Form 25 Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //Get the Report source from the Server and load this into the report table
                        DataSet dsForm25 = new DataSet();
                        string SelectedMonth = strMonth;
                        string SelectedYear = strYear;
                        DataTable NewDT = new DataTable();
                        string EmpID = "";
                        DataColumn DC1 = new DataColumn();
                        DC1.ColumnName = "Name";
                        NewDT.Columns.Add(DC1);
                        DataColumn DC2 = new DataColumn();
                        DC2.ColumnName = "FatherName";
                        NewDT.Columns.Add(DC2);
                        DataColumn DC3 = new DataColumn();
                        DC3.ColumnName = "Designation";
                        NewDT.Columns.Add(DC3);
                        DataColumn DC9 = new DataColumn();
                        DC9.ColumnName = "Employee_Code_Id";
                        NewDT.Columns.Add(DC9);
                        DataColumn DC4 = new DataColumn();
                        DC4.ColumnName = "Present";
                        NewDT.Columns.Add(DC4);
                        DataColumn DC5 = new DataColumn();
                        DC5.ColumnName = "Absent";
                        NewDT.Columns.Add(DC5);
                        DataColumn DC6 = new DataColumn();
                        DC6.ColumnName = "Leave";
                        NewDT.Columns.Add(DC6);
                        DataColumn dcHoliday = new DataColumn();
                        dcHoliday.ColumnName = "Holiday";
                        NewDT.Columns.Add(dcHoliday);
                        DataColumn dcOT = new DataColumn();
                        dcOT.ColumnName = "TotalOT";
                        NewDT.Columns.Add(dcOT);
                        for (int j = 1; j <= 31; j++)
                        {
                            DataColumn DC = new DataColumn();
                            DC.ColumnName = "Day" + j;
                            NewDT.Columns.Add(DC);
                        }
                        DataSet dsSummaryData = new DataSet();
                        DataSet dsDetailedData = new DataSet();
                        //TimeSpan ts = Convert.ToDateTime(ToDate).Subtract(Convert.ToDateTime(FromDate));
                        int Days = Convert.ToInt32(strDay);
                        if (Days > 31)
                        {
                            FromDate = strFromDate;
                        }
                        //dsSummaryData = objGetReports.SelectInOutEmployeeSummary(SelectedMonth, SelectedYear, "", "", "", "0", "0", UserGroupName, GradeLevel, "", 0, 0, "Both");
                        if (ReportType == "0")
                        {
                            dsSummaryData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsSummaryData != null)
                            {
                                if (dsSummaryData.Tables.Count > 0)
                                {
                                    if (dsSummaryData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            rptDoc.PrintOptions.PaperSize = CrystalDecisions.Shared.PaperSize.PaperCsheet;
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EmployeInOutSummary_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EmployeeInOutSummary.rpt"));
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsSummaryData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.Database.Tables["Table1"].SetDataSource(dsSummaryData.Tables[1]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        else
                        {
                            //dsDetailedData = objGetReports.SelectInOutEmployeeNew(SelectedMonth, SelectedYear, "", "", "", "0", "0", UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsDetailedData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsDetailedData != null)
                            {
                                if (dsDetailedData.Tables.Count > 0)
                                {
                                    if (dsDetailedData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            rptDoc.PrintOptions.PaperSize = CrystalDecisions.Shared.PaperSize.DefaultPaperSize;
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EmployeeInOut_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\EmployeeInOut.rpt"));
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsDetailedData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.Database.Tables["Table1"].SetDataSource(dsDetailedData.Tables[1]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            rptDoc.SetParameterValue("FromDate", FromDateInReport);
                                            rptDoc.SetParameterValue("ToDate", ToDateInReport);
                                            rptDoc.SetParameterValue("Display", "Both");
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_SummaryReport":
                    #region Report_SummaryReport
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Summary Entry";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Summary Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        DataSet dsSummaryData = new DataSet();
                        DataSet dsDetailedData = new DataSet();
                        //dsSummaryData = objGetReports.SelectSummaryReport(FromDate, UserGroupName, 0, 0);
                        dsSummaryData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsSummaryData != null)
                        {
                            if (dsSummaryData.Tables.Count > 0)
                            {
                                if (dsSummaryData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (LanguageName == "Arabic")
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\SummaryReport_AR.rpt"));
                                        }
                                        else
                                        {
                                            rptDoc.Load(System.IO.Path.GetFullPath("Reports\\SummaryReport.rpt"));
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsSummaryData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.Database.Tables["Table1"].SetDataSource(dsSummaryData.Tables[1]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    // EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_Overtime":
                    #region Report_Overtime
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Over Time";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "Over Time Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        DataSet dsOverTime = new DataSet();
                        DataSet dsCompOff = new DataSet();
                        //dsOverTime = objGetReports.SelectOverTime(FromDate, ToDate, "", 0, "", "0", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both", "OverTime");
                        dsOverTime = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsOverTime != null)
                        {
                            if (dsOverTime.Tables.Count > 0)
                            {
                                if (dsOverTime.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "CompOff")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\Compensation_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\Compensation.rpt"));
                                            }
                                        }
                                        else if (ReportType == "OverTime")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\overTime_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\overTime.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\OTCompensation_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\OTCompensation.rpt"));
                                            }
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsOverTime.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_LessHoursWorked":
                    #region Report_LessHoursWorked
                    try
                    {
                        //Create the datatable ,that holds the header information
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "LessHoursWorked";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsData != null)
                        {
                            if (dsData.Tables.Count > 0)
                            {
                                if (dsData.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        if (ReportType == "0")
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptLessHoursWorked_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptLessHoursWorked.rpt"));
                                            }
                                        }
                                        else
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptLessHoursWorkedSummary_AR.rpt"));
                                            }
                                            else
                                            {
                                                rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptLessHoursWorkedSummary.rpt"));
                                            }
                                        }
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
                case "Report_FirstInPunchDifference":
                    #region Report_FirstInPunchDifference
                    try
                    {
                        DataTable dtHdr1 = new DataTable();
                        dtHdr1 = hdrTable.CreateHeader();
                        dtHdr1.TableName = "Header";
                        //Add the Header information
                        DataRow drHdr = dtHdr1.NewRow();
                        drHdr["Link"] = 1;
                        drHdr["Hdr1"] = "";
                        drHdr["Hdr2"] = "";
                        drHdr["Address1"] = "";
                        drHdr["Address2"] = "";
                        drHdr["ReportName"] = "In Punch Deviation Hours Report";
                        drHdr["FromDate"] = FromDateInReport;
                        drHdr["ToDate"] = ToDateInReport;
                        dtHdr1.Rows.Add(drHdr);
                        //dtHdr = dtHdr1;
                        DataSet dsInPunchDifference = new DataSet();
                        dsInPunchDifference = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                        if (dsInPunchDifference != null)
                        {
                            if (dsInPunchDifference.Tables.Count > 0)
                            {
                                if (dsInPunchDifference.Tables[0].Rows.Count > 0)
                                {
                                    if (EmailSendType == 1)
                                    {
                                        rptDoc.Load(System.IO.Path.GetFullPath("Reports\\RptInPunchDeviationHours.rpt"));
                                        rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                        rptDoc.Database.Tables["Table"].SetDataSource(dsInPunchDifference.Tables[0]);
                                        rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                        rptDoc.SetParameterValue("DtFormat", DateFormat);
                                        rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                        EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc);
                                    }
                                    else
                                    {
                                        string UpdatedEmailContent = string.Empty;
                                        UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                        TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                        //End
                                    }
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                                else
                                {
                                    //EmailContent = string.Empty;
                                    Subject = Subject + " - " + " No Records Found ";
                                    TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                    objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                    }
                    break;
                    #endregion
            }
        }
        public void EmailSendWithAttachment(string FileFormat, string EmailContent, string Subject, string ToEmail, string CCEmail, string ReportName, ReportDocument rptDoc)
        {
            try
            {
                Attachment attachment;
                if (EmailContent.Contains("{Link}"))
                {
                    EmailContent = EmailContent.Replace("{Link}", "");
                }
                switch (FileFormat)
                {
                    case "PDF":
                        rptDoc.ExportToDisk(ExportFormatType.PortableDocFormat, @"D:\" + ReportName + ".pdf");
                        attachment = new Attachment(@"D:\" + ReportName + ".pdf");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(@"D:\" + ReportName + ".pdf"))
                        {
                            System.IO.File.Delete(@"D:\" + ReportName + ".pdf");
                        }
                        break;
                    case "Excel":
                        rptDoc.ExportToDisk(ExportFormatType.Excel, @"D:\" + ReportName + ".xls");
                        attachment = new Attachment(@"D:\" + ReportName + ".xls");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(@"D:\" + ReportName + ".xls"))
                        {
                            System.IO.File.Delete(@"D:\" + ReportName + ".xls");
                        }
                        break;
                    case "RichText":
                        rptDoc.ExportToDisk(ExportFormatType.RichText, @"D:\" + ReportName + ".rtf");
                        attachment = new Attachment(@"D:\" + ReportName + ".rtf");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(@"D:\" + ReportName + ".rtf"))
                        {
                            System.IO.File.Delete(@"D:\" + ReportName + ".rtf");
                        }
                        break;
                    case "Word":
                        rptDoc.ExportToDisk(ExportFormatType.WordForWindows, @"D:\" + ReportName + ".doc");
                        attachment = new Attachment(@"D:\" + ReportName + ".doc");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(@"D:\" + ReportName + ".doc"))
                        {
                            System.IO.File.Delete(@"D:\" + ReportName + ".doc");
                        }
                        break;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        private string SelectDropDownItem(string WeekName)
        {
            string value = "1";
            switch (WeekName)
            {
                case "Sunday":
                    value = "1";
                    break;
                case "Monday":
                    value = "2";
                    break;
                case "Tuesday":
                    value = "3";
                    break;
                case "Wednesday":
                    value = "4";
                    break;
                case "Thursday":
                    value = "5";
                    break;
                case "Friday":
                    value = "6";
                    break;
                case "Saturday":
                    value = "7";
                    break;
            }
            return value;
        }
    }
}
