using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Text.RegularExpressions;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
/****************************************************************************************************************************
* Project Name    : TimeCheck                                   Started Date  : 12-Aug-2007
* Module          : Leave                                       Last Modified : 14-Aug-2007
* Programmer      : 
* Current Storage : \\Angler56\Projects\Inprogress\SCREEN1206\code\Time_AttendanceApp
* BackUp          :
****************************************************************************************************************************/
public partial class Master_TA_UI_EmailSchedule : Base.BasePage
{
    EmailConfiguration objEmailConfiguration = new EmailConfiguration();
    cls_Common objcommon = new cls_Common();
    ResourceManager rm;
    CultureInfo ci;
    enum EmailSendtype { LINK, ATTACHMENT };
    enum LoginRequired { NO, YES };
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        if (Session["Session_ActiveLanguage"] == null)
        {
            string strScript1 = "<script language='javascript' type='text/javascript'>";
            strScript1 += "alert('" + rm.GetString("Alert_SessionExpired", ci) + "');self.close();";
            strScript1 += " </script>";
            this.RegisterStartupScript("closeScript1", strScript1);
            return;
        }
        string strSetAlert1 = "";
        strSetAlert1 = strSetAlert1 + "<script language='javascript'>";
        strSetAlert1 = strSetAlert1 + "SetAlertMessages('" + rm.GetString("Alert_Selectreportname", ci) + "','" + rm.GetString("Alert_EnterScheduleName", ci) + "','" + rm.GetString("Alert_SelectChooseFilters", ci) + "','" + rm.GetString("Alert_EnterTimeToSend", ci) + "','" + rm.GetString("Alert_EnterToMailIds", ci) + "','" + rm.GetString("Alert_EnterSubject", ci) + "','" + rm.GetString("Alert_SelectDayTo", ci) + "','" + rm.GetString("Alert_Are_you_sure_to_Save", ci) + "');";
        strSetAlert1 = strSetAlert1 + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert1);
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        hiddenTime.Value = Convert.ToString(Session["ITimeFormat"]);
        if (!Page.IsPostBack)
        {
            LoadReportName();
            ViewState["Report"] = string.Empty;
            objcommon.menu("Masters_EmailConfiguration", "177");
        }
        string strSetAlert = string.Empty;
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');SetAuthentication();";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("MaxLengthh", strSetAlert);
        string strScript;
        if (!Page.IsPostBack)
        {
            if (Request.QueryString["ScheduleId"] != null)
            {
                btnChooseFilters.Enabled = true;
                ddlReportName.Enabled = false;
                DataSet dsEmailSchedule = new DataSet();
                dsEmailSchedule = objEmailConfiguration.SelectEmailScheduleBasedOnId(Convert.ToInt32(Request.QueryString["ScheduleId"]));
                if (dsEmailSchedule.Tables[0].Rows.Count > 0)
                {
                    Session["ScheduleId"] = Convert.ToString(Request.QueryString["ScheduleId"]);
                    txtScheduleName.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["ScheduleName"]);
                    txtTimeToSend.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["TimeToSend"]);
                    int Authentication = Convert.ToInt32(dsEmailSchedule.Tables[0].Rows[0]["Authentication"]);
                    ddlReportName.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["ReportId"]);
                    ddlFileType.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["FileType"]);
                    string Frequency = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["Frequency"]);
                    ddlDateTo.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DateTo"]);
                    int EmailSendType = Convert.ToInt32(dsEmailSchedule.Tables[0].Rows[0]["EmailSendType"]);
                    txtSubject.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["Subject"]);
                    editor.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["EmailContent"]);
                    txtApprovalTO.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["ToEmailList"]);
                    txtApprovalCC.Text = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["CCEmailList"]);
                    hdnFilters.Value = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["Filters"]);
                    hdnReportType.Value = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["ReportType"]);
                    hdnCompanyId.Value = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["CompanyId"]);
                    Session["parentLevelId_modify"] = hdnCompanyId.Value;
                    if (Frequency == "Daily")
                    {
                        rbDaily.Checked = true;
                        rbWeekly.Checked = false;
                        rbMonthly.Checked = false;
                        rbWeekly.Enabled = false;
                        rbMonthly.Enabled = false;
                    }
                    else if (Frequency == "Monthly")
                    {
                        rbMonthly.Checked = true;
                        rbWeekly.Checked = false;
                        rbDaily.Checked = false;
                        rbWeekly.Enabled = false;
                        rbDaily.Enabled = false;
                        ddlDateToSend.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DateToSend"]);
                        ddlDateFrom.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DateFrom"]);
                        ddlDateTo.SelectedValue = Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DateTo"]);
                    }
                    else
                    {
                        rbWeekly.Checked = true;
                        rbDaily.Checked = false;
                        rbMonthly.Checked = false;
                        rbDaily.Enabled = false;
                        rbMonthly.Enabled = false;
                        ddlDayToSend.SelectedValue = SelectDropDownItem(Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DayToSend"]));
                        ddlDayFrom.SelectedValue = SelectDropDownItem(Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DayFrom"]));
                        ddlDayTo.SelectedValue = SelectDropDownItem(Convert.ToString(dsEmailSchedule.Tables[0].Rows[0]["DayTo"]));
                    }
                    if (Convert.ToInt32(EmailSendtype.ATTACHMENT) == EmailSendType)
                    {
                        rbAttachment.Checked = true;
                        rbLink.Checked = false;
                    }
                    else
                    {
                        rbLink.Checked = true;
                        rbAttachment.Checked = false;
                    }
                    if (Convert.ToInt32(LoginRequired.YES) == Authentication)
                    {
                        rbYes.Checked = true;
                        rbNo.Checked = false;
                    }
                    else
                    {
                        rbNo.Checked = true;
                        rbYes.Checked = false;
                    }
                    strScript = string.Empty;
                    strScript = "<script language='javascript'>";
                    strScript = strScript + "SetFrequency();SetAuthentication();";
                    strScript = strScript + "</script>";
                    Page.RegisterStartupScript("Script", strScript);
                    return;
                }
            }
            else
            {
                //BinddropdownItem(1);
                Session["ScheduleId"] = 0;
                //txtTimeToSend.Text = DateTime.Now.ToString(Session["ITimeFormat"]);
            }
        }
        //if (Request.QueryString["ScheduleId"] != null)
        //{
        //    BindPreviousWeekDates(2, Convert.ToString(ddlDayFrom.SelectedItem.Text), Convert.ToString(ddlDayTo.SelectedItem.Text), 0, 0);
        //}
        //strScript = string.Empty;
        //strScript = "<script language='javascript'>";
        //strScript = strScript + "SetFrequency(1);SetAuthentication();";
        //strScript = strScript + "</script>";
        //Page.RegisterStartupScript("Script", strScript);
        return;
    }
    //Getting Information from resource file and display it in label
    private void LoadStrings(CultureInfo ci)
    {
        lblApprovalTO.Text = rm.GetString("Caption_ToMailIds", ci);
        lblApprovalCC.Text = rm.GetString("Caption_CcMailIds", ci);
        btnSave.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        btn_Delete.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Delete", ci);
        btnApprovalTO.Text = rm.GetString("Caption_To", ci);
        btnApprovalCC.Text = rm.GetString("Caption_CC", ci);
        lbl_IndicatesMandatoryFields.Text = rm.GetString("IndicatesMandatoryFields", ci);
        lblSelectEmployee.Text = rm.GetString("lblSelectEmployee", ci);
        lbl_EmailSchedule.Text = rm.GetString("Masters_EmailConfiguration", ci);
        lblScheduleName.Text = rm.GetString("lblEmailScheduleName", ci);
        lblReportName.Text = rm.GetString("lblEmailReportName", ci);
        lblFrequency.Text = rm.GetString("lblEmailFrequency", ci);
        btnChooseFilters.Text = "&nbsp;&nbsp;" + rm.GetString("lnkbtnChooseFilter", ci);
        rbDaily.Text = rm.GetString("lblEmailDaily", ci);
        rbWeekly.Text = rm.GetString("lblEmailWeekly", ci);
        rbMonthly.Text = rm.GetString("lblEmailMonthly", ci);
        lblTimeToSend.Text = rm.GetString("lblEmailTimeToSend", ci);
        lblDayToSend.Text = rm.GetString("lblEmailDayToSend", ci);
        lblDayFrom.Text = rm.GetString("lblEmailPreviousWeek", ci);
        lblDayTo.Text = rm.GetString("email_ToDate", ci);
        lblSample.Text = rm.GetString("lblEmailSample", ci);
        lblDateToSend.Text = rm.GetString("lblEmailDateToSend", ci);
        lblDateFrom.Text = rm.GetString("lblEmailPreviousMonth", ci);
        lblDateTo.Text = rm.GetString("email_ToDate", ci);
        Label3.Text = rm.GetString("lblEmailSample", ci);
        lblEmailSendType.Text = rm.GetString("lblEmailEmailSendtype", ci);
        rbAttachment.Text = rm.GetString("lblEmailAttachment", ci);
        rbLink.Text = rm.GetString("lblEmailLink", ci);
        lblLoginRequired.Text = rm.GetString("lblEmailLoginRequired", ci);
        rbYes.Text = rm.GetString("ShiftSetting_Yes", ci);
        rbNo.Text = rm.GetString("ShiftSetting_No", ci);
        lblEmailTemplate.Text = rm.GetString("lblEmailEmailTemplate", ci);
        lblSubject.Text = rm.GetString("lblEmailSubject", ci);
    }
    public void LoadReportName()
    {
        DataSet dsReportName = new DataSet();
        dsReportName = objEmailConfiguration.SelectReportsForEmailSchedule(Convert.ToString(Session["UserGroupName"]));
        if (dsReportName.Tables[0].Rows.Count > 0)
        {
            ViewState["ReportNames"] = dsReportName.Tables[0];
            ddlReportName.DataSource = dsReportName;
            ddlReportName.DataValueField = "pageId";
            ddlReportName.DataTextField = "displayName";
            ddlReportName.DataBind();
        }
        BindToolTip(ddlReportName);
    }
    public void BindTemplate()
    {
        DataSet dsReportName = new DataSet();
        dsReportName = objEmailConfiguration.SelectReportsForEmailSchedule(Convert.ToString(Session["UserGroupName"]));
        if (dsReportName.Tables[0].Rows.Count > 0)
        {
            ddlTemplate.DataSource = dsReportName;
            ddlTemplate.DataValueField = "pageId";
            ddlTemplate.DataTextField = "displayName";
            ddlTemplate.DataBind();
        }
        BindToolTip(ddlTemplate);
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {
        string strInvalidEmailIdInTo = string.Empty;
        string strInvalidEmailIdInCC = string.Empty;
        string Frequency = string.Empty;
        char[] Delimit = { ';' };
        if (txtApprovalTO.Text != string.Empty)
        {
            string strMailIdsTo = txtApprovalTO.Text;
            string[] MailIdsTo = strMailIdsTo.Split(Delimit);
            foreach (string MailId in MailIdsTo)
            {
                if (ValidateEmailID(MailId) == false)
                {
                    if (strInvalidEmailIdInTo == string.Empty)
                    {
                        strInvalidEmailIdInTo = MailId;
                        break;
                    }
                }
            }
        }
        if (txtApprovalCC.Text != string.Empty)
        {
            string strMailIdsCC = txtApprovalCC.Text;
            string[] MailIdsCC = strMailIdsCC.Split(Delimit);
            foreach (string MailId in MailIdsCC)
            {
                if (ValidateEmailID(MailId) == false)
                {
                    if (strInvalidEmailIdInCC == string.Empty)
                    {
                        strInvalidEmailIdInCC = MailId;
                        break;
                    }
                }
            }
        }
        if (strInvalidEmailIdInTo != string.Empty)
        {
            string strMsg;
            strMsg = "<script language='javascript'>";
            strMsg = strMsg + "alert('" + rm.GetString("Alert_EnterValidEmailIdinToMailIds", ci) + "');";
            strMsg = strMsg + "</script>";
            Page.RegisterStartupScript("Inserted successfully", strMsg);
            return;
        }
        if (strInvalidEmailIdInCC != string.Empty)
        {
            string strMsg;
            strMsg = "<script language='javascript'>";
            strMsg = strMsg + "alert('" + rm.GetString("Alert_EnterValidEmailIdinCcMailIds", ci) + "');";
            strMsg = strMsg + "</script>";
            Page.RegisterStartupScript("Inserted successfully", strMsg);
            return;
        }
        if (rbDaily.Checked == true)
        {
            Frequency = "Daily";
        }
        else if (rbWeekly.Checked == true)
        {
            Frequency = "Weekly";
        }
        else
        {
            Frequency = "Monthly";
        }
        int EmailSendType = Convert.ToInt32(EmailSendtype.LINK);
        if (rbAttachment.Checked == true)
        {
            EmailSendType = Convert.ToInt32(EmailSendtype.ATTACHMENT);
        }
        int Authentication = Convert.ToInt32(LoginRequired.NO);
        if (rbYes.Checked == true)
        {
            Authentication = Convert.ToInt32(LoginRequired.YES);
        }
        int InsertedId = 0;
        string reportname = "";
        if (Request.QueryString["ScheduleId"] == null)
        {
            if (Convert.ToString(hdnReportType.Value) == "0" && Convert.ToInt32(ddlReportName.SelectedValue) == 183)
            {
                reportname = "RawDataDetailed";
            }
            else
            {
                reportname = Convert.ToString(ddlReportName.SelectedItem.Text);
            }
            InsertedId = objEmailConfiguration.InsertUpdateEmailScheduleDetails(txtScheduleName.Text, Convert.ToInt32(ddlReportName.SelectedValue), Frequency, Convert.ToString(ddlDayToSend.SelectedItem.Text), Convert.ToString(ddlDayFrom.SelectedItem.Text), Convert.ToString(ddlDayTo.SelectedItem.Text), Convert.ToInt32(ddlDateToSend.SelectedValue), Convert.ToInt32(ddlDateFrom.SelectedValue), Convert.ToInt32(ddlDateTo.SelectedValue), txtTimeToSend.Text, Convert.ToInt32(Session["EmpAutoId"]), EmailSendType, Authentication, ddlFileType.SelectedValue, 1, 0, "I", reportname);
            if (InsertedId == 0)
            {
                string strMsg;
                strMsg = "<script language='javascript'>";
                strMsg = strMsg + "alert('" + rm.GetString("Alert_ScheduleNamealreadyexists", ci) + "');";
                strMsg = strMsg + "</script>";
                Page.RegisterStartupScript("inserted successfully", strMsg);
                return;
            }
            objEmailConfiguration.InsertUpdateEmailTemplate(InsertedId, txtSubject.Text, editor.Text, "I");
            objEmailConfiguration.InsertUpdateEmailScheduleFilters(InsertedId, hdnFilters.Value, hdnReportType.Value, "I", Convert.ToInt32(hdnCompanyId.Value));
        }
        else
        {
            if (Convert.ToString(hdnReportType.Value) == "0" && Convert.ToInt32(ddlReportName.SelectedValue) == 183)
            {
                reportname = "RawDataDetailed";
            }
            else
            {
                reportname = Convert.ToString(ddlReportName.SelectedItem.Text);
            }
            InsertedId = objEmailConfiguration.InsertUpdateEmailScheduleDetails(txtScheduleName.Text, Convert.ToInt32(ddlReportName.SelectedValue), Frequency, Convert.ToString(ddlDayToSend.SelectedItem.Text), Convert.ToString(ddlDayFrom.SelectedItem.Text), Convert.ToString(ddlDayTo.SelectedItem.Text), Convert.ToInt32(ddlDateToSend.SelectedValue), Convert.ToInt32(ddlDateFrom.SelectedValue), Convert.ToInt32(ddlDateTo.SelectedValue), txtTimeToSend.Text, Convert.ToInt32(Session["EmpAutoId"]), EmailSendType, Authentication, ddlFileType.SelectedValue, 1, Convert.ToInt32(Request.QueryString["ScheduleId"]), "U", reportname);
            if (InsertedId == 0)
            {
                string strMsg;
                strMsg = "<script language='javascript'>";
                strMsg = strMsg + "alert('" + rm.GetString("Alert_ScheduleNamealreadyexists", ci) + "');";
                strMsg = strMsg + "</script>";
                Page.RegisterStartupScript("inserted successfully", strMsg);
                return;
            }
            objEmailConfiguration.InsertUpdateEmailTemplate(Convert.ToInt32(Request.QueryString["ScheduleId"]), txtSubject.Text, editor.Text, "U");
            objEmailConfiguration.InsertUpdateEmailScheduleFilters(Convert.ToInt32(Request.QueryString["ScheduleId"]), hdnFilters.Value, hdnReportType.Value, "U", Convert.ToInt32(hdnCompanyId.Value));
            objEmailConfiguration.DeleteMailIDBeforeInserting(Convert.ToInt32(Request.QueryString["ScheduleId"]));
        }
        if (txtApprovalTO.Text != string.Empty)
        {
            string strMailIds = txtApprovalTO.Text;
            string[] MailIds = strMailIds.Split(Delimit);
            foreach (string MailId in MailIds)
            {
                if (ValidateEmailID(MailId) == true)
                {
                    if (Request.QueryString["ScheduleId"] == null)
                    {
                        objEmailConfiguration.InsertMailIds(InsertedId, "To", MailId.Trim());
                    }
                    else
                    {
                        objEmailConfiguration.InsertMailIds(Convert.ToInt32(Request.QueryString["ScheduleId"]), "To", MailId.Trim());
                    }
                }
            }
        }
        if (txtApprovalCC.Text != string.Empty)
        {
            string strMailIds = txtApprovalCC.Text;
            string[] MailIds = strMailIds.Split(Delimit);
            foreach (string MailId in MailIds)
            {
                if (ValidateEmailID(MailId) == true)
                {
                    if (Request.QueryString["ScheduleId"] == null)
                    {
                        objEmailConfiguration.InsertMailIds(InsertedId, "CC", MailId.Trim());
                    }
                    else
                    {
                        objEmailConfiguration.InsertMailIds(Convert.ToInt32(Request.QueryString["ScheduleId"]), "CC", MailId.Trim());
                    }
                }
            }
        }
        if (Request.QueryString["ScheduleId"] == null)
        {
            string strMsg;
            strMsg = "<script language='javascript'>";
            strMsg = strMsg + "alert('" + rm.GetString("Alert_EmailSchedulerSavedSuccessfully", ci) + "');location.replace('TA_UI_EmailScheduleList.aspx');";
            strMsg = strMsg + "</script>";
            Page.RegisterStartupScript("inserted successfully", strMsg);
            Session["hdnReportFilters"] = null; return;
        }
        else
        {
            string strMsg;
            strMsg = "<script language='javascript'>";
            strMsg = strMsg + "alert('" + rm.GetString("Alert_EmailSchedulerUpdatedSuccessfully", ci) + "');location.replace('TA_UI_EmailScheduleList.aspx');";
            strMsg = strMsg + "</script>";
            Page.RegisterStartupScript("updated successfully", strMsg);
            Session["hdnReportFilters"] = null; return;
        }
    }
    public bool ValidateEmailID(string EmailID)
    {
        string strRegex = @"^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}" +
             @"\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\" +
             @".)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$";
        strRegex = (hfemail.Value != null) ? Convert.ToString(hfemail.Value) : strRegex;
        Regex re = new Regex(strRegex);
        if (re.IsMatch(EmailID))
            return (true);
        else
            return (false);
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_EmailScheduleList.aspx");
    }
    protected void btnChooseFilters_Click(object sender, EventArgs e)
    {
        if (ddlReportName.SelectedValue != "0")
        {
            if (Convert.ToString(ViewState["Report"]) != string.Empty)
            {
                if (Convert.ToString(ViewState["Report"]) == Convert.ToString(ddlReportName.SelectedValue))
                {
                    Session["hdnReportFilters"] = Session["hdnReportFilters"];
                    Session["EMailParentId"] = Session["EMailParentId"];
                    Session["ReportTypeID"] = Session["ReportTypeID"];
                    Session["LateReportName"] = Session["LateReportName"];
                }
                else
                {
                    Session["hdnReportFilters"] = string.Empty;
                    Session["EMailParentId"] = string.Empty;
                    Session["ReportTypeID"] = string.Empty;
                    Session["LateReportName"] = string.Empty;
                    ViewState["Report"] = ddlReportName.SelectedValue;
                }
            }
            else
            {
                ViewState["Report"] = ddlReportName.SelectedValue;
                Session["hdnReportFilters"] = string.Empty;
                Session["EMailParentId"] = string.Empty;
                Session["ReportTypeID"] = string.Empty;
            }
            DataTable dtReportPage = new DataTable();
            dtReportPage = (DataTable)ViewState["ReportNames"];
            dtReportPage.DefaultView.RowFilter = "pageId='" + ddlReportName.SelectedValue + "'";
            if (Request.QueryString["ScheduleId"] != null)
            {
                string strMsg;
                strMsg = "<script language='javascript'>";
                strMsg = strMsg + "openURL('" + Convert.ToString(dtReportPage.DefaultView.ToTable().Rows[0]["path"]) + "?Source=Email&ScheduleId=" + Convert.ToInt32(Request.QueryString["ScheduleId"]) + "');";
                //strMsg = strMsg + "window.open('" + dtReportPage.DefaultView.ToTable().Rows[0]["path"].ToString() + "?Source=Email&ScheduleId=" + Convert.ToInt32(Request.QueryString["ScheduleId"]) + "','','height=550,top=300,left=125,width=1003');";
                strMsg = strMsg + "</script>";
                Page.RegisterStartupScript("open report window", strMsg);
                return;
            }
            else
            {
                //Response.Redirect("../Reports/" + dtReportPage.DefaultView.ToTable().Rows[0]["path"].ToString());
                string strMsg;
                strMsg = "<script language='javascript'>";
                strMsg = strMsg + "openURL('" + Convert.ToString(dtReportPage.DefaultView.ToTable().Rows[0]["path"]) + "?Source=Email');";
                //strMsg = strMsg + "window.open('" + dtReportPage.DefaultView.ToTable().Rows[0]["path"].ToString() + "?Source=Email','','height=550,top=300,left=125,width=1003');";
                strMsg = strMsg + "</script>";
                Page.RegisterStartupScript("open report window", strMsg);
                return;
            }
        }
        else
        {
            string strScript1 = "<script language='javascript' type='text/javascript'>";
            strScript1 += "alert('" + rm.GetString("Alert_Selectreportnamefirst", ci) + "');";
            strScript1 += " </script>";
            this.RegisterStartupScript("Select Report Name", strScript1);
            return;
        }
    }
    protected void ddlDayFrom_SelectedIndexChanged(object sender, EventArgs e)
    {
    }
    protected void ddlDayTo_SelectedIndexChanged(object sender, EventArgs e)
    {
    }
    public DataSet dropdownItem(int itemID)
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Text", typeof(string));
        dt.Columns.Add("Value", typeof(string));
        dt.Rows.Add("Sunday", 1);
        dt.Rows.Add("Monday", 2);
        dt.Rows.Add("Tuesday", 3);
        dt.Rows.Add("Wednesday", 4);
        dt.Rows.Add("Thursday", 5);
        dt.Rows.Add("Friday", 6);
        dt.Rows.Add("Saturday", 7);
        for (int x = 0; x < dt.Rows.Count; x++)
        {
            DataRow[] matches = dt.Select("Value='" + itemID + "'");
            foreach (DataRow row in matches)
            {
                dt.Rows.Remove(row);
            }
        }
        DataSet ds = new DataSet();
        ds.Tables.Add(dt);
        return ds;
    }
    public void BinddropdownItem(int itemID)
    {
        DataSet dsReportName = new DataSet();
        dsReportName = dropdownItem(itemID);
        if (dsReportName.Tables[0].Rows.Count > 0)
        {
            ddlDayTo.DataSource = dsReportName;
            ddlDayTo.DataValueField = "Value";
            ddlDayTo.DataTextField = "Text";
            ddlDayTo.DataBind();
        }
        switch (itemID)
        {
            case 1:
                ddlDayTo.SelectedValue = "7";
                break;
            case 2:
                ddlDayTo.SelectedValue = "1";
                break;
            case 3:
                ddlDayTo.SelectedValue = "2";
                break;
            case 4:
                ddlDayTo.SelectedValue = "3";
                break;
            case 5:
                ddlDayTo.SelectedValue = "4";
                break;
            case 6:
                ddlDayTo.SelectedValue = "5";
                break;
            case 7:
                ddlDayTo.SelectedValue = "6";
                break;
        }
    }
    private void BindPreviousWeekDates(int Frequency, string DayFrom, string DayTo, int DateFrom, int DateTo)
    {
        //DataSet dsPrev_WeekDates = new DataSet();
        //dsPrev_WeekDates = objEmailConfiguration.GetSampleWeekDays(Frequency, Convert.ToString(DayFrom), Convert.ToString(DayTo), DateFrom, DateTo);
        //if (dsPrev_WeekDates.Tables.Count > 0)
        //{
        //    if (dsPrev_WeekDates.Tables[0].Rows.Count > 0)
        //    {
        //        Label2.Text = Convert.ToString(dsPrev_WeekDates.Tables[0].Rows[0]["Fromdate"]) + " To " + Convert.ToString(dsPrev_WeekDates.Tables[0].Rows[0]["Todate"]);
        //    }
        //}
    }
    private string SelectDropDownItem(string WeekName)
    {
        string value = "1";
        switch (WeekName)
        {
            case "Sunday":
                value = "1";
                break;
            case "Monday":
                value = "2";
                break;
            case "Tuesday":
                value = "3";
                break;
            case "Wednesday":
                value = "4";
                break;
            case "Thursday":
                value = "5";
                break;
            case "Friday":
                value = "6";
                break;
            case "Saturday":
                value = "7";
                break;
        }
        return value;
    }

    protected void RadioButton4_CheckedChanged(object sender, EventArgs e)
    {
        BindTemplate();
    }
}
