using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Text;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
using NPOI.HSSF.UserModel;
using NPOI.SS.UserModel;
using NPOI.HSSF.Util;
using NPOI.SS.Util;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.ComponentModel;


public partial class Reports_TA_UI_Report_LateInstance : Base.BasePage
{
    #region Variable Declaration
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    EmployeeEventData objEmployee = new EmployeeEventData();
    ResourceManager rm;
    CultureInfo ci;
    ISheet sheet;
    TimeSpan result;
    string fromTimeString;
    string saveAsFileName = string.Empty;
    bool ok;
    string dtFrom = "", dtTo = "";
    string empName = "", EmployeeId = "";
    cls_Common objCommon = new cls_Common();
    string strFromdate, gstrDateFormat, strTodate;
    int intIndividualUser = 0;
    string gStrLevel = string.Empty;
    string ParenetLevelid = string.Empty;
    int payrollConfig = 0, Cellvalcount = 0;
    string SheetName = "", ReportName = "";
    string strReportType = "Normal";
    string Level = string.Empty;
    string employeeName = string.Empty;
    string empId = string.Empty;
    string strEmpAutoId = "0";
    string MinExceptkHours = "";
    DataSet dscommon = new DataSet();
    int shft;
    #endregion
    #region Page Load Events
    /// <summary>
    /// On page loading
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            ddlShift.Focus();
            objCommon.menu("Exception Reports", "37");
        }
        //get the culture info to set the language        
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "selectReportType();";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_EnterDate", ci) + "','" + rm.GetString("Alert_EnterToDate", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        int value = 0;
        value = rbtlatein.Checked == true ? 0 : rbtEarlyExit.Checked == true ? 0 : rbtAll.Checked == true ? 1 : 3;
        strSetAlert = strSetAlert + "Click_Option('" + value + "')";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        //Set UserRights
        UserRights();
        if (!IsPostBack)
        {
            fillShift();
            // Bindings the employee category and type.
            BindingEmployeeCategoryandType();
            FillDesignation();
            if (Request.QueryString["Source"] != null)
            {
                if (Request.QueryString["Source"].ToString() == "Email")
                {
                    divdateTime.Visible = false;
                    trView.Visible = false;
                    trSave.Visible = true;
                    IDTest1.Visible = false;
                    rbtNormalReport.Visible = false;
                    rbtGraphReport.Visible = false;
                    if (Request.QueryString["ScheduleId"] != null)
                    {
                        DataSet ds = new DataSet();
                        ds = rptEmp.GetEmailSchedulerFilterDetails(Convert.ToInt32(Request.QueryString["ScheduleId"]));
                        if (ds.Tables.Count > 0)
                        {
                            if (ds.Tables[0].Rows.Count > 0)
                            {
                                if (ds.Tables[1].Rows.Count > 0)
                                {
                                    string strReportType;
                                    strReportType = Convert.ToString(ds.Tables[1].Rows[0][0]);
                                    if (strReportType == "LateEntry")
                                    {
                                        Session["parentLevelId_modify"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentId"]);
                                        txtEmployeeId.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeID"]);
                                        txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                                        ddlDesignation.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["DesignationID"]);
                                        ddlGender.SelectedItem.Text = Convert.ToString(ds.Tables[0].Rows[0]["Gender"]);
                                        ddlShift.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["shift"]);
                                        ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                                        ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                                        Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                                        rbtlatein.Checked = true;
                                    }
                                    else if (strReportType == "EarlyExit")
                                    {
                                        Session["parentLevelId_modify"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentId"]);
                                        txtEmployeeId.Text = Convert.ToString(ds.Tables[0].Rows[0]["empId"]);
                                        txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                                        ddlDesignation.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["DesignationID"]);
                                        ddlGender.SelectedItem.Text = Convert.ToString(ds.Tables[0].Rows[0]["Gender"]);
                                        ddlShift.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["shift"]);
                                        ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                                        ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                                        Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                                        rbtEarlyExit.Checked = true;
                                    }
                                    else if (strReportType == "EarlyEntry")
                                    {
                                        Session["parentLevelId_modify"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentId"]);
                                        txtEmployeeId.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeID"]);
                                        txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                                        ddlShift.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["shift"]);
                                        ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                                        ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                                        Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                                        rbtEarlyEntry.Checked = true;
                                    }
                                    else if (strReportType == "LateExit")
                                    {
                                        Session["parentLevelId_modify"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentId"]);
                                        txtEmployeeId.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeId"]);
                                        txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                                        ddlDesignation.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["DesignationID"]);
                                        ddlGender.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["Gender"]);
                                        ddlShift.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["shift"]);
                                        ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                                        ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                                        Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                                        rbtLateExit.Checked = true;
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        if (Convert.ToString(Session["hdnReportFilters"]) != string.Empty)
                        {
                            string strhdnParameters = Convert.ToString(Session["hdnReportFilters"]);
                            string[] strArray = new string[50];
                            string[] strArray1 = new string[50];
                            strArray = strhdnParameters.Split(',');
                            for (int i = 0; i < strArray.Length; i++)
                            {
                                string[] strTemp = new string[5];
                                strTemp = strArray[i].Split('=');
                                strArray1[i] = strTemp[1];
                            }
                            if (Convert.ToString(Session["LateReportName"]) == "LateEntry")
                            {
                                ddlShift.SelectedValue = strArray1[5].ToString();
                                txtEmployeeName.Text = strArray1[4].ToString().Replace("~", ",");
                                txtEmployeeId.Text = strArray1[0].ToString().Replace("~", ",");
                                ddlEmpCatagory.SelectedValue = strArray1[6].ToString();
                                ddlEmpType.SelectedValue = strArray1[7].ToString();
                                ddlDesignation.SelectedValue = Convert.ToString(strArray1[12]);
                                ddlGender.SelectedValue = Convert.ToString(strArray1[13]);
                                Session["EMailParentId"] = Convert.ToInt16(strArray1[11]);
                                rbtlatein.Checked = true;
                            }
                            else if (Convert.ToString(Session["LateReportName"]) == "EarlyExit")
                            {
                                ddlShift.SelectedValue = strArray1[3].ToString();
                                txtEmployeeName.Text = strArray1[4].ToString().Replace("~", ",");
                                txtEmployeeId.Text = strArray1[2].ToString().Replace("~", ",");
                                ddlEmpCatagory.SelectedValue = strArray1[6].ToString();
                                ddlEmpType.SelectedValue = strArray1[7].ToString();
                                ddlDesignation.SelectedValue = Convert.ToString(strArray1[12]);
                                ddlGender.SelectedValue = Convert.ToString(strArray1[13]);
                                Session["EMailParentId"] = Convert.ToInt16(strArray1[11]);
                                rbtEarlyExit.Checked = true;
                            }
                            else if (Convert.ToString(Session["LateReportName"]) == "EarlyEntry")
                            {
                                txtEmployeeId.Text = strArray1[2].ToString().Replace("~", ",");
                                ddlShift.SelectedValue = strArray1[3].ToString();
                                txtEmployeeName.Text = strArray1[4].ToString().Replace("~", ",");
                                ddlEmpCatagory.SelectedValue = strArray1[6].ToString();
                                ddlEmpType.SelectedValue = strArray1[7].ToString();
                                Session["EMailParentId"] = Convert.ToString(strArray1[11]);
                                rbtEarlyEntry.Checked = true;
                            }
                            else if (Convert.ToString(Session["LateReportName"]) == "LateExit")
                            {
                                txtEmployeeId.Text = strArray1[2].ToString().Replace("~", ",");
                                txtEmployeeName.Text = strArray1[4].ToString().Replace("~", ",");
                                ddlShift.SelectedValue = strArray1[3].ToString();
                                ddlEmpCatagory.SelectedValue = strArray1[6].ToString();
                                ddlEmpType.SelectedValue = strArray1[7].ToString();
                                ddlDesignation.SelectedValue = Convert.ToString(strArray1[12]);
                                ddlGender.SelectedValue = Convert.ToString(strArray1[13]);
                                Session["EMailParentId"] = Convert.ToInt16(strArray1[11]);
                                rbtLateExit.Checked = true;
                            }
                        }
                    }
                }
            }
            else
            {
                divdateTime.Visible = true;
                trView.Visible = true;
                trSave.Visible = false;
                IDTest1.Visible = false;
            }
            if (Request.QueryString["ScheduleId"] != null)
            {
                string strGet = hdnReportFilters.Value;
                string strScript = "<script language='javascript' type='text/javascript'>";
                strScript += "GethiddenValue();";
                strScript += " </script>";
                this.RegisterStartupScript("setScript", strScript);
                IDTest1.Visible = false;
            }
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            txtFromDate.Text = (Convert.ToDateTime(objCommon.CurrentMonthStartDate())).ToString(Session["MDateFormat"].ToString());
            txtToDate.Text = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(Session["MDateFormat"].ToString());
            ddlDesignation.PreRender += LB_PreRender;
            if (Session["parentLevelId"] != null || Convert.ToInt16(Session["parentLevelId"]) != 0)
            {
                Session["parentLevelId"] = null;
            }
        }
        //Check whether the employee is Individual User
        intIndividualUser = objCheckUser.CheckIndividualUser(Convert.ToString(Session["UserGroupName"]));
        if (intIndividualUser >= 1)
        {
            PlaceHolderLateEntry.Controls.Clear();
            divEmployeeDetails.Visible = false;
        }
        //Convert date time to MM/dd/YYYY format
        if (Session["MDateFormat"] != null)
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        }
        strFromdate = txtFromDate.Text;
        strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
        strTodate = txtToDate.Text;
        strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
        if (Page.MasterPageFile.ToString() == "TA_Popup_Report_MasterPage.master")
        {
            conHeader.Visible = false;
        }
        /*Added New parameter(Max Days/Month)for Angler. For this we are checking whether the payroll configuration page is exists or not*/
        payrollConfig = objCommon.CheckPageExistsInLicense(185);
        if (Convert.ToString(Session["UserGroupName"]) != "SuperAdmin" && payrollConfig == 1)
        {
            ReportType.Style.Add("display", "none");
            rbtAll.Checked = false;
            rbtlatein.Checked = true;
            ReportType1.Style.Add("display", "none");
        }
    }
    protected void Page_PreInit(object sender, EventArgs e)
    {
        if (Request.QueryString["Source"] != null)
            this.Page.MasterPageFile = "TA_Popup_Report_MasterPage.master";
    }
    #endregion
    #region User Defined Functions
    /// <summary>
    /// Fills the designation in the drop down
    /// </summary>
    private void FillDesignation()
    {
        DataSet ds_designation = new DataSet();
        ds_designation = objEmployee.select_CommonDesignation();
        if (ds_designation != null)
        {
            if (ds_designation.Tables[0].Rows.Count > 0)
            {
                ddlDesignation.DataSource = ds_designation;
                ddlDesignation.DataTextField = "TitleName";
                ddlDesignation.DataValueField = "TitleId";
                ddlDesignation.DataBind();
            }
            ds_designation.Dispose();
            BindToolTip(ddlDesignation);
        }
    }
    /// <summary>
    /// Bindings the employee category and type.
    /// </summary>
    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
        if (dsCategory != null)
        {
            if (dsCategory.Tables[0].Rows.Count > 0)
            {
                ddlEmpCatagory.DataSource = dsCategory;
                ddlEmpCatagory.DataTextField = "CategoryName";
                ddlEmpCatagory.DataValueField = "CategoryId";
                ddlEmpCatagory.DataBind();
            }
            dsCategory.Dispose();
            BindToolTip(ddlEmpCatagory);
        }
        // employee type binding
        DataSet dsType = new DataSet();
        dsType = objEmployee.SelectTypeDetailsEmployee("");
        if (dsType != null)
        {
            if (dsType.Tables[0].Rows.Count > 0)
            {
                ddlEmpType.DataSource = dsType;
                ddlEmpType.DataTextField = "TypeName";
                ddlEmpType.DataValueField = "TypeId";
                ddlEmpType.DataBind();
            }
            dsType.Dispose();
            BindToolTip(ddlEmpType);
        }
    }
    /// <summary>
    /// To fill teh shift in the drop down
    /// </summary>
    public void fillShift()
    {
        ShiftEvenData getShift = new ShiftEvenData();
        DataSet ds = new DataSet();
        string strusergroup = string.Empty;
        //ds = getShift.SelectShift(strusergroup, Session["LevelRights"].ToString());
        ds = getShift.SelectShift(Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["LevelRights"]), 0);
        foreach (DataRow drRow in ds.Tables[0].Rows)
        {
            switch (drRow["Shift_Name"].ToString())
            {
                case "No Shift":
                    drRow["Shift_Name"] = rm.GetString("Caption_NoShift", ci);
                    break;
            }
        }
        if (ds.Tables[0].Rows.Count > 0)
        {
            this.ddlShift.DataSource = ds;
            this.ddlShift.DataTextField = "Shift_Name";
            this.ddlShift.DataValueField = "Shift_Id";
            this.ddlShift.DataBind();
        }
        ListItem lstItem = new ListItem();
        lstItem.Value = "0";
        lstItem.Text = rm.GetString("ExportData_All", ci);
        ddlShift.Items.Insert(0, lstItem);
        foreach (ListItem item in ddlShift.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    /// <summary>
    /// Validate the FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateFromDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            if (Session["MDateFormat"] != null)
            {
                gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            }
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                //base.Message("Select valid From Date");
                base.Message(rm.GetString("Alert_EnterValidFromDate", ci));
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    /// <summary>
    /// Validate the ToDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateToDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            if (Session["MDateFormat"] != null)
            {
                gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            }
            strTodate = txtToDate.Text;
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strTodate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Alert_EnterValidToDate", ci));
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    /// <summary>
    /// Compare ToDate with FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            strTodate = txtToDate.Text;
            if (Session["MDateFormat"] != null)
            {
                gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            }
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtToDate = DateTime.Parse(strTodate);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtToDate.Subtract(dtFromDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Msg_SelectvaliddatecomparewithFromdate", ci));
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    /// <summary>
    /// Getting Information from resource file and display it in label
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lblFilter.Text = rm.GetString("lblFilter", ci);
        btn_View.Text = "&nbsp;&nbsp;" + rm.GetString("btn_View", ci);
        lblLateEntryReport.Text = rm.GetString("Menu_Reports_Entries", ci);
        lblShift.Text = rm.GetString("Menu_Reports_Shift", ci);
        lblEmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lblEmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblEmpCategory.Text = rm.GetString("Master_Category", ci);
        lblEmpType.Text = rm.GetString("Master_Type", ci);
        lblTimePeriod.Text = rm.GetString("Reports_TimePeriod", ci);
        lblFrom.Text = rm.GetString("Field_From", ci);
        lblTo.Text = rm.GetString("Field_To", ci);
        RequiredFieldValidator1.ErrorMessage = rm.GetString("Alert_SelectShift", ci);
        reqFromDate.ErrorMessage = rm.GetString("Alert_PleaseselectFromDate", ci);
        reqToDate.ErrorMessage = rm.GetString("Alert_PleaseselectToDate", ci);
        ddlEmpCatagory.Items[0].Text = rm.GetString("Select", ci);
        ddlEmpType.Items[0].Text = rm.GetString("Select", ci);
        lblDesignation.Text = rm.GetString("EmployeeMaster_Designation", ci);
        lblGender.Text = rm.GetString("EmployeeMaster_Gender", ci);
        ddlGender.Items[0].Text = rm.GetString("Caption_Both", ci);
        ddlGender.Items[1].Text = rm.GetString("rbtn_EmployeeMaster_Male", ci);
        ddlGender.Items[2].Text = rm.GetString("rbtn_EmployeeMaster_Female", ci);
        ddlDesignation.Items[0].Text = rm.GetString("ExportData_All", ci);
        btnSave.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Cancel", ci);
        lblDateFilter.Text = rm.GetString("lbl_DateFilter", ci);
        btn_Export.Text = "&nbsp;&nbsp;" + rm.GetString("btn_ExporttoExcel", ci);
        rbCustom.Text = rm.GetString("rb_Custom", ci);
        rbpreviousMonth.Text = rm.GetString("rb_PreviousMonth", ci);
        rbpreviousweek.Text = rm.GetString("rb_PreviousWeek", ci);
        rbThisMonth.Text = rm.GetString("rb_ThisMonth", ci);
        rbThisweek.Text = rm.GetString("rb_ThisWeek", ci);
        lblReportType.Text = rm.GetString("EmployeeInOutReportType", ci);
        rbtAll.Text = rm.GetString("ExportData_All", ci);
        rbtlatein.Text = rm.GetString("Dashboard_Late", ci);
        rbtEarlyExit.Text = rm.GetString("Report_Early_Exit", ci);
        rbtEarlyEntry.Text = rm.GetString("Field_EarlyEntry", ci);
        rbtLateExit.Text = rm.GetString("Report_Late_Exit", ci);
        rbtNormalReport.Text = rm.GetString("lbl_NormalReport", ci);
        rbtGraphReport.Text = rm.GetString("lbl_GraphReport", ci);
        lblExceptionHrs.Text = rm.GetString("lblExceptionHrs", ci);
    }
    /// <summary>
    /// To get the rights for the logged in user
    /// </summary>
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(37, Convert.ToInt32(Session["userGroup_Id"]), "viewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] == DBNull.Value || Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                btn_View.Visible = true;
            }
            else
            {
                btn_View.Visible = false;
            }
        }
        else
        {
            Response.Redirect("ReportsLandingPage.aspx");
        }
    }
    /// <summary>
    /// To apply tooltip for the designation in the drop down
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void LB_PreRender(object sender, System.EventArgs e)
    {
        foreach (ListItem item in ddlDesignation.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    #endregion
    #region Button Events
    protected void CommonThings()
    {
        if (!rbtAll.Checked && rdbtnSummary.Checked)
        {
            string strMsg;
            strMsg = "<script language='javascript'>";
            strMsg = strMsg + "alert('Summary option should work for All option Only, not for other options');";
            strMsg = strMsg + "</script>";
            Page.RegisterStartupScript("Display Message", strMsg);
            return;
        }
        if (Session["ReportsBasedOn"] != null)
        {
            if (Convert.ToString(Session["ReportsBasedOn"]) == "False") strEmpAutoId = "0";
            else strEmpAutoId = Convert.ToString(Session["EmpAutoID"]);
        }
        if (txtFromDate.Text != "") dtFrom = strFromdate;
        if (txtToDate.Text != "") dtTo = strTodate;
        if (intIndividualUser >= 1)
        {
            empName = string.Empty;
            Level = string.Empty;
            empId = Convert.ToString(Session["EmployeeCodeId"]);
        }
        else
        {
            empName = txtEmployeeName.Text.ToString();
            empId = txtEmployeeId.Text.Trim().ToString();
            employeeName = this.txtEmployeeName.Text.Replace("'", "''");
            Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
            gStrLevel = Level;
        }
        MinExceptkHours = Convert.ToString(txtMinExceptionHours.Text);
        shft = Convert.ToInt16(this.ddlShift.SelectedValue);
    }


    /// <summary>
    /// Load Late Entry report
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btn_View_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                CommonThings();

                if (rbtlatein.Checked)
                    dscommon = rptEmp.SelectLateInstanceReport(empId, Level, dtFrom, dtTo, employeeName, Convert.ToInt16(this.ddlShift.SelectedValue), Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt64(strEmpAutoId), 1, MinExceptkHours);
                else if (rbtEarlyExit.Checked)
                    dscommon = rptEmp.SelectEarlyOutReportNew(dtFrom, dtTo, empId, Convert.ToInt16(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 1, MinExceptkHours, Convert.ToInt32(Session["EmpAutoID"]));
                if (rbtlatein.Checked || rbtEarlyExit.Checked)
                {
                    if (dscommon.Tables["Table"].Rows.Count == 0)
                    {
                        Message(rm.GetString("Alert_Thereisnorecord", ci));
                        return;
                    }
                }
                ParenetLevelid = Convert.ToString(Session["parentLevelId"]);
                strReportType = "Normal";
                Session["Path"] = Server.MapPath(rm.GetString("rptLateEntry", ci));
                ok = true;
            }
        }
        catch (Exception ex)
        {
            ok = false;
            Response.Write(ex.ToString());
        }
        finally
        {
            if (rbtNormalReport.Checked == true)
            {
                if (ok == true && rbtlatein.Checked)
                    Response.Redirect("TA_UI_Report_LateInGrid.aspx?EmpID=" + empId + "&MinExceptHours=" + MinExceptkHours + "&ReportName=" + ReportName + "&From=" + dtFrom + "&To=" + dtTo + "&EmpName=" + employeeName + "&Shift=" + Convert.ToInt16(this.ddlShift.SelectedValue) + "&ReportType=" + strReportType + "&employeeCategory=" + Convert.ToInt32(ddlEmpCatagory.SelectedValue) + "&employeeType=" + Convert.ToInt32(ddlEmpType.SelectedValue) + "&ParentLevelid=" + ParenetLevelid + "&userGroupName=" + Convert.ToString(Session["UserGroupName"]) + "&gradeLevel=" + Session["GradeLevel"].ToString() + "&SwipeCard=" + empId + "&Designation=" + Convert.ToInt32(ddlDesignation.SelectedValue) + "&Gender=" + ddlGender.SelectedValue + "&EmpAutoID=" + Convert.ToInt64(strEmpAutoId));
                else if (ok == true && rbtEarlyExit.Checked)
                    Response.Redirect("TA_UI_Report_EarlyExitGrid.aspx?EmpID=" + empId + "&MinExceptHours=" + MinExceptkHours + "&From=" + dtFrom + "&To=" + dtTo + "&EmpName=" + employeeName + "&Shift=" + Convert.ToInt16(this.ddlShift.SelectedValue) + "&employeeCategory=" + Convert.ToInt32(ddlEmpCatagory.SelectedValue) + "&employeeType=" + Convert.ToInt32(ddlEmpType.SelectedValue) + "&ParentLevelId=" + ParenetLevelid + "&userGroupName=" + Convert.ToString(Session["UserGroupName"]) + "&gradeLevel=" + Session["GradeLevel"].ToString() + "&ReportType=" + strReportType + "&SwipeCard=" + empId + "&Designation=" + Convert.ToInt32(ddlDesignation.SelectedValue) + "&Gender=" + ddlGender.SelectedValue);
                else if (ok == true && rbtAll.Checked)
                    base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "Exception", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, ((rdbtnSummary.Checked) ? "1" : "0"), MinExceptkHours, null, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
                else if (ok == true && rbtEarlyEntry.Checked)
                    base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "EarlyEntry", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, MinExceptkHours, null, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
                else if (ok == true && rbtLateExit.Checked)
                    base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "LateExit", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, MinExceptkHours, null, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
            }
            else
            {
                DataTable dtLevelName = new DataTable();
                if (Convert.ToInt16(Session["parentLevelId"]) != 0)
                    dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
                string strreportHeader = "";
                if (dtLevelName.Rows.Count > 0)
                    strreportHeader = Convert.ToString(dtLevelName.Rows[0][0]);
                if (ok == true && rbtlatein.Checked)
                    base.EncryptandRedirect("TA_UI_Report_Graphical_View.aspx", "LateEntry", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, MinExceptkHours, strreportHeader, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
                else if (ok == true && rbtEarlyExit.Checked)
                    base.EncryptandRedirect("TA_UI_Report_Graphical_View.aspx", "EarlyExit", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, MinExceptkHours, strreportHeader, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
                else if (ok == true && rbtEarlyEntry.Checked)
                    base.EncryptandRedirect("TA_UI_Report_Graphical_View.aspx", "EarlyEntry", dtFrom, dtTo, empId, Convert.ToInt32(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, null, null, MinExceptkHours, strreportHeader, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
            }
        }
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                string employeeName = string.Empty;
                string empName = "", empId = "";
                string Level = string.Empty;
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Session["EmployeeCodeId"].ToString();
                }
                else
                {
                    empName = txtEmployeeName.Text.ToString();
                    empId = txtEmployeeId.Text.Trim().ToString();
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                    if (Level.Contains(","))
                    {
                        Level = Level.Replace(",", "~");
                    }
                    if (employeeName.Contains(","))
                    {
                        employeeName = employeeName.Replace(",", "~");
                    }
                    if (empId.Contains(","))
                    {
                        empId = empId.Replace(",", "~");
                    }
                }
                StringBuilder strFilters = new StringBuilder();
                string ReportType = "";
                if (rbtlatein.Checked)
                {
                    ReportType = "LateEntry";
                    Session["LateReportName"] = "LateEntry";
                    strFilters.Append("@EmployeeID=" + empId + ",");
                    strFilters.Append("@LevelID=" + "0,");
                    strFilters.Append("@FromDate=" + " Duration_From " + ",");
                    strFilters.Append("@ToDate=" + " Duration_To " + ",");
                    strFilters.Append("@EmployeeName=" + employeeName + ",");
                    strFilters.Append("@shift=" + ddlShift.SelectedValue + ",");
                    strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                    strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                    strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                    strFilters.Append("@GradeLevel=" + Session["GradeLevel"].ToString() + ",");
                    strFilters.Append("@EmpSwipeCard=" + EmployeeId + ",");
                    strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]).ToString() + ",");
                    strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                    strFilters.Append("@Gender=" + ddlGender.SelectedValue + ",");
                    strFilters.Append("@ExportType=1,");
                    strFilters.Append("@MINExceptionHOURS=" + Convert.ToString(txtMinExceptionHours.Text) + ",");
                    strFilters.Append("@EmpAutoId=0");
                }
                else if (rbtEarlyExit.Checked)
                {
                    ReportType = "EarlyExit";
                    Session["LateReportName"] = "EarlyExit";
                    strFilters.Append("@fromDat=" + " Duration_From " + ",");
                    strFilters.Append("@ToDat=" + " Duration_To " + ",");
                    strFilters.Append("@empId=" + empId + ",");
                    strFilters.Append("@shift=" + ddlShift.SelectedValue + ",");
                    strFilters.Append("@EmployeeName=" + employeeName + ",");
                    strFilters.Append("@LevelID=" + "0,");
                    strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                    strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                    strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                    strFilters.Append("@GradeLevel=" + Session["GradeLevel"].ToString() + ",");
                    strFilters.Append("@EmpSwipeCard=" + EmployeeId + ",");
                    strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]).ToString() + ",");
                    strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                    strFilters.Append("@ExportType=1,");
                    strFilters.Append("@MINExceptionHOURS=" + Convert.ToString(txtMinExceptionHours.Text) + ",");
                    strFilters.Append("@Gender=" + ddlGender.SelectedValue + ",");
                    strFilters.Append("@EmpAutoId=0");
                }
                else if (rbtEarlyEntry.Checked)
                {
                    ReportType = "EarlyEntry";
                    Session["LateReportName"] = "EarlyEntry";
                    strFilters.Append("@FromDate=" + " Duration_From " + ",");
                    strFilters.Append("@ToDate=" + " Duration_To " + ",");
                    strFilters.Append("@EmployeeID=" + empId + ",");
                    strFilters.Append("@shift=" + ddlShift.SelectedValue + ",");
                    strFilters.Append("@EmployeeName=" + employeeName + ",");
                    strFilters.Append("@LevelID=" + Level + ",");
                    strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                    strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                    strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                    strFilters.Append("@GradeLevel=" + Session["GradeLevel"].ToString() + ",");
                    strFilters.Append("@EmpSwipeCard=" + EmployeeId + ",");
                    strFilters.Append("@DesignationID=0,");
                    strFilters.Append("@Gender=Both,");
                    strFilters.Append("@ExportType=1,");
                    strFilters.Append("@MINExceptionHOURS=" + Convert.ToString(txtMinExceptionHours.Text) + ",");
                    strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]) + ",");
                    strFilters.Append("@EmpAutoId=0");
                }
                else if (rbtLateExit.Checked)
                {
                    ReportType = "LateExit";
                    Session["LateReportName"] = "LateExit";
                    strFilters.Append("@fromDat=" + " Duration_From " + ",");
                    strFilters.Append("@ToDat=" + " Duration_To " + ",");
                    strFilters.Append("@EmployeeId=" + empId + ",");
                    strFilters.Append("@shift=" + ddlShift.SelectedValue + ",");
                    strFilters.Append("@EmployeeName=" + employeeName + ",");
                    strFilters.Append("@LevelID= " + Level + ",");
                    strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                    strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                    strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                    strFilters.Append("@GradeLevel=" + Session["GradeLevel"].ToString() + ",");
                    strFilters.Append("@EmpSwipeCard=" + EmployeeId + ",");
                    strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]).ToString() + ",");
                    strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                    strFilters.Append("@MINExceptionHOURS=" + Convert.ToString(txtMinExceptionHours.Text) + ",");
                    strFilters.Append("@Gender=" + ddlGender.SelectedValue + ",");
                    strFilters.Append("@EmpAutoId=0");
                }
                else
                {
                    ReportType = "All";
                    Session["LateReportName"] = "All";
                    strFilters.Append("@FromDate=" + " Duration_From " + ",");
                    strFilters.Append("@ToDate=" + " Duration_To " + ",");
                    strFilters.Append("@EmployeeID=" + empId + ",");
                    strFilters.Append("@shift=" + ddlShift.SelectedValue + ",");
                    strFilters.Append("@EmployeeName=" + employeeName + ",");
                    strFilters.Append("@LevelID= " + Level + ",");
                    strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                    strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                    strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                    strFilters.Append("@GradeLevel=" + Session["GradeLevel"].ToString() + ",");
                    strFilters.Append("@EmpSwipeCard=" + EmployeeId + ",");
                    strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]).ToString() + ",");
                    strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                    strFilters.Append("@MINExceptionHOURS=" + Convert.ToString(txtMinExceptionHours.Text) + ",");
                    strFilters.Append("@Gender=" + ddlGender.SelectedValue + ",");
                    strFilters.Append("@EmpAutoId=0");
                }
                Session["hdnReportFilters"] = string.Empty;
                Session["hdnReportFilters"] = strFilters;
                string strScript = "<script language=\"javascript\">";
                //
                strScript = strScript + "{window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnFilters').value='" + strFilters + "'; window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnCompanyId').value='" + Convert.ToInt32(Session["parentLevelId"]).ToString() + "';window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnReportType').value='" + ReportType + "'}";
                //strScript = strScript + "self.close();";
                strScript = strScript + "parent.$('#myModalReport').modal('hide');";
                strScript = strScript + "</script>";
                Response.Write(strScript);
            }
        }
        catch
        {
            //
        }
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        string strMsg;
        strMsg = "<script language='javascript'>";
        strMsg = strMsg + "parent.$('#myModalReport').modal('hide');";
        strMsg = strMsg + "</script>";
        Page.RegisterStartupScript("close report window", strMsg);
        return;
    }
    protected void btn_Export_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                CommonThings();
                if (rbtAll.Checked)
                    dscommon = rptEmp.SelectExceptionReport(empId, Level, dtFrom, dtTo, employeeName, Convert.ToInt16(this.ddlShift.SelectedValue), Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, MinExceptkHours, Convert.ToInt32(strEmpAutoId));
                else if (rbtlatein.Checked)
                    dscommon = rptEmp.SelectLateInstanceReport(empId, Level, dtFrom, dtTo, employeeName, Convert.ToInt16(this.ddlShift.SelectedValue), Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt64(strEmpAutoId), 1, MinExceptkHours);
                else if (rbtEarlyExit.Checked)
                    dscommon = rptEmp.SelectEarlyOutReportNew(dtFrom, dtTo, empId, Convert.ToInt16(this.ddlShift.SelectedValue), employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 1, MinExceptkHours, Convert.ToInt32(Session["EmpAutoID"]));
                else if (rbtEarlyEntry.Checked)
                    dscommon = rptEmp.SelectEarlyEntryReport(empId, Level, dtFrom, dtTo, employeeName, shft, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Session["GradeLevel"].ToString(), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 1, MinExceptkHours, Convert.ToInt32(Session["EmpAutoID"]));
                else if (rbtLateExit.Checked)
                    dscommon = rptEmp.SelectLateExit(dtFrom, dtTo, empId, shft, employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), empId, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, MinExceptkHours, Convert.ToInt32(Session["EmpAutoID"]));

                if (dscommon.Tables["Table"].Rows.Count == 0)
                {
                    Message(rm.GetString("Alert_Thereisnorecord", ci));
                    return;
                }
                else
                    ExportExcel(dscommon);
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex.ToString());
        }
    }

    //private void GenerateExport(DataSet dsEmp)
    //{
    //    using (XLWorkbook wb = new XLWorkbook())
    //    {
    //        wb.Worksheets.Add(dsEmp);

    //        Response.Clear();
    //        Response.Buffer = true;
    //        Response.Charset = "";
    //        Response.ContentType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
    //        Response.AddHeader("content-disposition", "attachment;filename=GridView.xlsx");
    //        using (MemoryStream MyMemoryStream = new MemoryStream())
    //        {
    //            wb.SaveAs(MyMemoryStream);
    //            MyMemoryStream.WriteTo(Response.OutputStream);
    //            Response.Flush();
    //            Response.End();
    //        }
    //    }
    //}

    #endregion
    #region Export Excel
    protected void ExportExcel(DataSet dsEmp)
    {
        HSSFWorkbook workbook = new HSSFWorkbook();
        DataTable dtLevelName = new DataTable();
        string strPre = string.Empty;
        double ValCount = 0.0;
        int CountDays = 0;
        Int32 SlNo = 0;
        if (Convert.ToInt16(Session["parentLevelId"]) != 0)
        {
            dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
        }

        if (rbtAll.Checked)
        {
            SheetName = "All Exception Entry Report";
            ReportName = "AllExceptionEntryReport";
            Cellvalcount = 0;
        }
        else if (rbtlatein.Checked)
        {
            SheetName = "Late Entry Report";
            ReportName = "LateEntryReport";
            Cellvalcount = 11;
        }
        else if (rbtEarlyExit.Checked)
        {
            SheetName = "Early Exit Report";
            ReportName = "EarlyExitReport";
            Cellvalcount = 11;
        }
        else if (rbtEarlyEntry.Checked)
        {
            SheetName = "Early Entry Report";
            ReportName = "EarlyEntryReport";
            Cellvalcount = 10;
        }
        else if (rbtLateExit.Checked)
        {
            SheetName = "Late Exit Report";
            ReportName = "LateExitReport";
            Cellvalcount = 10;
        }
        string NewTimeFormat = string.Empty;
        string TimeFormat = Convert.ToString(Session["ITimeFormat"]);
        if (TimeFormat == "HH:mm")
            NewTimeFormat = "HH:mm";
        else
            NewTimeFormat = "hh:mm tt";
        sheet = workbook.CreateSheet(SheetName);
        int rowIndex = 0;
        NPOI.SS.UserModel.IRow row = sheet.CreateRow(rowIndex);
        HSSFCellStyle hStyle, MainHStyle, IStyle;
        getStylesForCells(workbook, out hStyle, out MainHStyle, out IStyle);
        if (dtLevelName.Rows.Count > 0)
        {
            row.CreateCell(0).SetCellValue(Convert.ToString(dtLevelName.Rows[0][0]));
            sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, Cellvalcount));
            row.GetCell(0).CellStyle = MainHStyle;
            rowIndex++;
            row = sheet.CreateRow(rowIndex);
        }
        row.CreateCell(0).SetCellValue(SheetName + " From - " + Convert.ToString(txtFromDate.Text) + " - " + " To - " + Convert.ToString(txtToDate.Text));
        row.GetCell(0).CellStyle = MainHStyle;
        sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, Cellvalcount));
        rowIndex++;
        rowIndex = CreateExcelReportHeaders(rowIndex, row, hStyle);
        if (rbtlatein.Checked || rbtEarlyEntry.Checked)
        {
            foreach (DataRow DR in dsEmp.Tables[0].Rows)
            {

                if (strPre != string.Empty)
                {
                    if (strPre != Convert.ToString(DR["CardNo"]))
                    {
                        row = sheet.CreateRow(rowIndex);
                        row.CreateCell(9).SetCellValue("Sub Total");
                        row.GetCell(9).CellStyle = hStyle;
                        result = TimeSpan.FromMinutes(ValCount);
                        fromTimeString = result.ToString();
                        row.CreateCell(10).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes) + " ( " + CountDays + " Days )");
                        row.GetCell(10).CellStyle = hStyle;
                        if (rbtlatein.Checked)
                        {
                            row.CreateCell(11).SetCellValue("");
                            row.GetCell(11).CellStyle = hStyle;
                        }
                        ValCount = 0.0;
                        CountDays = 0;
                        rowIndex++;
                    }
                }
                row = sheet.CreateRow(rowIndex);
                if (strPre == string.Empty || strPre != Convert.ToString(DR["CardNo"]))
                {
                    SlNo++;
                    row.CreateCell(0).SetCellValue(SlNo);
                }
                else
                    row.CreateCell(0).SetCellValue("");

                row.CreateCell(1).SetCellValue(Convert.ToString(DR["CardNo"]));
                row.CreateCell(2).SetCellValue(Convert.ToString(DR["Employee Name"]));
                row.CreateCell(3).SetCellValue(Convert.ToString(DR["Level Name"]));
                row.CreateCell(4).SetCellValue(Convert.ToString(DR["Designation"]));
                row.CreateCell(5).SetCellValue(Convert.ToString(DR["Gender"]));
                row.CreateCell(6).SetCellValue(Convert.ToString(DR["Date"]));
                row.CreateCell(7).SetCellValue(Convert.ToString(DR["shift_shortName"]));
                if (Convert.ToString(DR["Shift_StartTime"]) == String.Empty)
                    row.CreateCell(8).SetCellValue(Convert.ToString(DR["Shift_StartTime"]));
                else
                {
                    row.CreateCell(8).SetCellValue((Convert.ToDateTime(Convert.ToString(DR["Shift_StartTime"]))).ToString(NewTimeFormat));
                }
                if (Convert.ToString(DR["InTime"]) == String.Empty)
                    row.CreateCell(9).SetCellValue(Convert.ToString(DR["InTime"]));
                else
                {
                    row.CreateCell(9).SetCellValue((Convert.ToDateTime(Convert.ToString(DR["InTime"]))).ToString(NewTimeFormat));
                }
                if (rbtEarlyEntry.Checked)
                {
                    row.CreateCell(10).SetCellValue(Convert.ToString(DR["earlyby"]));
                    ValCount = ValCount + Convert.ToDouble(DR["earlyInMins"]);
                }
                else
                {
                    row.CreateCell(10).SetCellValue(Convert.ToString(DR["LateBy"]));
                    row.CreateCell(11).SetCellValue(Convert.ToString(DR["Reason"]));
                    ValCount = ValCount + Convert.ToDouble(DR["LateInMins"]);
                }
                CountDays++;
                strPre = Convert.ToString(DR["CardNo"]);
                ApplyStyleToCell(row, IStyle);
                rowIndex++;


            }
        }
        else if (rbtAll.Checked || rbtEarlyExit.Checked || rbtLateExit.Checked)
        {
            foreach (DataRow DR in dsEmp.Tables[0].Rows)
            {
                row = BindDataToExcel(NewTimeFormat, ref rowIndex, hStyle, IStyle, ref strPre, ref ValCount, ref CountDays, ref SlNo, DR);
            }
        }
        row = FinalRowDataBind(ref rowIndex, hStyle, ref ValCount, ref CountDays);
        ExportToExcel(workbook, ReportName);
    }

    private static void getStylesForCells(HSSFWorkbook workbook, out HSSFCellStyle hStyle, out HSSFCellStyle MainHStyle, out HSSFCellStyle IStyle)
    {
        HSSFFont hFont = (HSSFFont)workbook.CreateFont();
        hFont.Boldweight = (short)FontBoldWeight.Bold;
        hFont.Color = HSSFColor.Maroon.Index;
        hFont.FontHeightInPoints = 10;
        hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        hStyle.SetFont(hFont);
        hStyle.FillForegroundColor = IndexedColors.White.Index;
        hStyle.FillPattern = FillPattern.SolidForeground;
        hStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
        hStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
        MainHStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        MainHStyle.SetFont(hFont);
        MainHStyle.Alignment = HorizontalAlignment.Center;
        IStyle = (HSSFCellStyle)workbook.CreateCellStyle();
        IStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
        IStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
    }

    private int CreateExcelReportHeaders(int rowIndex, IRow row, HSSFCellStyle hStyle)
    {
        row = sheet.CreateRow(rowIndex);
        rowIndex++;
        row = sheet.CreateRow(rowIndex);
        row.CreateCell(0).SetCellValue("Sl.No");
        row.CreateCell(1).SetCellValue("Employee ID");
        row.CreateCell(2).SetCellValue("Employee Name");
        row.CreateCell(3).SetCellValue("Level");
        row.CreateCell(4).SetCellValue("Designation");
        row.CreateCell(5).SetCellValue("Gender");
        row.CreateCell(6).SetCellValue("Date");
        row.CreateCell(7).SetCellValue("Shift Short Name");
        if (rbtEarlyEntry.Checked)
        {
            row.CreateCell(8).SetCellValue("Shift In Time");
            row.CreateCell(9).SetCellValue("Actual In Time");
            row.CreateCell(10).SetCellValue("Early by Hrs");
        }
        else if (rbtlatein.Checked)
        {
            row.CreateCell(8).SetCellValue("Shift Start Time");
            row.CreateCell(9).SetCellValue("Actual In Time");
            row.CreateCell(10).SetCellValue("Late by Hrs");
            row.CreateCell(11).SetCellValue("Reason");
        }
        else
        {
            row.CreateCell(8).SetCellValue("Shift Out Time");
            row.CreateCell(9).SetCellValue("Actual Shift Out Time");
            if (rbtEarlyExit.Checked)
            {
                row.CreateCell(10).SetCellValue("Early by");
                row.CreateCell(11).SetCellValue("Reason");
            }
            else
            {
                row.CreateCell(10).SetCellValue("Extra Hours");
            }
        }
        ApplyStyleToHeaderCell(row, hStyle);
        rowIndex++;
        return rowIndex;
    }

    private IRow FinalRowDataBind(ref int rowIndex, HSSFCellStyle hStyle, ref double ValCount, ref int CountDays)
    {
        IRow row = sheet.CreateRow(rowIndex);
        row.CreateCell(9).SetCellValue("Sub Total");
        row.GetCell(9).CellStyle = hStyle;
        result = TimeSpan.FromMinutes(ValCount);
        string fromTimeString = result.ToString();
        row.CreateCell(10).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes) + " ( " + CountDays + " Days )");
        row.GetCell(10).CellStyle = hStyle;
        if (rbtEarlyExit.Checked)
        {
            row.CreateCell(11).SetCellValue("");
            row.GetCell(11).CellStyle = hStyle;
        }
        ValCount = 0.0;
        CountDays = 0;
        rowIndex++;
        return row;
    }

    private IRow BindDataToExcel(string NewTimeFormat, ref int rowIndex, HSSFCellStyle hStyle, HSSFCellStyle IStyle, ref string strPre, ref double ValCount, ref int CountDays, ref int SlNo, DataRow DR)
    {
        IRow row;
        if (strPre != string.Empty)
        {
            if (strPre != Convert.ToString(DR["Employee_Code_Id"]))
            {
                row = sheet.CreateRow(rowIndex);
                row.CreateCell(9).SetCellValue("Sub Total");
                row.GetCell(9).CellStyle = hStyle;
                result = TimeSpan.FromMinutes(ValCount);
                row.CreateCell(10).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes) + " ( " + CountDays + " Days )");
                row.GetCell(10).CellStyle = hStyle;
                if (rbtEarlyExit.Checked)
                {
                    row.CreateCell(11).SetCellValue("");
                    row.GetCell(11).CellStyle = hStyle;
                }
                ValCount = 0.0;
                CountDays = 0;
                rowIndex++;
            }
        }
        row = sheet.CreateRow(rowIndex);
        //row.CreateCell(0).SetCellValue(Convert.ToString(DR["Sl.No"]));
        if (strPre == string.Empty || strPre != Convert.ToString(DR["Employee_Code_Id"]))
        {
            SlNo++;
            row.CreateCell(0).SetCellValue(SlNo);
        }
        else
            row.CreateCell(0).SetCellValue("");
        row.CreateCell(1).SetCellValue(Convert.ToString(DR["Employee_Code_Id"]));
        row.CreateCell(4).SetCellValue(Convert.ToString(DR["TitleName"]));
        row.CreateCell(5).SetCellValue(Convert.ToString(DR["Gender"]));
        row.CreateCell(6).SetCellValue(Convert.ToString(DR["Date"]));
        row.CreateCell(7).SetCellValue(Convert.ToString(DR["shift_shortName"]));
        if (rbtEarlyExit.Checked)
        {
            row.CreateCell(2).SetCellValue(Convert.ToString(DR["Employee_FirstName"]));
            row.CreateCell(3).SetCellValue(Convert.ToString(DR["LevelName"]));
        }
        else
        {
            row.CreateCell(2).SetCellValue(Convert.ToString(DR["empName"]));
            row.CreateCell(3).SetCellValue(Convert.ToString(DR["Level Name"]));
        }
        if (Convert.ToString(DR["shiftOut"]) == String.Empty)
            row.CreateCell(8).SetCellValue(Convert.ToString(DR["shiftOut"]));
        else
        {
            row.CreateCell(8).SetCellValue((Convert.ToDateTime(Convert.ToString(DR["shiftOut"]))).ToString(NewTimeFormat));
        }
        if (Convert.ToString(DR["OutTime"]) == String.Empty)
            row.CreateCell(9).SetCellValue(Convert.ToString(DR["OutTime"]));
        else
        {
            row.CreateCell(9).SetCellValue((Convert.ToDateTime(Convert.ToString(DR["OutTime"]))).ToString(NewTimeFormat));
        }
        if (rbtEarlyExit.Checked)
        {
            row.CreateCell(10).SetCellValue(Convert.ToString(DR["EarlyOut"]));
            row.CreateCell(11).SetCellValue(Convert.ToString(DR["Reason"]));
            ValCount = ValCount + Convert.ToDouble(DR["EarlyOutMins"]);
        }
        else
        {
            row.CreateCell(10).SetCellValue(Convert.ToString(DR["hrsExtra"]));
            ValCount = ValCount + Convert.ToDouble(DR["ExtraMins"]);
        }
        CountDays++;
        strPre = Convert.ToString(DR["Employee_Code_Id"]);
        ApplyStyleToCell(row, IStyle);
        rowIndex++;
        return row;
    }

    private void ApplyStyleToCell(IRow row, HSSFCellStyle IStyle)
    {
        for (int i = 0; i <= Cellvalcount; i++)
        {
            row.GetCell(i).CellStyle = IStyle;
            sheet.AutoSizeColumn(i);
        }
    }

    private void ApplyStyleToHeaderCell(IRow row, HSSFCellStyle hStyle)
    {
        for (int i = 0; i <= Cellvalcount; i++)
        {
            row.GetCell(i).CellStyle = hStyle;
        }
    }
    #endregion
}
