using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Globalization;
using System.Threading;
using System.Resources;
/****************************************************************************************************************************
* Project Name    : TimeCheck                    Started Date  : 12-Aug-2007
* Module          : Leave Application            Lbast Modified : 15-May-2009
* Programmer      : Prabakaran.P
* BackUp          :
****************************************************************************************************************************/
public partial class Transactions_TA_UI_Transactions_LeaveApplicationAdd : Base.BasePage
{
    #region VariableDeclaration
    ResourceManager rm;
    CultureInfo objCultureInfo;
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet dsCheckuser = new DataSet();
    EmployeeEventData objEmployeeEventData = new EmployeeEventData();
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    LeaveEventData objLeaveEventData = new LeaveEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    HolidayEventData objHoliday = new HolidayEventData();
    SMSNotification objsms = new SMSNotification();
    cls_Common objClassCommon = new cls_Common();
    DataSet dsLeaveType = new DataSet();
    DataSet dsRemainingDays = new DataSet();
    DataSet dsLeaveApplication = new DataSet();
    DataSet dsLeavePolicyDetails = new DataSet();
    DataSet dsSpellCount = new DataSet();
    DataSet dsEmployeeDetails = new DataSet();
    DataSet dsMaxNoOfLeaves = new DataSet();
    DataSet dsEmailIdOfSanctionAuthority = new DataSet();
    DataSet dsEmailIdOfReportingTo = new DataSet();
    DataSet dsYear = new DataSet();
    DataSet dsHolidayDetails = new DataSet();
    string strApplicationDate, strTypeOfLeave, strFromDate, strToDate, strSessionFrom, strSessionTo, strReason, strEmailIdReportingTo, strEmailIdSanctioningAuthority, strEmployeeName, strEmployeeCodeId, strEmpFirstName, strEmpLastName, gstrDateFormat, strFromDateTime, strToDateTime, strlevelName;
    DateTime dtCurrentDate;
    int intEmployeeId, intLeaveTypeId, gintCount, intStartYear, intEndYear, intInsertFlag = 0, intHalfDayCount = 0;
    double dblNumberOfDaysApplied, dblNoOfDaysTaken, dblTotalDays;
    int intSuccessiveyear = 0;
    bool blnCheckEmail = true, blnCheckSMS = true;
    DataSet ds = new DataSet();
    int intLeaveApplicationId = 0;
    int LevelID;
    string LeaveApplicationStatus = string.Empty;
    #endregion
    #region PageLoad.
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!Page.IsPostBack)
            objClassCommon.menu("LeaveTransaction", "22");
        string strSourceLanguage;
        strSourceLanguage = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(strSourceLanguage, System.Reflection.Assembly.Load("App_GlobalResources"));
        objCultureInfo = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SelectEmployee('" + rm.GetString("Alert_SelectanEmployee", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "Emp('" + rm.GetString("Alert_Norecordsfound", objCultureInfo) + "','" + rm.GetString("Alert_Errorinretrivingdetails", objCultureInfo) + "','" + rm.GetString("Select", objCultureInfo) + "','" + rm.GetString("Employee_Others", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_LeaveType", objCultureInfo) + "','" + rm.GetString("Alert_LeaveRestictHoliday", objCultureInfo) + "','" + rm.GetString("Alert_Fromdate", objCultureInfo) + "','" + rm.GetString("Alert_ToDate", objCultureInfo) + "','" + rm.GetString("Alert_FromSession", objCultureInfo) + "','" + rm.GetString("Alert_ToSession", objCultureInfo) + "','" + rm.GetString("Alert_FillReasons", objCultureInfo) + "','" + rm.GetString("Alert_DayEmpty", objCultureInfo) + "','" + rm.GetString("Alert_DaysZero", objCultureInfo) + "','" + rm.GetString("Alert_RemainingZero", objCultureInfo) + "','" + rm.GetString("Alert_DaysNotExceed", objCultureInfo) + "','" + rm.GetString("InvalidApplicationDate", objCultureInfo) + "','" + rm.GetString("Alert_ConfirmSave", objCultureInfo) + "','" + rm.GetString("Alert_CompOffDaysNotExceed", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SetAlertMessagesAjax_Leave('" + rm.GetString("Alert_Selectvalidfromsessionandtosession", objCultureInfo) + "','" + rm.GetString("Alert_Halfdayisnotallowed", objCultureInfo) + "','" + rm.GetString("Master_Holiday_Select_Valid_Year", objCultureInfo) + "','" + rm.GetString("Alert_LeaveFromDateshouldnotbegreaterthanLeaveToDate", objCultureInfo) + "','" + rm.GetString("Alert_Leaveshouldnotbeappliedbeforedateofjoining", objCultureInfo) + "','" + rm.GetString("Alert_NoLeavePolicyexistsforthisLeaveFromDateorToDate", objCultureInfo) + "','" + rm.GetString("Alert_Leaveshouldbeappliedapplicableafterdays", objCultureInfo) + "','" + rm.GetString("Alert_YouareselectingHoliday", objCultureInfo) + "','" + rm.GetString("Alert_YouareselectingWeeklyOffinFromdate", objCultureInfo) + "','" + rm.GetString("Alert_YouareselectingWeeklyOffinTodate", objCultureInfo) + "','" + rm.GetString("Alert_YouareselectingWeeklyOff", objCultureInfo) + "','" + rm.GetString("Alert_LeaveApplicationcannotberaisedduringWeeklyOffGlobalHoliday", objCultureInfo) + "','" + rm.GetString("Alert_SelectLeaveandLeaveTypeId", objCultureInfo) + "','" + rm.GetString("Alert_Shiftnotallocated", objCultureInfo) + "','" + rm.GetString("ALert_SelectValidFromDateandToDate", objCultureInfo) + "','" + rm.GetString("Alert_YouhavechoosedafterweeklyOffOneDayAdded", objCultureInfo) + "','" + rm.GetString("ALert_YouhavechoosedBeforeweeklyOffOneDayAdded", objCultureInfo) + "','" + rm.GetString("Alert_YouhaveselectedInterveningweeklyOffGlobalHoliday", objCultureInfo) + "','" + rm.GetString("Alert_DayDeducted", objCultureInfo) + "','" + rm.GetString("Alert_Dayincluded", objCultureInfo) + "','" + rm.GetString("Alert_SelectanEmployee", objCultureInfo) + "','" + rm.GetString("Alert_LOPnotdefined", objCultureInfo) + "','" + rm.GetString("Alert_RestrictedHolidaynotdefined", objCultureInfo) + "','" + rm.GetString("Alert_LeavePolicynotdefined", objCultureInfo) + "','" + rm.GetString("Select_leavefrom_and_todate", objCultureInfo) + "','" + rm.GetString("Alert_Selectleavefromdate", objCultureInfo) + "','" + rm.GetString("Alert_Selectleavetodate", objCultureInfo) + "','" + rm.GetString("Alert_Theleavedurationcrossestheleavepolicy", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validdatemonthfourdigit", objCultureInfo) + "','" + rm.GetString("Alert_Invalidyearentry", objCultureInfo) + "','" + rm.GetString("ExceedsSuccessiveDays", objCultureInfo) + "','" + rm.GetString("Alert_Invalidmonthentry", objCultureInfo) + "','" + rm.GetString("Alert_Invaliddateentry", objCultureInfo) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", objCultureInfo) + "','" + rm.GetString("Alert_Entertime", objCultureInfo) + "','" + rm.GetString("Alert_Invalidvalueforhours", objCultureInfo) + "','" + rm.GetString("Alert_Invalidvalueforminites", objCultureInfo) + "','" + rm.GetString("Alert_Invalidtimeformat1", objCultureInfo) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", objCultureInfo) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", objCultureInfo) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", objCultureInfo) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", objCultureInfo) + "','" + rm.GetString("Alert_Invalidvalueforhours", objCultureInfo) + "','" + rm.GetString("Alert_Invalidvalueforminites", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        LoadStrings(objCultureInfo);
        UserRights();
        GettingFinancialYearDetails();
        Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
        ListItem liSelect = new ListItem();
        liSelect.Value = "-Select-";
        liSelect.Text = rm.GetString("Select", objCultureInfo);
        dtCurrentDate = Convert.ToDateTime(System.DateTime.Today.Date.ToShortDateString());
        lblLeaveApplicationDateData.Text = dtCurrentDate.ToString(Session["MDateFormat"].ToString());
        if (Session["User"] == null)
            Response.Redirect("../index.aspx");
        if (Convert.ToString(Session["User"]) == "")
            Response.Redirect("../index.aspx");
        Page.RegisterStartupScript("HideBorrow", "<script>hidedivBorrow();</script>");
        Page.RegisterStartupScript("hideLeaveProcess", "<script>hidedivLeaveProcess();</script>");
        ds = objClassCommon.GetSuccessiveYearsetting();
        hdnApplicationYear.Value = Convert.ToString(ViewState["YearSettings_Id"]);
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["IndividualUsers"]) != "True")
        {
            divEmployees.Visible = false;
            divAdmin.Visible = true;
            if (ds.Tables.Count > 0)
                if (ds.Tables[0].Rows.Count > 0)
                {
                    hdnSuccessiveYear.Value = Convert.ToString(ds.Tables[0].Rows[0][0]);
                    rbtnSuccessiveYear.Enabled = true;
                }
                else
                    rbtnSuccessiveYear.Enabled = false;
        }
        else
        {
            divEmployees.Visible = true;
            divAdmin.Visible = false;
            if (ds.Tables.Count > 0)
            {
                if (ds.Tables[0].Rows.Count > 0)
                {
                    hdnSuccessiveYear.Value = Convert.ToString(ds.Tables[0].Rows[0][0]);
                    if (rbtnCurrentYear.Checked == true)
                        hdnApplicationYear.Value = Convert.ToString(ViewState["YearSettings_Id"]);
                    else if (rbtnSuccessiveYear.Checked == true)
                        hdnSuccessiveYear.Value = Convert.ToString(ds.Tables[0].Rows[0][0]);
                    rbtnSuccessiveYear.Enabled = true;
                }
                else
                    rbtnSuccessiveYear.Enabled = false;
            }
            else
                rbtnSuccessiveYear.Enabled = false;
            hdnEmployeeId.Value = Convert.ToString(Session["EmpAutoId"]);
            GetEmployeeName();
            string strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "OpenWindowLeaveQuota(" + intEmployeeId + ");";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("AlertLeavePolicyYear", strScript);
        }
        btnAdd.Focus();
    }
    private void GettingFinancialYearDetails()
    {
        dsYear = objClassCommon.GetYearsetting();
        if (dsYear.Tables[0].Rows.Count <= 0)
        {
            MessageWithreplace(rm.GetString("Alert_DefineYearSettinginOrganizationSettings", objCultureInfo), "../Organization Settings/Organization_YearSetting.aspx");
        }
        else
        {
            intStartYear = Convert.ToInt32(dsYear.Tables[0].Rows[0]["StartYear"]);
            intEndYear = Convert.ToInt32(dsYear.Tables[0].Rows[0]["EndYear"]);
            ViewState["YearSettings_Id"] = Convert.ToString(dsYear.Tables[0].Rows[0]["YearSettings_Id"]);
            dsYear.Dispose();
        }
    }
    #endregion
    #region Employee Name.
    public void GetEmployeeName()
    {
        if (Session["user"] == null || Convert.ToString(Session["user"]) == "")
        {
            Response.Redirect("../Index.aspx");
        }
        else
        {
            lblEmployeeIdData.Text = Convert.ToString(Session["EmployeeCodeId"]);
            hfEmployeeCode.Value = Convert.ToString(Session["EmployeeCodeId"]);
            intEmployeeId = Convert.ToInt32(Session["EmpAutoId"]);
            DataSet ds_EmployeeDetails = new DataSet();
            ds_EmployeeDetails = objEmployeeEventData.Select_EmployeeDetailsNewbyId(intEmployeeId);
            if (ds_EmployeeDetails.Tables[0].Rows.Count > 0)
            {
                strEmpFirstName = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["Employee_FirstName"]);
                strEmpLastName = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["Employee_LastName"]);
                lblEmployeeNameData.Text = strEmpFirstName + " " + strEmpLastName;
            }
        }
    }
    #endregion
    #region Leave Application Save function.
    protected void btn_add_Click(object sender, EventArgs e)
    {
        if (Page.IsValid == true)
        {
            string hostUrl = Request.Url.Scheme + "://" + Request.Url.Host;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strApplicationDate = objClassCommon.DateConvertion(gstrDateFormat, lblLeaveApplicationDateData.Text);
            strApplicationDate = DateTime.Parse(strApplicationDate).ToShortDateString();
            strFromDate = objClassCommon.DateConvertion(gstrDateFormat, txtFromDate.Text);
            strFromDate = DateTime.Parse(strFromDate).ToShortDateString();
            strToDate = objClassCommon.DateConvertion(gstrDateFormat, txtToDate.Text);
            strToDate = DateTime.Parse(strToDate).ToShortDateString();
            strSessionFrom = ddl_SessionFrom.SelectedValue;
            strSessionTo = ddl_SessionTo.SelectedValue;
            int intLeaveStartYear = DateTime.Parse(strFromDate).Year;
            int intLeaveEndYear = DateTime.Parse(strToDate).Year;
            if (rbtnCurrentYear.Checked == true)
                intSuccessiveyear = 0;
            else if (rbtnSuccessiveYear.Checked == true)
                intSuccessiveyear = 1;
            if (hdnEmployeeId.Value == "")
            {
                intInsertFlag = -1;
                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_SelectanEmployee", objCultureInfo) + "');", true);
                ddl_Type.SelectedIndex = 0;
                return;
            }
            dsEmployeeDetails = objLeaveApplicationEventData.GetEmployeeDetails(Convert.ToInt32(hdnEmployeeId.Value));
            if (dsEmployeeDetails.Tables[0].Rows.Count > 0)
            {
                strEmpFirstName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_FirstName"]);
                strEmpLastName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_LastName"]);
                strEmployeeCodeId = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["Employee_Code_Id"]);
                strEmployeeName = strEmpFirstName + " " + strEmpLastName;
                strlevelName = Convert.ToString(dsEmployeeDetails.Tables[0].Rows[0]["levelName"]);
            }
            else
            {
                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("lblSelectEmployee", objCultureInfo) + "');", true);
                ddl_Type.SelectedIndex = 0;
                return;
            }
            if (ddl_Type.SelectedValue == "Comp Off")
            {
                if (Convert.ToInt32(dsEmployeeDetails.Tables[0].Rows[0]["CompOff_Eligible"]) == 0)
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_NoCompOff", objCultureInfo) + "');", true);
                    intInsertFlag = -1;
                    ddl_Type.SelectedIndex = 0;
                    return;
                }
            }
            else if (ddl_Type.SelectedValue == "ESI")
            {
                if (Convert.ToInt32(dsEmployeeDetails.Tables[0].Rows[0]["ESI_Eligible"]) == 0)
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_NoESI", objCultureInfo) + "');", true);
                    intInsertFlag = -1;
                    ddl_Type.SelectedIndex = 0;
                    return;
                }
            }
            else if (hdnTxtLeaveTypeId.Value == "")
            {
                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_SelLeaveType", objCultureInfo) + "');", true);
                intInsertFlag = -1;
                ddl_Type.SelectedIndex = 0;
                return;
            }
            dblNumberOfDaysApplied = Convert.ToDouble(hdnNumberofDaysApplied.Value);
            if (dblNumberOfDaysApplied <= 0)
            {
                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_DaysShouldGreater", objCultureInfo) + "');", true);
                intInsertFlag = -1;
                ddl_Type.SelectedIndex = 0;
                return;
            }
            if (ddl_Type.SelectedValue != "Comp Off" && ddl_Type.SelectedValue != "ESI")
            {
                dblNoOfDaysTaken = double.Parse(Convert.ToString(hdnleaveRemaining.Value));
                if (dblNoOfDaysTaken - double.Parse(hdnNumberofDaysApplied.Value) < 0)
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_NoOfdayslessToRemining", objCultureInfo) + "');", true);
                    intInsertFlag = -1;
                    return;
                }
                dblTotalDays = dblNoOfDaysTaken - dblNumberOfDaysApplied;
                if (ddl_Type.SelectedValue != "Restricted Holiday")
                {
                    dsLeavePolicyDetails = objLeaveApplicationEventData.GetLeavePolicyDetailsLeaveApplication(Convert.ToInt32(hdnEmployeeId.Value), Convert.ToInt32(hdnTxtLeaveTypeId.Value), DateTime.Parse(strFromDate), DateTime.Parse(strToDate));
                    dsSpellCount = objLeaveApplicationEventData.GetSpellCountByLeaveType(Convert.ToInt32(hdnEmployeeId.Value), Convert.ToInt32(hdnTxtLeaveTypeId.Value));
                    if (dblNoOfDaysTaken - double.Parse(hdnNumberofDaysApplied.Value) >= 0)
                    {
                        if (dsLeavePolicyDetails.Tables[0].Rows.Count > 0)
                        {
                            if (Convert.ToInt32(dsLeavePolicyDetails.Tables[0].Rows[0]["MaxDays_Avail"]) != 0)
                            {
                                if (dblNumberOfDaysApplied <= Convert.ToDouble(dsLeavePolicyDetails.Tables[0].Rows[0]["MaxDays_Avail"]))
                                    intInsertFlag = 0;
                                else
                                {
                                    intInsertFlag = -1;
                                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_Maxdaysexceed", objCultureInfo) + "');", true);
                                    ddl_Type.SelectedIndex = 0;
                                    return;
                                }
                            }
                            if (dsLeavePolicyDetails.Tables[0].Rows[0]["MinDays_Avail"] != DBNull.Value || Convert.ToString(dsLeavePolicyDetails.Tables[0].Rows[0]["MinDays_Avail"]) != "" || Convert.ToString(dsLeavePolicyDetails.Tables[0].Rows[0]["MinDays_Avail"]) != "0")
                            {
                                if (dblNumberOfDaysApplied >= Convert.ToDouble(dsLeavePolicyDetails.Tables[0].Rows[0]["MinDays_Avail"]))
                                    intInsertFlag = 0;
                                else
                                {
                                    intInsertFlag = -1;
                                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_MinDayslimit", objCultureInfo) + "');", true);
                                    ddl_Type.SelectedIndex = 0;
                                    return;
                                }
                            }
                            if (Convert.ToInt32(dsLeavePolicyDetails.Tables[0].Rows[0]["Spells"]) != 0)
                            {
                                if (Convert.ToInt32(dsSpellCount.Tables[0].Rows[0]["SpellCount"]) < Convert.ToInt32(dsLeavePolicyDetails.Tables[0].Rows[0]["Spells"]))
                                {
                                }
                                else
                                {
                                    intInsertFlag = -1;
                                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_exceedSpell", objCultureInfo) + "');", true);
                                    ddl_Type.SelectedIndex = 0;
                                    return;
                                }
                            }
                            else
                            {
                                intInsertFlag = 0;
                            }
                        }
                        else
                        {
                            intInsertFlag = -1;
                            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_NoPolicyLeave", objCultureInfo) + "');", true);
                            ddl_Type.SelectedIndex = 0;
                            return;
                        }
                    }
                    else
                    {
                        intInsertFlag = -1;
                        ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_exceedLeave", objCultureInfo) + "');", true);
                        ddl_Type.SelectedIndex = 0;
                    }
                }
                else if (ddl_Type.SelectedIndex == 2)
                {
                    int HolidayID = Convert.ToInt32(hdnTxtLeaveTypeId.Value);
                    string UserGroupName = string.Empty;
                    dsHolidayDetails = objHoliday.SelectHolidayDetailsById(HolidayID, UserGroupName, Convert.ToInt32(ViewState["YearSettings_Id"]));
                    if (dsHolidayDetails.Tables[0].Rows.Count > 0)
                    {
                        string HolidayFromDate = Convert.ToString(dsHolidayDetails.Tables[0].Rows[0]["Holiday_FromDate"]);
                        string HolidayToDate = Convert.ToString(dsHolidayDetails.Tables[0].Rows[0]["Holiday_ToDate"]);
                        if (DateTime.Parse(strFromDate) >= DateTime.Parse(HolidayFromDate) && DateTime.Parse(strFromDate) <= DateTime.Parse(HolidayToDate))
                        {
                            if (DateTime.Parse(strToDate) >= DateTime.Parse(HolidayFromDate) && DateTime.Parse(strToDate) <= DateTime.Parse(HolidayToDate))
                            {
                                if (dblNoOfDaysTaken - double.Parse(hdnNumberofDaysApplied.Value) >= 0)
                                {
                                    intInsertFlag = 0;
                                    CheckRestrictedHolidayCount();
                                }
                                else
                                {
                                    intInsertFlag = -1;
                                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_exceedRestrictHoliday", objCultureInfo) + "');", true);
                                }
                            }
                            else
                            {
                                intInsertFlag = -1;
                                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_SelectHolidayToDate", objCultureInfo) + "');", true);
                            }
                        }
                        else
                        {
                            intInsertFlag = -1;
                            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_SelectValidHoliday", objCultureInfo) + "');", true);
                        }
                    }
                }
            }
            int intcount = 0;
            DataSet dsChecking = new DataSet();
            DataSet dsCheck = new DataSet();
            DataSet dsShiftId = new DataSet();
            DateTime dtPermissionDate = new DateTime();
            DateTime dtPermissionFromTime = new DateTime();
            DateTime dtPermissionToTime = new DateTime();
            int intShiftId;
            string strPermissionStatus = string.Empty;
            DataSet dsLeavePolicy = new DataSet();
            dsLeavePolicy = objPermissionEventData.GetMaxNoOfHours_ByLeavePolicy(Convert.ToInt32(hdnEmployeeId.Value));
            if (dsLeavePolicy.Tables[0].Rows.Count > 0)
            {
                if (Convert.ToString(dsLeavePolicy.Tables[0].Rows[0]["PermissionBeforeLeave"]) == "False")
                {
                    dsChecking = objLeaveApplicationEventData.CheckLeaveBeforeAfterWithPermission(DateTime.Parse(strFromDate).ToShortDateString(), DateTime.Parse(strToDate).ToShortDateString(), "LeaveAfterPermission", Convert.ToInt32(hdnEmployeeId.Value));
                    if (dsChecking.Tables.Count > 0)
                    {
                        if (dsChecking.Tables[0].Rows.Count > 0)
                        {
                            dtPermissionDate = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["permission_Date"]);
                            dtPermissionFromTime = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["Permission_FromTime"]);
                            dtPermissionToTime = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["Permission_ToTime"]);
                            dsShiftId = objPermissionEventData.GetShiftID(strEmployeeCodeId, dtPermissionDate.Year, dtPermissionDate.Month, dtPermissionDate.Day);
                            intShiftId = Convert.ToInt32(dsShiftId.Tables[0].Rows[0][0]);
                            string StatusPermissionDate = dtPermissionDate.ToShortDateString();
                            strPermissionStatus = PermissionStatusonShift(StatusPermissionDate, intShiftId, dtPermissionFromTime, dtPermissionToTime);
                            if (strPermissionStatus != "First Half")
                            {
                                if (Convert.ToString(ddl_SessionFrom.SelectedValue) == "First half")
                                {
                                    Message(rm.GetString("Msg_LeaveAfterPermission", objCultureInfo));
                                    return;
                                }
                            }
                        }
                    }
                }
            }
            if (dsLeavePolicy.Tables[0].Rows.Count > 0)
            {
                if (Convert.ToString(dsLeavePolicy.Tables[0].Rows[0]["PermissionAfterLeave"]) == "False")
                {
                    dsChecking = objLeaveApplicationEventData.CheckLeaveBeforeAfterWithPermission(DateTime.Parse(strFromDate).ToShortDateString(), DateTime.Parse(strToDate).ToShortDateString(), "LeaveBeforePermission", Convert.ToInt32(hdnEmployeeId.Value));
                    if (dsChecking.Tables.Count > 0)
                    {
                        if (dsChecking.Tables[0].Rows.Count > 0)
                        {
                            dtPermissionDate = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["permission_Date"]);
                            dtPermissionFromTime = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["Permission_FromTime"]);
                            dtPermissionToTime = Convert.ToDateTime(dsChecking.Tables[0].Rows[0]["Permission_ToTime"]);
                            dsShiftId = objPermissionEventData.GetShiftID(strEmployeeCodeId, dtPermissionDate.Year, dtPermissionDate.Month, dtPermissionDate.Day);
                            intShiftId = Convert.ToInt32(dsShiftId.Tables[0].Rows[0][0]);
                            string StatusPermissionDate = dtPermissionDate.ToShortDateString();
                            strPermissionStatus = PermissionStatusonShift(StatusPermissionDate, intShiftId, dtPermissionFromTime, dtPermissionToTime);
                            if (strPermissionStatus == "First Half")
                            {
                                if (strFromDate == strToDate)
                                {
                                    if (Convert.ToString(ddl_SessionFrom.SelectedValue) == "First half" && Convert.ToString(ddl_SessionTo.SelectedValue) == "First half")
                                    {
                                    }
                                    else
                                    {
                                        Message(rm.GetString("Msg_LeaveBeforePermission", objCultureInfo));
                                        return;
                                    }
                                }
                                else
                                {
                                    if (Convert.ToString(ddl_SessionTo.SelectedValue) != "First half")
                                    {
                                        Message(rm.GetString("Msg_LeaveBeforePermission", objCultureInfo));
                                        return;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            DataSet dsCheckLeave = new DataSet();
            dsCheckLeave = objLeaveApplicationEventData.CheckLeaveBeforeAfterWithPermission(DateTime.Parse(strFromDate).ToShortDateString(), DateTime.Parse(strToDate).ToShortDateString(), "LeaveOnPermission", Convert.ToInt32(hdnEmployeeId.Value));
            if (dsCheckLeave.Tables.Count > 0)
            {
                if (dsCheckLeave.Tables[0].Rows.Count > 0)
                {
                    Message(rm.GetString("Msg_PermissionApplied", objCultureInfo));
                    return;
                }
            }
            if (intInsertFlag == 0)
            {
                intcount = objLeaveApplicationEventData.CheckLeaveApplication(Convert.ToInt32(hdnEmployeeId.Value), strFromDate, strToDate);
                intHalfDayCount = objLeaveApplicationEventData.CheckHalfDayLeave(Convert.ToInt32(hdnEmployeeId.Value), strFromDate, strToDate, strSessionFrom, strSessionTo);
                int PermissionCount = 0;
                PermissionCount = objLeaveApplicationEventData.CheckLeaveWithPermission(strFromDate, strToDate, Convert.ToInt32(hdnEmployeeId.Value));
                if (PermissionCount > 0)
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_PermissionappliedDates", objCultureInfo) + "');", true);
                    return;
                }
                if (intcount == 0 || intHalfDayCount == 0)
                {
                    intEmployeeId = Convert.ToInt32(hdnEmployeeId.Value);
                    if (ddl_Type.SelectedValue == "Comp Off" || ddl_Type.SelectedValue == "ESI")
                        intLeaveTypeId = 0;
                    else
                        intLeaveTypeId = Convert.ToInt32(hdnTxtLeaveTypeId.Value);
                    strTypeOfLeave = ddl_Type.SelectedValue;
                    strReason = txtReason.Text.Trim().Replace("'", "''");
                    int intIsBorrow = 0;
                    if (chkBorrowLeave.Checked == true)
                        intIsBorrow = 1;
                    string strLeaveStatus = string.Empty;
                    string strLeaveStatusNew = string.Empty;
                    int leaveSanctionExists = 0;
                    int approvalSettingsPageExists = 0;
                    leaveSanctionExists = objClassCommon.CheckPageExistsInLicense(248);
                    //Checking grade module is available or not and changed the id value from 110 to 228
                    approvalSettingsPageExists = objClassCommon.CheckPageExistsInLicense(228);
                    if (leaveSanctionExists == 1)
                    {
                        if (approvalSettingsPageExists == 1)
                        {
                            int intCompanyId = base.GetCompanyId(intEmployeeId);
                            DataSet dsApprovalSettings = new DataSet();
                            ShiftEvenData objShift = new ShiftEvenData();
                            dsApprovalSettings = objShift.SelectApprovalSettings(intCompanyId);
                            if (dsApprovalSettings != null)
                                if (dsApprovalSettings.Tables.Count > 0)
                                    if (dsApprovalSettings.Tables[0].Rows.Count > 0)
                                    {
                                        if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0]["LeaveSanction"]) == false)
                                            strLeaveStatus = "Approved";
                                        else
                                        {
                                            strLeaveStatusNew = objShift.GetApprovalStatus(Convert.ToInt32(Session["EmpAutoID"]), Convert.ToString(hdnEmployeeId.Value), Convert.ToBoolean(Session["ReportsBasedOn"]));
                                            if (strLeaveStatusNew != string.Empty && strLeaveStatusNew != null)
                                                strLeaveStatus = strLeaveStatusNew;
                                        }
                                    }
                                    else
                                    {
                                        ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_ApprovalSettings", objCultureInfo) + "');", true);
                                        return;
                                    }
                        }
                    }
                    else
                        strLeaveStatus = "Approved";
                    DataSet dsLeaveApp = new DataSet();
                    string strEmployeeEmailId = string.Empty;
                    DataSet dsYearSettingsid = new DataSet();
                    dsYearSettingsid = objEmployeeEventData.GetYearSettingsId(strFromDate, strToDate);
                    #region InsertLeaveApplication
                    if (dsYearSettingsid.Tables[0].Rows.Count > 0)
                    {
                        if (Convert.ToString(dsYearSettingsid.Tables[0].Rows[0][0]) != "Apply Induvial records")
                            dsLeaveApp = objLeaveApplicationEventData.InsertLeaveApplication(intEmployeeId, strApplicationDate, intLeaveTypeId, strTypeOfLeave, strFromDate, strToDate, strSessionFrom, strSessionTo, Decimal.Parse(dblNumberOfDaysApplied.ToString()), strReason, intIsBorrow, Convert.ToString(Session["EmpAutoId"]), Convert.ToString(dsYearSettingsid.Tables[0].Rows[0][0]), strLeaveStatus, intSuccessiveyear, Convert.ToString(Intervening.Value));
                        else
                        {
                            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_ApplySeparateLeaveforFromdateandToDate", objCultureInfo) + "');", true);
                            return;
                        }
                    }
                    else
                    {
                        ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_ApplyLeaveonavailableYearsettingsDays", objCultureInfo) + "');", true);
                        return;
                    }
                    if (Convert.ToString(dsLeaveApp.Tables[0].Rows[0]["LeaveApplicationId"]) != "")
                        intLeaveApplicationId = Convert.ToInt32(dsLeaveApp.Tables[0].Rows[0]["LeaveApplicationId"]);
                    if (Convert.ToString(dsLeaveApp.Tables[0].Rows[0]["LeaveApplicationStatus"]) != "")
                        LeaveApplicationStatus = Convert.ToString(dsLeaveApp.Tables[0].Rows[0]["LeaveApplicationStatus"]);
                    if (Convert.ToString(dsLeaveApp.Tables[0].Rows[0]["LevelID"]) != "")
                        LevelID = Convert.ToInt32(dsLeaveApp.Tables[0].Rows[0]["LevelID"]);
                    DataTable dtSanctionView = new DataTable();
                    dtSanctionView = objLeaveApplicationEventData.GetLeaveApplicationByLeaveApplicationId(intLeaveApplicationId);
                    string strLeaveCategoryType = string.Empty;
                    if (Convert.ToString(dtSanctionView.Rows[0]["LeaveType"]) != "")
                        strLeaveCategoryType = Convert.ToString(dtSanctionView.Rows[0]["LeaveType"]);
                    if (Convert.ToString(dtSanctionView.Rows[0]["emailId"]) != "")
                        strEmployeeEmailId = Convert.ToString(dtSanctionView.Rows[0]["emailId"]);
                    if (strLeaveStatus == "Approved")
                    {
                        if (strTypeOfLeave == "Leave")
                        {
                            if (intIsBorrow == 0)
                                objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(Convert.ToDouble(dblNumberOfDaysApplied), intLeaveTypeId, intEmployeeId, "A", Convert.ToInt32(Session["EmpAutoId"]), Convert.ToInt16(dsYearSettingsid.Tables[0].Rows[0][0]));
                            else
                                objLeaveApplicationEventData.UpdateYearClosureByLeaveSanction(Convert.ToDouble(dblNumberOfDaysApplied), intLeaveTypeId, intEmployeeId, "AB", Convert.ToInt32(Session["EmpAutoId"]), Convert.ToInt16(dsYearSettingsid.Tables[0].Rows[0][0]));
                        }
                        objLeaveApplicationEventData.UpdateProcessedDataFlag(intEmployeeId, strFromDate, strToDate, 0);
                    }
                    #endregion
                    #region EmailTriggering                    
                    blnCheckEmail = objClassCommon.PrepareEmailContentForMailTriggering(strEmployeeCodeId, strEmployeeName, strlevelName, Convert.ToString(LevelID), "", "", strReason, strEmployeeEmailId, LeaveApplicationStatus, "", "", "", "", "", strLeaveCategoryType, lblLeaveApplicationDateData.Text, txtFromDate.Text, txtToDate.Text, ddl_SessionFrom.SelectedItem.Text, ddl_SessionTo.SelectedItem.Text, Convert.ToString(dblNumberOfDaysApplied), Convert.ToString(intLeaveApplicationId), "", "", "", "LeaveApplication", intEmployeeId);
                    #endregion
                    #region SMSNotification
                    try
                    {
                        int smsIsRequired = 0;
                        //To check SMS Template is available in page table or not. if no then it will skip the SMS Triggering portion.
                        //244 is template page id
                        smsIsRequired = objClassCommon.CheckPageExistsInLicense(244);
                        if (smsIsRequired > 0)
                        {
                            DataSet dsGateway = new DataSet();
                            DataSet dsStatus = new DataSet();
                            bool isSmsEnabledForEmployee = false;
                            string destinationKey = string.Empty;
                            string MessageKey = string.Empty;
                            string ServiceUrl = string.Empty;
                            string mobileNo = string.Empty;
                            string strTemplateName = string.Empty;
                            bool isApplyAndReceiverSame = false;
                            string empName = string.Empty;
                            if (LeaveApplicationStatus == "Pending")
                            {
                                strTemplateName = "Leave Application - Apply";
                            }
                            else if (LeaveApplicationStatus == "Forwarded")
                            {
                                strTemplateName = "Leave Application - Forward";
                            }
                            else if (LeaveApplicationStatus == "Approved")
                            {
                                strTemplateName = "Leave Application - Approved";
                            }
                            dsStatus = objsms.GetTemplateStauts(strTemplateName);
                            string strConvertedMessage = string.Empty;
                            if (dsStatus.Tables.Count > 0)
                            {
                                if (dsStatus.Tables[0].Rows.Count > 0 && Convert.ToBoolean(dsStatus.Tables[0].Rows[0]["Status"]) != false)
                                {
                                    dsGateway = objsms.SelectGatewayDetails();
                                    if (dsGateway.Tables.Count > 0)
                                    {
                                        if (dsGateway.Tables[0].Rows.Count > 0)
                                        {
                                            if (dsGateway.Tables[0].Rows[0]["ServiceUrl"] != null)
                                            {
                                                ServiceUrl = Convert.ToString(dsGateway.Tables[0].Rows[0]["ServiceUrl"]);
                                            }
                                            if (dsGateway.Tables[0].Rows[0]["DestinationKey"] != null)
                                            {
                                                destinationKey = Convert.ToString(dsGateway.Tables[0].Rows[0]["DestinationKey"]);
                                            }
                                            if (dsGateway.Tables[0].Rows[0]["MessageKey"] != null)
                                            {
                                                MessageKey = Convert.ToString(dsGateway.Tables[0].Rows[0]["MessageKey"]);
                                            }
                                            if (dsStatus.Tables[0].Rows[0]["ToEmployee"] != null)
                                            {
                                                isSmsEnabledForEmployee = Convert.ToBoolean(dsStatus.Tables[0].Rows[0]["ToEmployee"]);
                                            }
                                            if (isSmsEnabledForEmployee)
                                            {
                                                if (dtSanctionView.Rows.Count > 0)
                                                {
                                                    if (dtSanctionView.Rows[0]["Mobile_Number"] != null)
                                                    {
                                                        mobileNo = Convert.ToString(dtSanctionView.Rows[0]["Mobile_Number"]);
                                                    }
                                                    if (dtSanctionView.Rows[0]["Employee_FirstName"] != null)
                                                    {
                                                        empName = Convert.ToString(dtSanctionView.Rows[0]["Employee_FirstName"]);
                                                    }
                                                }
                                            }
                                            DataSet dsReceivers = new DataSet();
                                            string[] strleaveType = strLeaveCategoryType.Split('/');
                                            dsReceivers = objsms.GetReceiversDetails(strTemplateName, strEmployeeCodeId, strEmployeeName, strFromDate + " To " + strToDate, strleaveType[0], Convert.ToString(dblNumberOfDaysApplied));
                                            if (dsReceivers.Tables.Count > 0)
                                            {
                                                if (dsReceivers.Tables[1].Rows.Count > 0)
                                                {
                                                    foreach (DataRow dr in dsReceivers.Tables[1].Rows)
                                                    {
                                                        if (Convert.ToString(dr["Mobile_Number"]) != "")
                                                        {
                                                            blnCheckSMS = objsms.SendSMSNotifications
                                                                (
                                                                    ServiceUrl,
                                                                    destinationKey,
                                                                    MessageKey,
                                                                    Convert.ToString(dr["Receivers"]),
                                                                    Convert.ToString(dsReceivers.Tables[0].Rows[0]["Message"]),
                                                                    Convert.ToString(dr["Mobile_Number"]),
                                                                    strEmployeeCodeId,
                                                                    strTemplateName,
                                                                    Convert.ToString(dr["SwipeCardNo"])
                                                                );
                                                            if (Convert.ToString(dr["SwipeCardNo"]) == strEmployeeCodeId)
                                                            {
                                                                isApplyAndReceiverSame = true;
                                                            }
                                                        }
                                                        else
                                                        {
                                                            if (dsReceivers.Tables[0].Rows[0]["Message"] != null)
                                                            {
                                                                if (Convert.ToString(dsReceivers.Tables[0].Rows[0]["Message"]).Contains("{User Name}"))
                                                                {
                                                                    strConvertedMessage = Convert.ToString(dsReceivers.Tables[0].Rows[0]["Message"]).Replace("{User Name}", Convert.ToString(dr["Receivers"]));
                                                                }
                                                            }
                                                            objsms.InsertLogDetails(strTemplateName, Convert.ToString(dr["SwipeCardNo"]), strEmployeeCodeId, false, Convert.ToString(strConvertedMessage), "Mobile Number is not configured in employee master");
                                                            blnCheckSMS = false;
                                                        }
                                                    }
                                                }
                                            }
                                            //in add receiver textbox mentioned usergroups and employee usergroup is not same, that time we should check 
                                            //employee option has been enable in template for employees or not.
                                            if (mobileNo != string.Empty && isApplyAndReceiverSame != true)
                                            {
                                                blnCheckSMS = objsms.SendSMSNotifications
                                                                 (
                                                                    ServiceUrl,
                                                                    destinationKey,
                                                                    MessageKey,
                                                                    empName,
                                                                    Convert.ToString(dsReceivers.Tables[0].Rows[0]["Message"]),
                                                                    Convert.ToString(mobileNo),
                                                                    strEmployeeCodeId,
                                                                     strTemplateName,
                                                                Convert.ToString(strEmployeeCodeId)

                                                                );

                                            }
                                            else if (mobileNo == string.Empty && isApplyAndReceiverSame != true)
                                            {
                                                if (isSmsEnabledForEmployee)
                                                {
                                                    objsms.InsertLogDetails(strTemplateName, Convert.ToString(strEmployeeCodeId), strEmployeeCodeId, false, Convert.ToString(dsReceivers.Tables[0].Rows[0]["Message"]), "Mobile Number is not configured in employee master");
                                                    blnCheckSMS = false;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            blnCheckSMS = true;
                        }
                    }
                    catch (Exception ex)
                    {
                        throw ex;
                    }
                    #endregion
                    if (blnCheckEmail == true && blnCheckSMS == true)
                        MessageWithreplace(rm.GetString("Alert_LeaveApplicationSaved", objCultureInfo), "TA_UI_Transactions_LeaveApplication.aspx");
                    else if (blnCheckEmail == false && blnCheckSMS == true)
                        MessageWithreplace(rm.GetString("Alert_LeaveApplicationSavedEmailnotsent", objCultureInfo), "TA_UI_Transactions_LeaveApplication.aspx");
                    else if (blnCheckEmail == true && blnCheckSMS == false)
                        MessageWithreplace(rm.GetString("Alert_LeaveApplicationSavedbutSMSisnottriggered", objCultureInfo), "TA_UI_Transactions_LeaveApplication.aspx");
                    else
                        MessageWithreplace(rm.GetString("Alert_LeaveApplicationSavedEmailnotsent", objCultureInfo), "TA_UI_Transactions_LeaveApplication.aspx");
                }
                else
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_AlreadyApplied", objCultureInfo) + "');", true);
                    ddl_Type.SelectedIndex = 0;
                }
            }
            else
            {
                return;
            }
        }
    }

    #endregion

    #region Permissions the statuson shift.
    protected string PermissionStatusonShift(string PermissionDate, int shiftId, DateTime PermissionFromTime, DateTime PermissionToTime)
    {
        DataSet dsShiftDetails = new DataSet();
        string ShiftStartTime = string.Empty;
        string ShiftEndTime = string.Empty;
        string ShiftFirstHalfStart = string.Empty;
        string ShiftFirstHalfEnd = string.Empty;
        string ShiftSecondHalfStart = string.Empty;
        string ShiftSecondHalfEnd = string.Empty;
        string status = string.Empty;
        DateTime dtShiftFirstHalfStart = new DateTime();
        DateTime dtShiftFirstHalfEnd = new DateTime();
        DateTime dtShiftSecondHalfStart = new DateTime();
        DateTime dtShiftSecondHalfEnd = new DateTime();
        dsShiftDetails = objPermissionEventData.GetShiftTime(shiftId);
        if (dsShiftDetails.Tables.Count > 0)
        {
            if (dsShiftDetails.Tables[0].Rows.Count > 0)
            {
                if (dsShiftDetails.Tables[0].Rows[0]["shift_StartTime"] != DBNull.Value)
                {
                    ShiftStartTime = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["shift_StartTime"]);
                }
                if (dsShiftDetails.Tables[0].Rows[0]["shift_EndTime"] != DBNull.Value)
                {
                    ShiftEndTime = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["shift_EndTime"]);
                }
                if (dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_StartTime"] != DBNull.Value)
                {
                    dtShiftFirstHalfStart = DateTime.Parse(PermissionDate + " " + Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_StartTime"]));
                    ShiftFirstHalfStart = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_StartTime"]);
                }
                if (dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_EndTime"] != DBNull.Value)
                {
                    dtShiftFirstHalfEnd = DateTime.Parse(PermissionDate + " " + Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_EndTime"]));
                    ShiftFirstHalfEnd = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_FirstHalf_EndTime"]);
                }
                if (dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_StartTime"] != DBNull.Value)
                {
                    dtShiftSecondHalfStart = DateTime.Parse(PermissionDate + " " + Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_StartTime"]));
                    ShiftSecondHalfStart = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_StartTime"]);
                }
                if (dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_EndTime"] != DBNull.Value)
                {
                    dtShiftSecondHalfEnd = DateTime.Parse(PermissionDate + " " + Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_EndTime"]));
                    ShiftSecondHalfEnd = Convert.ToString(dsShiftDetails.Tables[0].Rows[0]["Shift_SecondHalf_EndTime"]);
                }
                if (ShiftStartTime.Substring(6, 2) == "PM" && ShiftEndTime.Substring(6, 2) == "AM")
                {
                    if (ShiftFirstHalfEnd != string.Empty)
                    {
                        if (ShiftFirstHalfEnd.Substring(6, 2) == "AM")
                        {
                            dtShiftFirstHalfEnd.AddDays(1);
                        }
                    }
                    if (ShiftSecondHalfStart != string.Empty)
                    {
                        if (ShiftSecondHalfStart.Substring(6, 2) == "AM")
                        {
                            dtShiftSecondHalfStart.AddDays(1);
                        }
                    }
                    if (ShiftSecondHalfEnd != string.Empty)
                    {
                        if (ShiftSecondHalfEnd.Substring(6, 2) == "AM")
                        {
                            dtShiftSecondHalfEnd = dtShiftSecondHalfEnd.AddDays(1);
                        }
                    }
                }
            }
        }
        if ((PermissionFromTime >= dtShiftFirstHalfStart && PermissionFromTime <= dtShiftFirstHalfEnd) && (PermissionToTime >= dtShiftFirstHalfStart && PermissionToTime <= dtShiftFirstHalfEnd))
        {
            status = "First Half";
        }
        else if ((PermissionFromTime >= dtShiftSecondHalfStart && PermissionFromTime <= dtShiftSecondHalfEnd) && (PermissionToTime >= dtShiftSecondHalfStart && PermissionToTime <= dtShiftSecondHalfEnd))
        {
            status = "Second Half";
        }
        return status;
    }
    #endregion
    protected void btn_cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Transactions_LeaveApplication.aspx");
    }
    #region Compare ToDate with FromDate
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strFromDateTime = objClassCommon.DateTimeConvertion((gstrDateFormat), txtFromDate.Text, "D");
            strToDateTime = objClassCommon.DateTimeConvertion((gstrDateFormat), txtToDate.Text, "D");
            DateTime dtToDate = DateTime.Parse(strToDateTime);
            DateTime dtFromDate = DateTime.Parse(strFromDateTime);
            TimeSpan diff = dtToDate.Subtract(dtFromDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex.ToString());
        }
    }
    #endregion
    #region Compare FromMonth With Current Month.
    public void CompareCurrentdate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strFromDateTime = objClassCommon.DateTimeConvertion((gstrDateFormat), txtFromDate.Text, "D");
            DateTime dtCurrentDate = DateTime.Now;
            DateTime dtFromDate = DateTime.Parse(strFromDateTime);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex.ToString());
        }
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
        {
            e.IsValid = true;
        }
    }
    #endregion
    #region Compare Tomonth with Current Month.
    public void CompareTodate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strToDateTime = objClassCommon.DateTimeConvertion((gstrDateFormat), txtToDate.Text, "D");
            DateTime dtCurrentDate = DateTime.Now;
            DateTime dtToDate = DateTime.Parse(strToDateTime);
            TimeSpan diff = dtToDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                e.IsValid = false;
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex.ToString());
        }
        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
        {
            e.IsValid = true;
        }
    }
    #endregion
    #region Checks the restricted holiday count.
    public void CheckRestrictedHolidayCount()
    {
        int HolidayId = Convert.ToInt32(hdnTxtLeaveTypeId.Value);
        gintCount = objLeaveApplicationEventData.CheckLeaveApplicationRestrictedHolidays(Convert.ToInt32(hdnEmployeeId.Value), HolidayId);
        if (gintCount > 0)
        {
            intInsertFlag = -1;
            base.Message(rm.GetString("Msg_RestirctHolidays", objCultureInfo));
        }
        gintCount = 0;
    }
    #endregion
    #region Handles the SelectedIndexChanged event of the ddlEmployeeNames control.
    #endregion
    #region Getting Information from resource file and display it in label.
    private void LoadStrings(CultureInfo ci)
    {
        lblEmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblEmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lblempname.Text = rm.GetString("Field_EmployeeName", ci);
        lblFromDate.Text = rm.GetString("email_FromDate", ci);
        lblLeave.Text = rm.GetString("LeaveApplication_Leave", ci);
        lblLeaveApplicationDate.Text = rm.GetString("LeaveApplication_LeaveApplicationDate", ci);
        lblLeaveRestrictedHoliday.Text = rm.GetString("LeaveApplication_LeaveRestrictedHoliday", ci);
        lblLeaveType.Text = rm.GetString("lbl_leavetype", ci);
        lblNumberofdaysapplied.Text = rm.GetString("LeaveApplication_NumberOfDaysApplied", ci);
        lblReason.Text = rm.GetString("email_Reason", ci);
        lblRemainingNumberofLeave.Text = rm.GetString("LeaveApplication_RemainingNumberOfLeave", ci);
        lblToDate.Text = rm.GetString("email_ToDate", ci);
        lblIndicatesMandatoryFields.Text = rm.GetString("IndicatesMandatoryFields", ci);
        CustomValidator1.ErrorMessage = rm.GetString("Alert_SelectvalidFromDate", ci);
        cus_ComDate.ErrorMessage = rm.GetString("Msg_GrearterThanFrmDate", ci);
        CustomValidator2.ErrorMessage = rm.GetString("Alert_SelectvalidToDate", ci);
        lbl_HeaderLeaveApplication.Text = rm.GetString("Transactions_LeaveApplication", ci);
        chkBorrowLeave.Text = rm.GetString("Transactions_LeaveBorrow", ci);
        lblApplicationYear.Text = rm.GetString("Transactions_LeaveApplicationYear", ci);//mar19
        btnAdd.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btnCancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
        lblSelectEmployee.Text = rm.GetString("lblSelectEmployee", ci);
        btnQuota.Text = "";
        rbtnCurrentYear.Text = rm.GetString("YearSetting_CurrentYear", ci);//mar19
        rbtnSuccessiveYear.Text = rm.GetString("Transaction_SucessiveYear", ci);//mar19
        ddl_SessionFrom.Items[0].Text = rm.GetString("Select", ci);
        ddl_SessionFrom.Items[1].Text = rm.GetString("Caption_Firsthalf", ci);
        ddl_SessionFrom.Items[2].Text = rm.GetString("Caption_Secondhalf", ci);
        ddl_SessionTo.Items[0].Text = rm.GetString("Select", ci);
        ddl_SessionTo.Items[1].Text = rm.GetString("Caption_Firsthalf", ci);
        ddl_SessionTo.Items[2].Text = rm.GetString("Caption_Secondhalf", ci);
        lblSession.Text = rm.GetString("email_Session", ci);
        ddl_Type.Items[0].Text = rm.GetString("Select", ci);
        ddl_Type.Items[1].Text = rm.GetString("LeaveApplication_Leave", ci);
        ddl_Type.Items[2].Text = rm.GetString("Holiday_RestrictedHoliday", ci);
        ddl_Type.Items[3].Text = rm.GetString("Caption_CompOff", ci);
        ddl_Type.Items[4].Text = rm.GetString("lbl_LOP", ci);
        ddl_LeaveType.Items[0].Text = rm.GetString("Select", ci);
        lblLoading.Text = rm.GetString("ProgressBarText", ci);
        lblEmpId.Text = rm.GetString("Field_EmployeeID", ci);
    }
    #endregion
    #region Users rights.
    private void UserRights()
    {
        dsCheckuser = objCheckUser.checkRights(22, Convert.ToInt32(Session["userGroup_Id"]), "addPrv");
        if (dsCheckuser.Tables[0].Rows.Count == 0)
            Response.Redirect("TransactionLandingPage.aspx");
    }
    #endregion
    #region Message.
    private void Message(string messageContent)
    {
        string strScript = "<script language='javascript' type='text/javascript'>";
        strScript += "alert('" + messageContent + "');";
        strScript += " </script>";
        ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", strScript, false);
    }
    #endregion
}