using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Globalization;
using System.Threading;
using System.Reflection;
using System.Resources;
using System.Threading;
using DevExpress.Web;
/****************************************************************************************************************************
* Project Name    : TimeCheck                         Started Date  : 12-Aug-2007
* Module          : Permission Application            Last Modified : 14-Aug-2007
* Programmer      : Prabakaran.P
* Current Storage : \\Angler56\Projects\Inprogress\SCREEN1206\code\Time_AttendanceApp
* BackUp          :
****************************************************************************************************************************/
public partial class Transactions_TA_UI_Transactions_LeavePermission : Base.BasePage
{
    #region "Variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    LeaveApplicationEventData objLeaveApplicationEventData = new LeaveApplicationEventData();
    PermissionEventData objPermissionEventData = new PermissionEventData();
    cls_Common objClassCommon = new cls_Common();
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    string source_Language;
    string strFromTime, strEndTime, strReason, EmployeeEamilId, strFromEmailId, strEmailIdReportingTo, gstrDateFormat, gstrTimeFormat, strApplicationDate, strFromDateTime, strToDateTime, strlevelName;
    string MaxPermitHours, strStatusType;
    DataSet ds_EmployeeDetails = new DataSet();
    DataSet dsEmailIdOfSanctionAuthority = new DataSet();
    DataSet ds_EmailIdOfReportingTo = new DataSet();
    int payrollConfig = 0;
    string dNumberOfHoursApplied, dNoOfRemainingHours, EmpID;
    #endregion
    #region Page Load Event
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        grv_Permission.Styles.CssFilePath = Convert.ToString(Session["GridCSS"]);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            objClassCommon.menu("PermissionTransaction", "23");
        }
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_FillDetails", ci) + "','" + rm.GetString("Alert_FillFromToDate", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        Userrights();
        DataSet dsEmployeeGroup = new DataSet();
        dsEmployeeGroup = objLeaveApplicationEventData.GetEmployeeGroupName(Convert.ToInt32(Session["EmpAutoId"]));
        payrollConfig = objClassCommon.CheckPageExistsInLicense(185);
        if (dsEmployeeGroup.Tables[0].Rows.Count > 0)
        {
            if (dsEmployeeGroup.Tables[0].Rows[0]["GroupName"].ToString() == "SuperAdmin" || Convert.ToString(Session["IndividualUsers"]) != "True")
            {
                grv_Permission.DataSourceID = "";
                grv_Permission.DataSourceID = ObjectDataSource2.ID;
                ViewState["GroupName"] = "SuperAdmin";
            }
            else
            {
                grv_Permission.DataSourceID = ObjectDataSource1.ID;
                grv_Permission.Columns[2].Visible = false;
                grv_Permission.Columns[3].Visible = false;
                grv_Permission.Columns[4].Visible = false;
                ViewState["GroupName"] = "Normal";
            }
        }
        else
        {
            grv_Permission.DataSourceID = ObjectDataSource1.ID;
            grv_Permission.Columns[2].Visible = false;
            grv_Permission.Columns[3].Visible = false;
            grv_Permission.Columns[4].Visible = false;
            ViewState["GroupName"] = "Normal";
        }
        if (!Page.IsPostBack)
        {
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            btn_Add.Focus();
        }
        if (ViewState["GroupName"] == "Normal")
        {
            trSwipeCardNo.Visible = false;
            trEmployeeDetails.Visible = false;
        }
    }
    #endregion
    #region User Defined Functions
    private void UserRights()
    {
        throw new Exception("The method or operation is not implemented.");
    }
    private void LoadStrings(CultureInfo ci)
    {
        lbl_Header.Text = rm.GetString("Menu_Transactions_Permission", ci);
        lbl_EmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lbl_EmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblTimePeriod.Text = rm.GetString("ShiftExchange_DateRange", ci);
        lblPermissionStartDate.Text = rm.GetString("Field_From", ci);
        lblPermissionEndDate.Text = rm.GetString("Field_To", ci);
        btn_Search.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Search", ci);
        btn_Clear.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Clear", ci);
        btn_Add.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Add", ci);
        grv_Permission.Columns[1].Caption = rm.GetString("LeaveApplication_LeaveApplicationDate", ci);
        grv_Permission.Columns[2].Caption = rm.GetString("Field_EmployeeID", ci);
        grv_Permission.Columns[3].Caption = rm.GetString("Field_EmployeeName", ci);
        grv_Permission.Columns[4].Caption = rm.GetString("LevelDetails_LevelName", ci);
        grv_Permission.Columns[5].Caption = rm.GetString("Report_Duration", ci);
        grv_Permission.Columns[6].Caption = rm.GetString("Field_Status", ci);
        grv_Permission.Columns[7].Caption = rm.GetString("Field_Reason", ci);
        grv_Permission.Columns[8].Caption = rm.GetString("email_Remarks", ci);
        lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        lblFilter.Text = rm.GetString("lblFilter", ci);

    }
    private void grid_RestoreDefault()
    {
        txt_EmpName.Text = string.Empty;
        txtEmployeeId.Text = string.Empty;
        txtPermissionStartDate.Text = string.Empty;
        txtPermissionEndDate.Text = string.Empty;
        txtSwipeCard.Text = string.Empty;
        grv_Permission.PageIndex = 0;
        if (ViewState["GroupName"].ToString() == "SuperAdmin")
        {
            grv_Permission.DataSourceID = ObjectDataSource2.ID;
        }
        else
        {
            grv_Permission.DataSourceID = ObjectDataSource1.ID;
        }
    }
    private void Userrights()
    {
        ds_Checkuser = objCheckUser.checkRights(23, Convert.ToInt32(Session["userGroup_Id"]), "");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["addPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["addPrv"]) == 1)
            {
                this.btn_Add.Visible = true;
            }
            else
            {
                this.btn_Add.Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["modifyPrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["modifyPrv"]) == 1)
            {
                this.grv_Permission.Columns[11].Visible = true;
            }
            else
            {
                this.grv_Permission.Columns[11].Visible = false;
            }
            if (ds_Checkuser.Tables[0].Rows[0]["deletePrv"] != DBNull.Value && Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["deletePrv"]) == 1)
            {
                this.grv_Permission.Columns[12].Visible = true;
            }
            else
            {
                this.grv_Permission.Columns[12].Visible = false;
            }
        }
        else
        {
            Response.Redirect("TransactionLandingPage.aspx");
        }
    }
    private void FillGrid_Search()
    {
        string empName = txt_EmpName.Text.Trim();
        txt_EmpName.Text = empName;
        string empId = txtEmployeeId.Text.Trim();
        txtEmployeeId.Text = empId;
        string strPermissionStartDate = txtPermissionStartDate.Text;
        string strPermissionEndDate = txtPermissionEndDate.Text;
        string gstrDateFormat = Session["MDateFormat"].ToString();
        strPermissionStartDate = objClassCommon.DateConvertion(gstrDateFormat, strPermissionStartDate);
        strPermissionEndDate = objClassCommon.DateConvertion(gstrDateFormat, strPermissionEndDate);
        bool boolErrorStatus = true;
        string strSwipeCard = "";
        strSwipeCard = txtSwipeCard.Text.ToString().Trim().Replace("'", "''");
        if (empName == string.Empty && empId == string.Empty && strPermissionStartDate == string.Empty && strPermissionEndDate == string.Empty && strSwipeCard == string.Empty && ViewState["GroupName"].ToString() == "SuperAdmin")
        {
            grv_Permission.DataSourceID = "";
            return;
            txt_EmpName.Focus();
            boolErrorStatus = true;
        }
        else
        {
            if (strPermissionStartDate == string.Empty && strPermissionEndDate == string.Empty)
            {
                boolErrorStatus = false;
            }
            else if (strPermissionStartDate != string.Empty && strPermissionEndDate != string.Empty)
            {
                if (Convert.ToDateTime(strPermissionEndDate).Date < Convert.ToDateTime(strPermissionStartDate).Date)
                {
                    base.Message(rm.GetString("Alert_FromDateLessThanToDate", ci));
                    grv_Permission.DataSourceID = "";
                    return;
                    boolErrorStatus = true;
                }
                else
                {
                    boolErrorStatus = false;
                }
            }
            else
            {
                grv_Permission.DataSourceID = "";
                return;
                boolErrorStatus = true;
            }
        }
        if (boolErrorStatus == true)
        {
            grid_RestoreDefault();
        }
        else
        {
            lbl_Error.Text = string.Empty;
            grv_Permission.PageIndex = 0;
            if (ViewState["GroupName"].ToString() == "SuperAdmin")
            {
                grv_Permission.DataSourceID = ObjectDataSource2.ID;
            }
            else
            {
                grv_Permission.DataSourceID = ObjectDataSource1.ID;
            }
        }
    }
    public void GetEmptyText(object sender, EventArgs e)
    {
        Label lblNoRecords = (Label)sender;
        lblNoRecords.Text = rm.GetString("Alert_Norecordsfound", ci);
    }
    #endregion
    #region Button Click Events
    protected void btn_Add_Click(object sender, EventArgs e)
    {
        Response.Redirect("TA_UI_Transactions_LeavePermissionAdd.aspx");
    }
    protected void btn_Clear_Click(object sender, EventArgs e)
    {
        grid_RestoreDefault();
        lbl_Error.Text = string.Empty;
    }
    protected void btn_Search_Click(object sender, EventArgs e)
    {
        Thread.Sleep(100);
        FillGrid_Search();
    }
    #endregion
    #region Gridview Events
    protected void grv_Permission_HtmlRowCreated(object sender, DevExpress.Web.ASPxGridViewTableRowEventArgs e)
    {
        base.Page_Load(sender, e);
        if (e.RowType == DevExpress.Web.GridViewRowType.Data)
        {
            source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
            rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
            ci = Thread.CurrentThread.CurrentCulture;
            string Lbl_EndTime = e.GetValue("Permission_ToTime").ToString();
            string Lbl_FromTime = Convert.ToString(e.GetValue("Permission_FromTime"));
            Label lbl_date = (Label)grv_Permission.FindRowCellTemplateControl(e.VisibleIndex, null, "AppDate");
            string TEndTime;
            TEndTime = DateTime.Parse(Lbl_EndTime).ToString(Session["MTimeFormat"].ToString());
            string TFromTime;
            TFromTime = DateTime.Parse(Lbl_FromTime).ToString(Session["MDateFormat"].ToString()) + "&nbsp;" + DateTime.Parse(Lbl_FromTime).ToString(Session["MTimeFormat"].ToString());
            TEndTime = TFromTime + " To " + TEndTime;
            if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
            {
                if (Convert.ToString(Session["IndividualUsers"]) == "True")
                {
                    e.Row.Cells[1].Text = TEndTime;
                    e.Row.Cells[1].Style.Add("color", "#5D5D5D");
                }
                else
                {
                    e.Row.Cells[4].Text = TEndTime;
                    e.Row.Cells[4].Style.Add("color", "#5D5D5D");
                }
            }
            else if (Convert.ToString(Session["IndividualUsers"]) == "True")
            {
                e.Row.Cells[1].Text = TEndTime;
                e.Row.Cells[1].Style.Add("color", "#5D5D5D");
            }
            else
            {
                e.Row.Cells[4].Text = TEndTime;
                e.Row.Cells[4].Style.Add("color", "#5D5D5D");
            }
            Label lbl_Status = (Label)grv_Permission.FindRowCellTemplateControl(e.VisibleIndex, null, "lbl_Status");
            if (lbl_Status.Text == "Approved")
            {
                lbl_Status.Text = rm.GetString("btn_Approved", ci);
            }
            else if (lbl_Status.Text == "Forwarded")
            {
                lbl_Status.Text = rm.GetString("btn_Forwarded", ci);
            }
            else if (lbl_Status.Text == "Pending")
            {
                lbl_Status.Text = rm.GetString("btn_Pending", ci);
            }
            else if (lbl_Status.Text == "Rejected")
            {
                lbl_Status.Text = rm.GetString("btn_Reject", ci);
            }
        }
    }
    #endregion    
    protected void btn_Delete_Click(object sender, EventArgs e)
    {
        try
        {
            int approvalSettingsPageExists = 0;
            int permissionid = 0;
            string strPermissionStatus = string.Empty;
            DataSet ds_PermissionApplication = new DataSet();

            LinkButton btn = sender as LinkButton;
            permissionid = Convert.ToInt32(btn.CommandName);
            ds_PermissionApplication = objPermissionEventData.SelectLeavePermissionByPermissionId(permissionid);
            if (ds_PermissionApplication.Tables.Count > 0)
            {
                if (ds_PermissionApplication.Tables[0].Rows.Count > 0)
                {
                    approvalSettingsPageExists = objClassCommon.CheckPageExistsInLicense(228);
                    if (approvalSettingsPageExists == 1)
                    {
                        int intCompanyId = base.GetCompanyId(Convert.ToInt32(ds_PermissionApplication.Tables[0].Rows[0]["Employee_Id"]));
                        DataSet dsApprovalSettings = new DataSet();
                        ShiftEvenData objShift = new ShiftEvenData();
                        dsApprovalSettings = objShift.SelectApprovalSettings(intCompanyId);
                        if (dsApprovalSettings != null)
                            if (dsApprovalSettings.Tables.Count > 0)
                                if (dsApprovalSettings.Tables[0].Rows.Count > 0)
                                {
                                    if (Convert.ToBoolean(dsApprovalSettings.Tables[0].Rows[0]["Approval"]) == false)
                                        strPermissionStatus = "ApprovalNotRequired";
                                }
                                else
                                {
                                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Msg_ApprovalSettings", ci) + "');", true);
                                    return;
                                }
                    }
                    else
                        strPermissionStatus = "ApprovalNotRequired";
                    if (Convert.ToString(Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_Status"])) == "Pending" || strPermissionStatus == "ApprovalNotRequired")
                    {
                        objPermissionEventData.Delete_PermissionApplication(permissionid, Convert.ToInt32(Session["EmpAutoId"]));
                        MailToReportingTo(ds_PermissionApplication);
                        string strScript = string.Empty;
                        strScript = strScript + "<script language='javascript'>";
                        strScript = strScript + "alert('" + rm.GetString("Alert_PermissionApplicationDeleted", ci) + "');";
                        strScript = strScript + "location.replace('TA_UI_Transactions_LeavePermission.aspx');";
                        strScript = strScript + "</script>";
                        ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", strScript, false);
                    }
                    else
                    {
                        if (Convert.ToString(Session["UserGroupName"]) == "SuperAdmin" || Convert.ToString(Session["HasSpecialRights"]) == "True")
                        {
                            if (Convert.ToString(Session["IndividualUsers"]) == "True")
                            {
                                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_CannotdeletethisrecordPermission", ci) + "');", true);
                                return;
                            }
                            else
                            {
                                objPermissionEventData.Delete_PermissionApplication(permissionid, Convert.ToInt32(Session["EmpAutoId"]));
                                gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
                                if (ds_PermissionApplication.Tables.Count > 0)
                                {
                                    if (ds_PermissionApplication.Tables[0].Rows.Count > 0)
                                    {
                                        strApplicationDate = objClassCommon.DateConvertion(gstrDateFormat, (DateTime.Parse(Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_Date"]))).ToString(Convert.ToString(Session["MDateFormat"])));
                                        string strPermissionDate = strApplicationDate;
                                        if (strPermissionStatus == "ApprovalNotRequired")
                                        {
                                            objLeaveApplicationEventData.UpdateProcessedDataFlag(Convert.ToInt32(ds_PermissionApplication.Tables[0].Rows[0]["Employee_Id"]), strPermissionDate, strPermissionDate, 0);
                                        }
                                    }
                                }
                                MailToReportingTo(ds_PermissionApplication);
                                string strScript = string.Empty;
                                strScript = strScript + "<script language='javascript'>";
                                strScript = strScript + "alert('" + rm.GetString("Alert_PermissionApplicationDeleted", ci) + "');";
                                strScript = strScript + "location.replace('TA_UI_Transactions_LeavePermission.aspx');";
                                strScript = strScript + "</script>";
                                ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", strScript, false);
                            }
                        }
                        else
                        {
                            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_CannotdeletethisrecordPermission", ci) + "');", true);
                            return;
                        }
                    }
                }
            }
        }
        catch
        {
            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "alert('" + rm.GetString("Alert_CannotdeletethisrecordPermission", ci) + "');", true);
        }
    }
    private void MailToReportingTo(DataSet ds_PermissionApplication)
    {
        if (ds_PermissionApplication.Tables.Count > 0)
        {
            if (ds_PermissionApplication.Tables[0].Rows.Count > 0)
            {
                string strEmployeeEmailId = string.Empty;
                string strEmailIdSanctioningAuthority = string.Empty;
                gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
                gstrTimeFormat = Convert.ToString(Session["MTimeFormat"]);
                strStatusType = "deleted";
                ds_EmployeeDetails = objLeaveApplicationEventData.GetEmployeeDetails(Convert.ToInt32(ds_PermissionApplication.Tables[0].Rows[0]["Employee_Id"]));
                if (ds_EmployeeDetails.Tables[0].Rows.Count > 0)
                {
                    strlevelName = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["levelName"]);
                    strEmployeeEmailId = Convert.ToString(ds_EmployeeDetails.Tables[0].Rows[0]["emailId"]);
                }
                string strDateTimeFormat = Convert.ToString(Session["MDateFormat"]) + " " + Convert.ToString(Session["MTimeFormat"]);
                string strStartTime = Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_FromTime"]);
                string strEndTime = Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_ToTime"]);
                strFromDateTime = Convert.ToDateTime(strStartTime).ToString(strDateTimeFormat);
                strToDateTime = Convert.ToDateTime(strEndTime).ToString(strDateTimeFormat);
                dNumberOfHoursApplied = CalculateNumberOfHoursApplied(strFromDateTime, strToDateTime);
                objClassCommon.PrepareEmailContentForMailTriggering
                    (
                    Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["employee_Code_id"]),
                        Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Employee_firstname"]),
                        strlevelName,
                        "",
                       Convert.ToString(payrollConfig),
                        "",
                        Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_Reason"]),
                        strEmployeeEmailId,
                        "Deleted",
                        Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_Hours"]),
                        (DateTime.Parse(Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_Date"]))).ToString(Convert.ToString(Session["MDateFormat"])),
                        strFromDateTime,
                        strToDateTime,
                        "",
                        "",
                        (DateTime.Parse(Convert.ToString(ds_PermissionApplication.Tables[0].Rows[0]["Permission_AppliedDate"]))).ToString(Convert.ToString(Session["MDateFormat"])),
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "", "PermissionApplication", Convert.ToInt32(ds_PermissionApplication.Tables[0].Rows[0]["Employee_Id"]));
            }
        }
    }
    public string CalculateNumberOfHoursApplied(string startTime, string EndTime)
    {
        TimeSpan tsDiff = new TimeSpan();
        DateTime dtmIn = DateTime.Parse(startTime);
        DateTime dtmOut = DateTime.Parse(EndTime);
        tsDiff = dtmOut.Subtract(dtmIn);
        string s = Convert.ToString(tsDiff);
        int sReturn = s.LastIndexOf(':');
        string RemainHours = s.Remove(sReturn);
        return (RemainHours);
    }
}
