﻿<%@ Page Language="C#" AutoEventWireup="true"
    MasterPageFile="~/MasterFile/TimeCheck.master"
    CodeFile="EmployeePanel.aspx.cs" Inherits="EmployeePanel" %>

<asp:Content ID="Content1" ContentPlaceHolderID="BodyContentPH" runat="Server">
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <link rel="stylesheet" href="plugins/fullcalendar/fullcalendar.min.css">
    <link rel="stylesheet" href="plugins/fullcalendar/fullcalendar.print.css" media="print">

    <script src="bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
    <link href="dist/css/bootstrap-responsive-tabs.css" rel="stylesheet" type="text/css">
    <script src="dist/js/jquery.bootstrap-responsive-tabs.min.js"></script>

    <script src="plugins/moment.min.js" type="text/javascript"></script>
    <script src="plugins/fullcalendar/fullcalendar.min.js"></script>
    <script src="js/GetNotification.js"></script>
    <script src="js/GetMycalendardata.js"></script>

    <script>
        function clickUserMycalendar() {
            $('#tablist a[href="#ctl00_BodyContentPH_tab1"]').tab('show');
            $('html, body').animate({ scrollTop: 0 }, 'slow');
        }
        function clickTeamcalendar() {
            $('#tablist a[href="#ctl00_BodyContentPH_tab2"]').tab('show');
            $('html, body').animate({ scrollTop: 0 }, 'slow');
        }

        function clickIndividualUser() {
            GetIndividualCalendar();
        }
        function clickTeam() {
            GetTeamCalendar(<%= Session["EmpAutoID"].ToString() %>);
        }

        document.onreadystatechange = function () {
            if (document.readyState === 'complete') {
                clickTeam();
                clickIndividualUser();
            }
        }
    </script>
    <section class="content-header">
        <h1 style="padding-right: 0px">
            <img src="dist/img/MyCalendar.png" style="padding-right: 10px; vertical-align: middle; padding-bottom: 2px" />
            <asp:Label ID="lbl_Header" runat="server" Text="User Profile"></asp:Label>
        </h1>
        <asp:SiteMapPath ID="site" runat="server" CssClass="breadcrumb">
            <NodeStyle CssClass="active" />
        </asp:SiteMapPath>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-3">
                <div class="box box-primary">
                    <div class="box-body box-profile">
                        <img class="profile-user-img img-responsive img-circle" src="LoginImage/emp-photo.png" alt="User profile picture">
                        <h3 class="profile-username text-center">Manikandan.R</h3>
                        <p class="text-muted text-center">Product Leader</p>
                        <ul class="list-group list-group-unbordered">
                            <li class="list-group-item">
                                <b>Reporting To</b> <a class="pull-right">1,322</a>
                            </li>
                            <li class="list-group-item">
                                <b>Sanction To</b> <a class="pull-right">543</a>
                            </li>
                        </ul>
                        <a href="#" class="btn btn-primary btn-block"><b>Edit Profile</b></a>
                    </div>
                </div>
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">My Team</h3>
                    </div>
                    <div class="box-body">
                    </div>
                </div>
                <div class="box box-primary">
                    <div class="box-header with-border">
                        <h3 class="box-title">Absent Team Member</h3>
                    </div>
                    <div class="box-body">
                    </div>
                </div>
            </div>
            <div class="col-md-9">
                <div class="nav-tabs-custom">
                    <ul class="nav nav-tabs">
                        <li class="active"><a href="#ctl00_BodyContentPH_tab1" data-toggle="tab">My Calendar</a></li>
                        <li><a href="#ctl00_BodyContentPH_tab2" data-toggle="tab">Team</a></li>
                        <li><a href="#recentSwipe" data-toggle="tab">My Recent Swipes</a></li>
                        <li><a href="#approval" data-toggle="tab">Pending Approvals</a></li>
                        <li><a href="#holday" data-toggle="tab">Holidays</a></li>                        
                        <li><a href="#balance" data-toggle="tab">My Balance Leaves</a></li>
                    </ul>
                    <div class="tab-content">
                        <div class="tab-pane" id="ctl00_BodyContentPH_tab1">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-8">
                                            <div class="col-md-12">
                                                <i class="fa fa-square" style="color: #008247; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblPresent" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #FF5151; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblAbsent" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #D0457B; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblLeave" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #FF7F00; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblHoliday" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #02749E; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblWeeklyOff" runat="server" />&nbsp;&nbsp;
                                                <i class="fa fa-square" style="color: #A9A9A9; font-size: 16px"></i>&nbsp;&nbsp;<asp:Label ID="lblcombination" runat="server" Text="Combined Attendance" />
                                            </div>
                                        </div>
                                        <div class="col-md-12">
                                            <div class="col-md-12">
                                                <div class="box box-primary">
                                                    <div class="box-body no-padding">
                                                        <div id="calendar"></div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="ctl00_BodyContentPH_tab2">
                            <div class="form-horizontal">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="col-md-12">
                                            <div class="box box-primary">
                                                <div class="box-body no-padding">
                                                    <div id="Teamcalendar"></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="tab-pane" id="recentSwipe">
                        </div>
                        <div class="tab-pane" id="approval">
                        </div>
                        <div class="tab-pane" id="balance">
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <script src="plugins/select2/select2.full.min.js"></script>
</asp:Content>
