﻿using System;
using System.Data;
using System.Globalization;
using System.IO;
using System.Resources;
using System.Security.Cryptography;
using System.Text;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Masters_UserProfile : Base.BasePage
{
    #region VariableDeclaration
    ResourceManager rm;
    CultureInfo ci;
    cls_Common objcommon = new cls_Common();
    EmployeeEventData objEmployee = new EmployeeEventData();
    cls_Common objCommon = new cls_Common();
    byte[] image;
    string gstrDateFormat = "";
    int EmployeeID;
    #endregion
    #region PageLoad
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        GC.Collect();
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;   
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "ChMaxLengthh('" + rm.GetString("Alert_Maximumlengthis250", ci) + "');";
        strSetAlert = strSetAlert + "ChMaxLength500Fun('" + rm.GetString("Alert_Maximumlengthis500", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_Enterchildrendetails") + "','" + rm.GetString("Alert_Enterspousedetails") + "','" + rm.GetString("Alert_EnterEmployeeFirstName") + "',";
        strSetAlert = strSetAlert + "'" + rm.GetString("Alert_InvalidDOB") + "','" + rm.GetString("Alert_EnterValidEmailId") + "');";
       
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlert_AjaxChild('" + rm.GetString("Alert_EntertheChildrenintherangeof1to10", ci) + "','" + rm.GetString("Alert_NoDetailsfoundinChild", ci) + "','" + rm.GetString("Alert_Errorinretrivingdetails", ci) + "','" + rm.GetString("Alert_InvalidChildDOB", ci) + "');";
        strSetAlert = strSetAlert + "SetAlert_AjaxSpouse('" + rm.GetString("Alert_EntertheSpouseintherangeof1to4", ci) + "','" + rm.GetString("Alert_NoDetailsfoundinspouse", ci) + "','" + rm.GetString("Alert_Errorinretrivingdetailsfromspouse", ci) + "','" + rm.GetString("Alert_InvalidSpouseDOB", ci) + "','" + rm.GetString("Alert_EntertheSpouseintherangeof1to4", ci) + "');";
        
        strSetAlert = strSetAlert + "Alert_LookUp('" + rm.GetString("Alert_Errorretrievingdatafromlookup", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        EmployeeID = Convert.ToInt32(Session["EmpAutoID"]);
        this.Page.RegisterStartupScript("pageldMod", "<script>var EmpID=" + EmployeeID + "</script>");
    
        if (!Page.IsPostBack)
        {
            // BindingEmployeeCategoryandType();
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            this.Page.RegisterStartupScript("pageld", "<script>var checkPageLoad=0</script>");
            txt_ChildrenNo.Attributes.Add("onchange", "ajaxfunctionModify(" + EmployeeID + ");");
            txt_SpouseNo.Attributes.Add("onchange", "ajaxfunctionModify_spouse(" + EmployeeID + ");");
         

            GetEmpDetailsbyID(Convert.ToInt32(Session["EmpAutoID"]));
          
            Page.RegisterStartupScript("upload", "<script>ajaxfunctionModify(" + EmployeeID + ")</script>");
            Page.RegisterStartupScript("spouse", "<script>ajaxfunctionModify_spouse(" + EmployeeID + ")</script>");
            txt_ChildrenNo.Attributes.Add("onkeypress", "javascript:return number_only(event,this);");
            txt_SpouseNo.Attributes.Add("onkeypress", "javascript:return number_only(event,this);");
            objcommon.menu("EmployeeMaster", "18");
        }
        else
        {
            this.Page.RegisterStartupScript("pageload", "<script>var checkPageLoad=1</script>");
        }
    }
    #endregion
   
   
    #region GetEmployeeDetails
    private void GetEmpDetailsbyID(int Empid)
    {
        string detenew = DateTime.Today.ToShortDateString();
        DataSet ds_Empdetails = new DataSet();
        ds_Empdetails = objEmployee.Select_EmployeeDetailsbyId(Empid);
        string strEmployeeName = string.Empty;
      
        if (ds_Empdetails != null)
        {
            if (ds_Empdetails.Tables[0].Rows.Count > 0)
            {
                if (ds_Empdetails.Tables[0].Rows[0]["Employee_FirstName"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_FirstName"]) != "")
                {
                    strEmployeeName = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_FirstName"]);
                    txt_FirstName.Text= Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_FirstName"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Employee_MiddleName"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_MiddleName"]) != "")
                {
                    //strEmployeeName +=" "+ Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_MiddleName"]);
                    txt_MiddleName.Text= Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_MiddleName"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Employee_LastName"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_LastName"]) != "")
                {
                    strEmployeeName +=" "+ Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_LastName"]);
                    txt_LastName.Text= Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Employee_LastName"]);
                }
                lbl_EmployeeName.Text = strEmployeeName;
                if (ds_Empdetails.Tables[0].Rows[0]["TitleName"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["TitleName"]) != "")
                {
                    lbldesignation.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["TitleName"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Father_name"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Father_name"]) != "")
                {
                    txt_FatherName.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Father_name"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Mother_name"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Mother_name"]) != "")
                {
                    txt_MotherName.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Mother_name"]);
                }
                DateTime date1 = new DateTime();
                if (ds_Empdetails.Tables[0].Rows[0]["DateofBirth"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["DateofBirth"]) != "")
                {
                    date1 = Convert.ToDateTime(ds_Empdetails.Tables[0].Rows[0]["DateofBirth"]);
                    txt_dob.Text = date1.ToString(Convert.ToString(Session["MDateFormat"]));
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Blood_Group"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Blood_Group"]) != "")
                {
                    txt_BloodGroup.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Blood_Group"]);
                }
               
                if (ds_Empdetails.Tables[0].Rows[0]["Permanent_Address"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Permanent_Address"]) != "")
                {
                    txt_PermanentAddress.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Permanent_Address"]);
                }
               
                if (ds_Empdetails.Tables[0].Rows[0]["Mobile_Number"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Mobile_Number"]) != "")
                {
                    txt_MobileNo.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Mobile_Number"]);
                }

               
                if (ds_Empdetails.Tables[0].Rows[0]["Spouse_No"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Spouse_No"]) != "")
                {
                    txt_SpouseNo.Value = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Spouse_No"]);
                    if (txt_SpouseNo.Value == "0") txt_SpouseNo.Value = "";
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Children_No"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Children_No"]) != "")
                {
                    txt_ChildrenNo.Value = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Children_No"]);
                    if (txt_ChildrenNo.Value == "0") txt_ChildrenNo.Value = "";
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Photo"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Photo"]) != "")
                {
                    try
                    {
                        DirectoryInfo dir = new DirectoryInfo(AppDomain.CurrentDomain.BaseDirectory + "Masters");
                        FileInfo[] files = dir.GetFiles("*.bmp");
                        foreach (FileInfo file in files)
                        {
                            string str = AppDomain.CurrentDomain.BaseDirectory + "Masters\\";
                            File.Delete(str + Convert.ToString(file));
                        }
                        Random rnd = new Random();
                        string strPath = "Employee_Photo_" + Empid + ".bmp";
                        byte[] storedImage = (byte[])(ds_Empdetails.Tables[0].Rows[0]["Photo"]);
                        MemoryStream stream = new MemoryStream(storedImage);
                        System.Drawing.Image img = System.Drawing.Image.FromStream(stream);
                        img.Save(Server.MapPath(strPath));
                        img.Dispose();
                        imgUser.ImageUrl = strPath;
                    }
                    catch (Exception ex)
                    {
                        Response.Write(ex.ToString());
                    }
                }
                else
                {
                    imgUser.ImageUrl = "../LoginImage/emp-photo.png";
                }
                string strGender = "", strMstatus = "";
                if (ds_Empdetails.Tables[0].Rows[0]["Gender"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Gender"]) != "")
                {
                    strGender = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Gender"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Marital_status"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Marital_status"]) != "")
                {
                    strMstatus = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Marital_status"]);
                }
                if (ds_Empdetails.Tables[0].Rows[0]["Personal_mailid"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Personal_mailid"]) != "")
                {
                    txt_PersonalMailID.Text = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Personal_mailid"]);
                }
                string strpath = "";
                if (ds_Empdetails.Tables[0].Rows[0]["Photo"] != DBNull.Value && Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Photo"]) != string.Empty)
                {
                    strpath = Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Photo"]);
                }
                checkMstatus(strMstatus);
            }
            ds_Empdetails.Dispose();
        }
    }
    #endregion
    #region UserDefine
    private void checkMstatus(string mstatus)
    {
        if (mstatus == "Single")
        {
            rbtn_Single.Checked = true;
            txt_SpouseNo.Attributes.Add("style", "display:none");
            txt_ChildrenNo.Attributes.Add("style", "display:none");
            lbl_NoofSpouse.Attributes.Add("style", "display:none");
            lbl_NoofChildren.Attributes.Add("style", "display:none");
            txt_SpouseNo.Disabled = true;
            txt_ChildrenNo.Disabled = true;
        }
        if (mstatus == "Married")
        { 
            rbtn_Married.Checked = true;
            txt_SpouseNo.Attributes.Add("style", "display:block");
            txt_ChildrenNo.Attributes.Add("style", "display:block");
            lbl_NoofSpouse.Attributes.Add("style", "display:block");
            lbl_NoofChildren.Attributes.Add("style", "display:block");
            txt_SpouseNo.Disabled = false;
            txt_ChildrenNo.Disabled = false;
        }
    }
    private void LoadStrings(CultureInfo ci)
    {
        lbl_BloodGroup.Text = rm.GetString("EmployeeMaster_BloodGroup", ci);
        lbl_DateofBirth.Text = rm.GetString("EmployeeMaster_DateOfBirth", ci);
        lbl_FathersName.Text = rm.GetString("EmployeeMaster_FathersName", ci);
        lbl_Maritalstatus.Text = rm.GetString("EmployeeMaster_MaritalStatus", ci);
        lbl_MobileNumber.Text = rm.GetString("EmployeeMaster_MobileNumber", ci);
        lbl_MothersName.Text = rm.GetString("EmployeeMaster_MothersName", ci);
        lbl_PermanentAddress.Text = rm.GetString("EmployeeMaster_PermanentAddress", ci);
        lbl_PersonalMailID.Text = rm.GetString("EmployeeMaster_PersionalMailId", ci);
        rbtn_Married.Text = rm.GetString("rbtn_EmployeeMaster_Married", ci);
        rbtn_Single.Text = rm.GetString("rbtn_EmployeeMaster_Single", ci);
        btn_Save.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        lbl_FirstName.Text = rm.GetString("Field_EmployeeName", ci);
        lbl_LastName.Text = rm.GetString("EmployeeMaster_LastName", ci);
        lbl_MiddleName.Text = rm.GetString("EmployeeMaster_MiddleName", ci);
        lbl_NoofChildren.Text = rm.GetString("EmployeeMaster_NoOfChildren", ci);
        lbl_NoofSpouse.Text = rm.GetString("EmployeeMaster_NoOfSpouse", ci);
        lbl_HeaderEmployeeprofile.Text = rm.GetString("UserProfile_Header", ci);
        btn_Cancel.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Back", ci);
    }
    private string CheckMstatus(RadioButton r1, RadioButton r2)
    {
        string mstatus = "";
        if (r1.Checked == true)
            mstatus = "Single";
        if (r2.Checked == true)
            mstatus = "Married";
        return mstatus;
    }
    #endregion
    protected void btn_Save_Click(object sender, EventArgs e)
    {
        try
        {
          
            string strDob = string.Empty;
            string strGender = string.Empty;
           
            int intEmpid = Convert.ToInt32(Session["EmpAutoID"]);
            string strFirstname = txt_FirstName.Text.Trim().Replace("'", "''");
            string strMiddlename = txt_MiddleName.Text.Trim().Replace("'", "''");
            string strLastname = txt_LastName.Text.Trim().Replace("'", "''");
            string strFathername = txt_FatherName.Text.Trim().Replace("'", "''");
            string strMothername = txt_MotherName.Text.Trim().Replace("'", "''");
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            if (txt_dob.Text != "")
            {
                strDob = objCommon.DateConvertion(gstrDateFormat, txt_dob.Text.Trim());
            }
            else
            {
            }
            string strBloodgroup = txt_BloodGroup.Text.Trim();
            string strPermanentAddress = txt_PermanentAddress.Text.Trim();
            string strMobileno = txt_MobileNo.Text.Trim();
            string strMstatus = CheckMstatus(rbtn_Single, rbtn_Married);
            string strPersonalmailID = txt_PersonalMailID.Text.Trim();
            if (txt_SpouseNo.Value.Trim() == "") txt_SpouseNo.Value = "0";
            int intNoofSpouse;
            if (strMstatus == "Single")
            intNoofSpouse = 0;
            else
            intNoofSpouse = Convert.ToInt32(txt_SpouseNo.Value.Trim());
 
            if (txt_ChildrenNo.Value.Trim() == "") txt_ChildrenNo.Value = "0";
            int intNoofchildren;
            if (strMstatus == "Single")
            intNoofchildren = 0;
            else
            intNoofchildren = Convert.ToInt32(txt_ChildrenNo.Value.Trim());

            DataSet ds_Empdetails = new DataSet();
            if (fup_Photo.HasFile)
            {
                string strphotofile = fup_Photo.PostedFile.FileName;
                int index = strphotofile.LastIndexOf(".");
                string strFileFormat = strphotofile.Substring(index + 1).ToLower();
                if (strFileFormat == "jpeg" || strFileFormat == "jpg" || strFileFormat == "bmp" || strFileFormat == "gif")
                {
                    image = fup_Photo.FileBytes;
                }
                else
                {
                    ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", "AlertMessage('" + rm.GetString("Alert_PleaseSelectJPGorGIForBMPFileforPhoto", ci) + "');", true);
                    return;
                }
            }
            else if (fup_Photo.PostedFile.FileName == "")
            {
                ds_Empdetails = objEmployee.Select_EmployeeDetailsbyId(intEmpid);
                if (ds_Empdetails.Tables[0].Rows.Count > 0)
                {
                    if (Convert.ToString(ds_Empdetails.Tables[0].Rows[0]["Photo"]) != "")
                    {
                        image = (byte[])ds_Empdetails.Tables[0].Rows[0]["Photo"];
                    }
                }
            }
            //objEmployee.SaveMyProfile(intEmpid, strFathername, strMothername, strDob, strBloodgroup, strContactaddress, strPermanentAddress,
            //                      strPhoneno, strMobileno, strMstatus, strNationality, Religion, image,
            //                      strPersonalmailID, intNativeplace, strDistrict, intState, intCountry);

              objEmployee.UpdateEmployeeProfile(intEmpid,strFirstname,strMiddlename,strLastname,strFathername,strMothername,strBloodgroup,strDob,strPersonalmailID,strPermanentAddress,strMobileno,strMstatus, intNoofSpouse, intNoofchildren, image);

        

            if ((hid_Children.Value != "") && (intNoofchildren > 0))
            {
                objEmployee.delete_EmployeeChildren(intEmpid);
                ChildrenData(intEmpid);
            }
            else
            {
                objEmployee.delete_EmployeeChildren(intEmpid);
            }
          
            if ((hid_Spouse.Value != "") && (intNoofSpouse > 0))
            {
                objEmployee.delete_EmployeeSpouse(intEmpid);
                SpouseData(intEmpid);
            }
            else
            {
                objEmployee.delete_EmployeeSpouse(intEmpid);
            }

            string strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("Alert_Employeeinformaitonsavedsucessfully", ci) + "');";
            strScript = strScript + "location.replace('UserProfile.aspx');";
            strScript = strScript + "</script>";
            ScriptManager.RegisterStartupScript(this, this.GetType(), "Alert", strScript, false);

        }


        catch (Exception ex)
        {

            throw;
        }
    }


    private void ChildrenData(int MaxID)
    {
        string children_data = hid_Children.Value;
        if (children_data != "")
        {
            char[] comma = { ',' };
            char[] star = { '*' };
            string[] childrenname = { };
            string[] children = children_data.Split(star);
            for (int i = 0; i < children.Length; i++)
            {
                string data = children[i];
                childrenname = data.Split(comma);
                objEmployee.InsertChildrenDetails(MaxID, childrenname[0], objcommon.DateConvertion(gstrDateFormat, childrenname[1]), EmployeeID);
            }
        }
    }

    private void SpouseData(int MaxID)
    {
        string spouse_data = hid_Spouse.Value;
        if (spouse_data != "")
        {
            char[] comma = { ',' };
            char[] star = { '*' };
            string[] spousename = { };
            string[] spouse = spouse_data.Split(star);
            for (int i = 0; i < spouse.Length; i++)
            {
                string data = spouse[i];
                spousename = data.Split(comma);
                objEmployee.InsertSpouseDetails(MaxID, spousename[0], objCommon.DateConvertion(gstrDateFormat, spousename[1]), EmployeeID);
            }
        }
    }



    protected void btn_Cancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("../DashBoard.aspx");
    }
}