using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Text;
using System.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.IO;
using NPOI.HSSF.UserModel;
using NPOI.SS.UserModel;
using NPOI.HSSF.Util;
using NPOI.SS.Util;
using System.Xml;
using System.Web;

public partial class Reports_TA_UI_Report_DetailAttendance : Base.BasePage
{
    #region Variable Declaration
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    DataSet ds_Checkuser = new DataSet();
    GetReports rptEmp = new GetReports();
    Rpt_Common rptcommon = new Rpt_Common();
    EmployeeEventData objEmployee = new EmployeeEventData();
    ResourceManager rm;
    cls_Common objCommon = new cls_Common();
    CultureInfo ci;
    string strFromdate, gstrDateFormat, strTodate;
    int intIndividualUser = 0;
    TimeSpan result;
    bool blnNormal;
    int intXML = 1;
    DataSet dsEmp = new DataSet();
    int payrollConfig = 0;
    string strEmpAutoId = "0";
    string dtFrom = "", dtTo = "";
    string empName = "", empId = "";
    string employeeName = string.Empty;
    string Level = string.Empty;
    #endregion
    #region Page Load Events
    /// <summary>
    /// On page loading
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
            //Todo: need to add below lines into main applications
            objCommon.menu("Attendance Reports", "30");
        }
        //get the culture info to set the language
        string source_Language;
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        LoadStrings(ci);
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + rm.GetString("Alert_MaximumLengthis", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + rm.GetString("Alert_EnterDate", ci) + "','" + rm.GetString("Alert_EnterToDate", ci) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + rm.GetString("Alert_Validmonthdatefourdigit", ci) + "','" + rm.GetString("Alert_Validdatemonthfourdigit", ci) + "','" + rm.GetString("Alert_Invalidyearentry", ci) + "','" + rm.GetString("Alert_Invalidmonthentry", ci) + "','" + rm.GetString("Alert_Invaliddateentry", ci) + "','" + rm.GetString("Alert_IncorrectdateformatDDMONYYYY", ci) + "','" + rm.GetString("Alert_Entertime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "','" + rm.GetString("Alert_Invalidtimeformat1", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMM", ci) + "','" + rm.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", ci) + "','" + rm.GetString("Alert_PleaseentervalidDateandTime", ci) + "','" + rm.GetString("Alert_Invalidvalueforhours", ci) + "','" + rm.GetString("Alert_Invalidvalueforminites", ci) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        //Set UserRights
        UserRights();
        if (!IsPostBack)
        {
            BindingEmployeeCategoryandType();
            FillDesignation();
            if (Request.QueryString["Source"] != null)
            {
                if (Convert.ToString(Request.QueryString["Source"]) == "Email")
                {
                    divdateTime.Visible = false;
                    trView.Visible = false;
                    trSave.Visible = true;
                }
            }
            else
            {
                divdateTime.Visible = true;
                trView.Visible = true;
                trSave.Visible = false;
            }
            if (Request.QueryString["ScheduleId"] != null && Convert.ToString(Session["hdnReportFilters"]) == string.Empty)
            {
                string strGet = hdnReportFilters.Value;
                string strScript = "<script language='javascript' type='text/javascript'>";
                strScript += "GethiddenValue();";
                strScript += " </script>";
                this.RegisterStartupScript("setScript", strScript);
                if (Request.QueryString["ScheduleId"] != null)
                {
                    DataSet ds = new DataSet();
                    ds = rptEmp.GetEmailSchedulerFilterDetails(Convert.ToInt32(Request.QueryString["ScheduleId"]));
                    if (ds.Tables.Count > 0)
                    {
                        if (ds.Tables[0].Rows.Count > 0)
                        {
                            txtEmpId.Text = Convert.ToString(ds.Tables[0].Rows[0]["empid"]);
                            txtEmployeeName.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeName"]);
                            ddlEmpCatagory.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeCategory"]);
                            ddlEmpType.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["EmployeeType"]);
                            txtSwipeCard.Text = Convert.ToString(ds.Tables[0].Rows[0]["EmpSwipeCard"]);
                            ddlDesignation.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["DesignationID"]);
                            ddlGender.SelectedValue = Convert.ToString(ds.Tables[0].Rows[0]["Gender"]);
                            Session["EMailParentId"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentID"]);
                            //Session["parentLevelId_modify"] = Convert.ToString(ds.Tables[0].Rows[0]["ParentId"]);
                        }
                    }
                }
            }
            else
            {
                if (Convert.ToString(Session["hdnReportFilters"]) != string.Empty)
                {
                    string strhdnParameters = Convert.ToString(Session["hdnReportFilters"]);
                    string[] strArray = new string[50];
                    string[] strArray1 = new string[50];
                    strArray = strhdnParameters.Split(',');
                    for (int i = 0; i < strArray.Length; i++)
                    {
                        string[] strTemp = new string[5];
                        strTemp = strArray[i].Split('=');
                        strArray1[i] = strTemp[1];
                    }
                    txtEmployeeName.Text = Convert.ToString(strArray1[3]).Replace("~", ",");
                    txtEmpId.Text = Convert.ToString(strArray1[2]).Replace("~", ",");
                    ddlEmpCatagory.SelectedValue = Convert.ToString(strArray1[8]);
                    ddlEmpType.SelectedValue = Convert.ToString(strArray1[9]);
                    ddlDesignation.SelectedValue = Convert.ToString(strArray1[11]);
                    ddlGender.SelectedValue = Convert.ToString(strArray1[12]);
                    Session["EMailParentId"] = Convert.ToString(strArray1[10]);
                }
            }
            if (Session["parentLevelId"] != null || Convert.ToInt16(Session["parentLevelId"]) != 0)
            {
                Session["parentLevelId"] = null;
            }
            ddlDesignation.PreRender += LB_PreRender;
            Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
            txtFromDate.Text = (Convert.ToDateTime(objCommon.CurrentMonthStartDate())).ToString(Convert.ToString(Session["MDateFormat"]));
            txtToDate.Text = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(Convert.ToString(Session["MDateFormat"]));
        }
        else
        {
            if (Request.QueryString["Source"] != null)
            {
                if (Convert.ToString(Request.QueryString["Source"]) == "Email")
                {
                    divdateTime.Visible = false;
                    trView.Visible = false;
                    trSave.Visible = true;
                }
            }
            else
            {
                divdateTime.Visible = true;
                trView.Visible = true;
                trSave.Visible = false;
            }
        }
        //Check whether the employee is Individual User
        intIndividualUser = objCheckUser.CheckIndividualUser(Convert.ToString(Session["UserGroupName"]));
        if (intIndividualUser >= 1)
        {
            PlaceHolderDetailedAttendance.Controls.Clear();
            divEmployeeDetails.Visible = false;
            lblEmpSwipe.Visible = false;
            txtSwipeCard.Visible = false;
        }
        //Convert date time to MM/dd/YYYY format
        gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
        strFromdate = txtFromDate.Text;
        strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
        strTodate = txtToDate.Text;
        strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
        if (Convert.ToString(Page.MasterPageFile) == "TA_Popup_Report_MasterPage.master")
        {
            conHeader.Visible = false;
        }
    }
    protected void Page_PreInit(object sender, EventArgs e)
    {
        if (Request.QueryString["Source"] != null)
            this.Page.MasterPageFile = "TA_Popup_Report_MasterPage.master";
    }
    #endregion
    #region User Defined functions
    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
        if (dsCategory != null)
        {
            if (dsCategory.Tables[0].Rows.Count > 0)
            {
                ddlEmpCatagory.DataSource = dsCategory;
                ddlEmpCatagory.DataTextField = "CategoryName";
                ddlEmpCatagory.DataValueField = "CategoryId";
                ddlEmpCatagory.DataBind();
            }
            dsCategory.Dispose();
            foreach (ListItem item in ddlEmpCatagory.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
        // employee type binding
        DataSet dsType = new DataSet();
        dsType = objEmployee.SelectTypeDetailsEmployee("");
        if (dsType != null)
        {
            if (dsType.Tables[0].Rows.Count > 0)
            {
                ddlEmpType.DataSource = dsType;
                ddlEmpType.DataTextField = "TypeName";
                ddlEmpType.DataValueField = "TypeId";
                ddlEmpType.DataBind();
            }
            dsType.Dispose();
            foreach (ListItem item in ddlEmpType.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// Validate the FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateFromDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            //strCurrentDate = objCommon.DateConvertion(gstrDateFormat,DateTime.Today.Date.ToString());
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            //strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            //DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy")); ;
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Alert_EnterValidFromDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Validate the ToDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateToDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            //strCurrentDate = objCommon.DateConvertion(gstrDateFormat, DateTime.Today.Date.ToString());
            strTodate = txtToDate.Text;
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            //DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date.ToString("MM/dd/yyyy"));
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strTodate);
            TimeSpan diff = dtFromDate.Subtract(dtCurrentDate);
            int day = diff.Days;
            if (day <= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Alert_EnterValidToDate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Compare ToDate with FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            strTodate = txtToDate.Text;
            gstrDateFormat = Convert.ToString(Session["MDateFormat"]);
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtToDate = DateTime.Parse(strTodate);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan diff = dtToDate.Subtract(dtFromDate);
            int day = diff.Days;
            if (day >= 0)
                e.IsValid = true;
            else
            {
                base.Message(rm.GetString("Msg_SelectvaliddatecomparewithFromdate", ci));
                e.IsValid = false;
            }
        }
        catch
        {
            //
        }
    }
    /// <summary>
    /// Getting Information from resource file and display it in label
    /// </summary>
    /// <param name="ci"></param>
    private void LoadStrings(CultureInfo ci)
    {
        lblFilter.Text = rm.GetString("lblFilter", ci);
        btn_View.Text = "&nbsp;&nbsp;" + rm.GetString("btn_View", ci);
        lblDetailedAttendanceReport.Text = rm.GetString("Reports_DetailedAttendance_DetailedAttendanceReport", ci);
        lblEmployeeName.Text = rm.GetString("Field_EmployeeName", ci);
        lblEmployeeId.Text = rm.GetString("Field_EmployeeID", ci);
        lblTimePeriod.Text = rm.GetString("Reports_TimePeriod", ci);
        lblFrom.Text = rm.GetString("Field_From", ci);
        lblTo.Text = rm.GetString("Field_To", ci);
        lblEmpSwipe.Text = rm.GetString("TerminalDataType_Card_No", ci);
        reqFromDate.ErrorMessage = rm.GetString("Alert_PleaseselectFromDate", ci);
        reqToDate.ErrorMessage = rm.GetString("Alert_PleaseselectToDate", ci);
        lblDesignation.Text = rm.GetString("EmployeeMaster_Designation", ci);
        lblGender.Text = rm.GetString("EmployeeMaster_Gender", ci);
        lblEmpCategory.Text = rm.GetString("Master_Category", ci);
        lblEmpType.Text = rm.GetString("Master_Type", ci);
        ddlEmpCatagory.Items[0].Text = rm.GetString("Select", ci);
        ddlEmpType.Items[0].Text = rm.GetString("Select", ci);
        btnSave.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Save", ci);
        btnBack.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Cancel", ci);
        lblDateFilter.Text = rm.GetString("lbl_DateFilter", ci);
        btn_Export.Text = "&nbsp;&nbsp;" + rm.GetString("btn_ExporttoExcel", ci);
        rbCustom.Text = rm.GetString("rb_Custom", ci);
        rbpreviousMonth.Text = rm.GetString("rb_PreviousMonth", ci);
        rbpreviousweek.Text = rm.GetString("rb_PreviousWeek", ci);
        rbThisMonth.Text = rm.GetString("rb_ThisMonth", ci);
        rbThisweek.Text = rm.GetString("rb_ThisWeek", ci);
        btn_EporttoXML.Text = "&nbsp;&nbsp;" + rm.GetString("Caption_ExportToXML", ci);
        ddlGender.Items[0].Text = rm.GetString("Caption_Both", ci);
        ddlGender.Items[1].Text = rm.GetString("rbtn_EmployeeMaster_Male", ci);
        ddlGender.Items[2].Text = rm.GetString("rbtn_EmployeeMaster_Female", ci);
        ddlDesignation.Items[0].Text = rm.GetString("ExportData_All", ci);
    }
    /// <summary>
    /// To check rights for the logged in user
    /// </summary>
    private void UserRights()
    {
        ds_Checkuser = objCheckUser.checkRights(30, Convert.ToInt32(Session["userGroup_Id"]), "viewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
            if (ds_Checkuser.Tables[0].Rows[0]["viewPrv"] == DBNull.Value || Convert.ToInt32(ds_Checkuser.Tables[0].Rows[0]["viewPrv"]) == 1)
            {
                btn_View.Visible = true;
            }
            else
            {
                btn_View.Visible = false;
            }
        }
        else
        {
            Response.Redirect("ReportsLandingPage.aspx");
        }
    }
    /// <summary>
    /// Fills the designation in the drop down
    /// </summary>
    private void FillDesignation()
    {
        DataSet ds_designation = new DataSet();
        ds_designation = objEmployee.select_CommonDesignation();
        if (ds_designation != null)
        {
            if (ds_designation.Tables[0].Rows.Count > 0)
            {
                ddlDesignation.DataSource = ds_designation;
                ddlDesignation.DataTextField = "TitleName";
                ddlDesignation.DataValueField = "TitleId";
                ddlDesignation.DataBind();
            }
            ds_designation.Dispose();
            foreach (ListItem item in ddlDesignation.Items)
            {
                item.Attributes.Add("title", item.Text);
            }
        }
    }
    /// <summary>
    /// To apply tooltip for the designation in the drop down
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void LB_PreRender(object sender, System.EventArgs e)
    {
        foreach (ListItem item in ddlDesignation.Items)
        {
            item.Attributes.Add("title", item.Text);
        }
    }
    #endregion
    #region Button Events
    private void CommontThings()
    {
        if (txtFromDate.Text != "")
            dtFrom = strFromdate;
        if (txtToDate.Text != "")
            dtTo = strTodate;
        if (intIndividualUser >= 1)
        {
            empName = string.Empty;
            Level = string.Empty;
            empId = Convert.ToString(Session["EmployeeCodeId"]);
        }
        else
        {
            empName = Convert.ToString(txtEmployeeName.Text);
            empId = Convert.ToString(txtEmpId.Text.Trim());
            employeeName = this.txtEmployeeName.Text.Replace("'", "''");
            Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
        }
        blnNormal = (rbtNormalReport.Checked == true) ? true : false;
    }

    /// <summary>
    /// Load the Punchality report
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btn_View_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                CommontThings();
                base.EncryptandRedirect("TA_UI_Report_ReportViewer.aspx", "DetailedAttendance", dtFrom, dtTo, empId, 0, employeeName, Level, Convert.ToInt32(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text.Trim().Replace("'", "''"), Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, 0, 0, 0, Convert.ToString(blnNormal), null, null, null, null, null, 0, null, null, null, null, null, 0, null, 0, null, null, null, 0, 0, 0, 0, 0, 0, null, null, null, null, null, null, null, null, null, null, null, null, null);
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                string empName = "", empId = "";
                string employeeName = string.Empty;
                string Level = string.Empty;
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    empName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmpId.Text).Trim();
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                    if (Level.Contains(","))
                    {
                        Level = Level.Replace(",", "~");
                    }
                    if (employeeName.Contains(","))
                    {
                        employeeName = employeeName.Replace(",", "~");
                    }
                    if (empId.Contains(","))
                    {
                        empId = empId.Replace(",", "~");
                    }
                }
                StringBuilder strFilters = new StringBuilder();
                strFilters.Append("@fromDat=" + " Duration_From " + ",");
                strFilters.Append("@ToDat=" + " Duration_To " + ",");
                strFilters.Append("@empId=" + empId + ",");
                strFilters.Append("@EmployeeName=" + employeeName + ",");
                strFilters.Append("@LevelID=" + Level + ",");
                strFilters.Append("@UserGroupName=" + Convert.ToString(Session["UserGroupName"]) + ",");
                strFilters.Append("@GradeLevel=" + Convert.ToString(Session["GradeLevel"]) + ",");
                strFilters.Append("@EmpSwipeCard=" + Convert.ToString(txtSwipeCard.Text).Trim().Replace("'", "''") + ",");
                strFilters.Append("@EmployeeCategory=" + ddlEmpCatagory.SelectedValue + ",");
                strFilters.Append("@EmployeeType=" + ddlEmpType.SelectedValue + ",");
                strFilters.Append("@ParentId=" + Convert.ToInt32(Session["parentLevelId"]) + ",");
                strFilters.Append("@DesignationID=" + ddlDesignation.SelectedValue + ",");
                strFilters.Append("@EmpAutoId=0,");
                strFilters.Append("@Gender=" + ddlGender.SelectedValue);
                Session["hdnReportFilters"] = string.Empty;
                Session["hdnReportFilters"] = strFilters;
                string strScript = "<script language=\"javascript\">";
                strScript = strScript + "{window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnFilters').value='" + strFilters + "'; window.top.parent.document.getElementById('ctl00_BodyContentPH_hdnCompanyId').value='" + Convert.ToInt32(Session["parentLevelId"]) + "';}";
                //strScript = strScript + "self.close();";
                strScript = strScript + "parent.$('#myModalReport').modal('hide');";
                strScript = strScript + "</script>";
                Response.Write(strScript);
            }
        }
        catch
        {
            //
        }
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        string strMsg;
        strMsg = "<script language='javascript'>";
        strMsg = strMsg + "parent.$('#myModalReport').modal('hide');";
        strMsg = strMsg + "</script>";
        Page.RegisterStartupScript("close report window", strMsg);
        return;
    }
    protected void btn_Export_Click(object sender, EventArgs e)
    {
        try
        {
            if (Page.IsValid == true)
            {
                CommontThings();
                if (Session["ReportsBasedOn"] != null)
                    strEmpAutoId = (Convert.ToString(Session["ReportsBasedOn"]) == "False") ? "0" : Convert.ToString(Session["EmpAutoID"]);
                //Create the datatable ,that holds the header information
                payrollConfig = objCommon.CheckPageExistsInLicense(185);
                /*Below parameter is used for Angler*/
                if (payrollConfig == 0)
                    dsEmp = rptEmp.SelectDetailAttend(dtFrom, dtTo, empId, employeeName, Level, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt16(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToInt32(Session["EmpAutoID"]));
                else
                    dsEmp = rptEmp.SelectDetailAttend_Old(dtFrom, dtTo, empId, employeeName, Level, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text, Convert.ToInt64(strEmpAutoId), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt16(Session["parentLevelId"]), 1);

                DataTable dtLevelName = new DataTable();
                if (Convert.ToInt16(Session["parentLevelId"]) != 0)
                    dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
                //dsEmp = rptEmp.SelectDetailAttend(dtFrom, dtTo, empId, employeeName, Level, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text, Convert.ToInt64(strEmpAutoId), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt16(Session["parentLevelId"]), 1);
                if (dsEmp.Tables["Table"] == null || dsEmp.Tables["Table"].Rows.Count == 0)
                {
                    ShowMessage_CloseWindow(rm.GetString("Alert_Thereisnorecord", ci));
                    return;
                }
                else
                {
                    HSSFWorkbook workbook = new HSSFWorkbook();
                    ISheet sheet = workbook.CreateSheet("Detailed Attendance Report");
                    sheet.IsPrintGridlines = true;
                    sheet.VerticallyCenter = true;
                    int rowIndex = 0;
                    NPOI.SS.UserModel.IRow row = sheet.CreateRow(rowIndex);
                    HSSFFont hFont = (HSSFFont)workbook.CreateFont();
                    hFont.Boldweight = (short)FontBoldWeight.Bold;
                    hFont.Color = HSSFColor.Maroon.Index;
                    HSSFCellStyle hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
                    hStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
                    hStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
                    hStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
                    hStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
                    hStyle.SetFont(hFont);
                    HSSFCellStyle hStyle2 = (HSSFCellStyle)workbook.CreateCellStyle();
                    hStyle2.SetFont(hFont);
                    hStyle2.Alignment = HorizontalAlignment.Center;
                    HSSFCellStyle IStyle = (HSSFCellStyle)workbook.CreateCellStyle();
                    IStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
                    IStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
                    IStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
                    IStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
                    #region Product
                    if (payrollConfig == 0)
                    {
                        if (dtLevelName.Rows.Count > 0)
                        {
                            row.CreateCell(0).SetCellValue(Convert.ToString(dtLevelName.Rows[0][0]));
                            sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, dsEmp.Tables[0].Columns.Count - 4));
                            row.GetCell(0).CellStyle = hStyle2;
                            rowIndex++;
                            row = sheet.CreateRow(rowIndex);
                        }
                        row.CreateCell(0).SetCellValue("Detailed Attendance report From - " + Convert.ToString(txtFromDate.Text) + " To - " + Convert.ToString(txtToDate.Text));
                        row.GetCell(0).CellStyle = hStyle2;
                        sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, dsEmp.Tables[0].Columns.Count - 4));
                        rowIndex++;
                        row = sheet.CreateRow(rowIndex);
                        rowIndex++;
                        row = sheet.CreateRow(rowIndex);
                        row.CreateCell(0).SetCellValue("Sl.No");
                        row.CreateCell(1).SetCellValue("Employee Id");
                        row.CreateCell(2).SetCellValue("Employee Name");
                        row.CreateCell(3).SetCellValue("Gender");
                        row.CreateCell(4).SetCellValue("Present");
                        row.CreateCell(5).SetCellValue("Absent");
                        row.CreateCell(6).SetCellValue("Total Late Days");
                        row.CreateCell(7).SetCellValue("Total Late Hours");
                        row.CreateCell(8).SetCellValue("Total Early Exit Days");
                        row.CreateCell(9).SetCellValue("TotalEarly ExitHours");
                        row.CreateCell(10).SetCellValue("TotalOT Days");
                        row.CreateCell(11).SetCellValue("TotalOTHours");
                        row.CreateCell(12).SetCellValue("NormOTHrs");
                        row.CreateCell(13).SetCellValue("WeekOffOTHrs");
                        row.CreateCell(14).SetCellValue("HolidayOTHrs");
                        row.CreateCell(15).SetCellValue("Others");
                        int CC = 0;
                        int CellCount = 16;
                        //Create auto generated column in excel sheet
                        for (int j = 19; j <= dsEmp.Tables[0].Columns.Count - 1; j++)
                        {
                            row.CreateCell(CellCount).SetCellValue(dsEmp.Tables[0].Columns[j].ColumnName);
                            CellCount++;
                        }
                        //Style Added the created Headers.
                        for (int i = 0; i <= CellCount - 1; i++)
                        {
                            row.GetCell(i).CellStyle = hStyle;
                        }
                        rowIndex++;
                        Int32 SlNo = 0;
                        double HrsVal;
                        foreach (DataRow DR in dsEmp.Tables[0].Rows)
                        {
                            CellCount = 16;
                            row = sheet.CreateRow(rowIndex);
                            row.Height = 300;
                            SlNo++;
                            row.CreateCell(0).SetCellValue(SlNo);
                            row.CreateCell(1).SetCellValue(Convert.ToString(DR["Employee Id"]));
                            row.CreateCell(2).SetCellValue(Convert.ToString(DR["Employee Name"]));
                            row.CreateCell(3).SetCellValue(Convert.ToString(DR["Gender"]));
                            row.CreateCell(4).SetCellValue(Convert.ToDouble(DR["Present"]));
                            row.CreateCell(5).SetCellValue(Convert.ToDouble(DR["Absent"]));
                            row.CreateCell(6).SetCellValue(Convert.ToDouble(DR["Total Late Days"]));
                            HrsVal = DR["Total Late Hours"] == DBNull.Value ? 0 : Convert.ToDouble(DR["Total Late Hours"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(7).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            row.CreateCell(8).SetCellValue(Convert.ToDouble(DR["Total Early Exit Days"]));
                            HrsVal = DR["Total Early Exit Hours"] == DBNull.Value ? 0 : Convert.ToDouble(DR["Total Early Exit Hours"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(9).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            row.CreateCell(10).SetCellValue(Convert.ToDouble(DR["Total OT Days"]));
                            HrsVal = DR["Total OT Hours"] == DBNull.Value ? 0 : Convert.ToDouble(DR["Total OT Hours"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(11).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            HrsVal = DR["Norm OT Hrs"] == DBNull.Value ? 0 : Convert.ToDouble(DR["Norm OT Hrs"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(12).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            HrsVal = DR["WeekOff OT Hrs"] == DBNull.Value ? 0 : Convert.ToDouble(DR["WeekOff OT Hrs"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(13).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            HrsVal = DR["Holiday OT Hrs"] == DBNull.Value ? 0 : Convert.ToDouble(DR["Holiday OT Hrs"]);
                            result = TimeSpan.FromMinutes(HrsVal);
                            row.CreateCell(14).SetCellValue(string.Format("{0:00}:{1:00}", (int)result.TotalHours, result.Minutes));
                            row.CreateCell(15).SetCellValue(Convert.ToDouble(DR["Others"]));
                            //Auto generated column value added the column
                            for (int j = 19; j <= dsEmp.Tables[0].Columns.Count - 1; j++)
                            {
                                row.CreateCell(CellCount).SetCellValue(Convert.ToDouble(DR[dsEmp.Tables[0].Columns[j].ColumnName]));
                                CellCount++;
                            }
                            //Style Added the items like border
                            for (int i = 0; i <= CellCount - 1; i++)
                            {
                                row.GetCell(i).CellStyle = IStyle;
                                sheet.AutoSizeColumn(i);
                            }
                            rowIndex++;
                        }
                    }
                    #endregion
                    #region Angler
                    else
                    {
                        row.CreateCell(0).SetCellValue("Sl.No");
                        row.CreateCell(1).SetCellValue("Employee Id");
                        row.CreateCell(2).SetCellValue("Employee Name");
                        row.CreateCell(3).SetCellValue("Employee Category");
                        row.CreateCell(4).SetCellValue("Present");
                        row.CreateCell(5).SetCellValue("Absent");
                        row.CreateCell(6).SetCellValue("Weekly Off");
                        row.CreateCell(7).SetCellValue("Saturday Off");
                        row.CreateCell(8).SetCellValue("Holiday");
                        row.CreateCell(9).SetCellValue("CompOff");
                        row.CreateCell(10).SetCellValue("Lop");
                        row.CreateCell(11).SetCellValue("CL");
                        row.CreateCell(12).SetCellValue("SL");
                        row.CreateCell(13).SetCellValue("Total Late Hours");
                        row.CreateCell(14).SetCellValue("Total Late Days");
                        //row.RowStyle = hStyle;
                        for (int i = 0; i <= 14; i++)
                        {
                            row.GetCell(i).CellStyle = hStyle;
                        }
                        rowIndex++;
                        foreach (DataRow DR in dsEmp.Tables[0].Rows)
                        {
                            row = sheet.CreateRow(rowIndex);
                            row.Height = 300;
                            row.CreateCell(0).SetCellValue(Convert.ToInt32(DR["Sl.No"]));
                            row.CreateCell(1).SetCellValue(Convert.ToString(DR["Employee Id"]));
                            row.CreateCell(2).SetCellValue(Convert.ToString(DR["Employee Name"]));
                            row.CreateCell(3).SetCellValue(Convert.ToString(DR["Employee Category"]));
                            row.CreateCell(4).SetCellValue(Convert.ToDouble(DR["Present"]));
                            row.CreateCell(5).SetCellValue(Convert.ToDouble(DR["Absent"]));
                            row.CreateCell(6).SetCellValue(Convert.ToDouble(DR["Weekly Off"]));
                            row.CreateCell(7).SetCellValue(Convert.ToDouble(DR["Saturday Off"]));
                            row.CreateCell(8).SetCellValue(Convert.ToDouble(DR["Holiday"]));
                            row.CreateCell(9).SetCellValue(Convert.ToDouble(DR["CompOff"]));
                            row.CreateCell(10).SetCellValue(Convert.ToDouble(DR["Lop"]));
                            row.CreateCell(11).SetCellValue(Convert.ToDouble(DR["CL"]));
                            row.CreateCell(12).SetCellValue(Convert.ToDouble(DR["SL"]));
                            row.CreateCell(13).SetCellValue(Convert.ToString(DR["Total Late Hours"]));
                            row.CreateCell(14).SetCellValue(Convert.ToDouble(DR["Total Late Days"]));
                            rowIndex++;
                        }
                    }
                    #endregion
                    ISheet sheet1 = workbook.CreateSheet("Legends");
                    sheet1.IsPrintGridlines = true;
                    sheet1.VerticallyCenter = true;
                    int rowIndex1 = 0;
                    NPOI.SS.UserModel.IRow row1 = sheet1.CreateRow(rowIndex1);
                    hFont = (HSSFFont)workbook.CreateFont();
                    hFont.Boldweight = (short)FontBoldWeight.Bold;
                    hFont.Color = HSSFColor.Red.Index;
                    hFont.FontHeightInPoints = 10;
                    hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
                    hStyle.SetFont(hFont);
                    hStyle.FillForegroundColor = IndexedColors.White.Index;
                    hStyle.FillPattern = FillPattern.SolidForeground;
                    HSSFCellStyle hStyle1 = (HSSFCellStyle)workbook.CreateCellStyle();
                    hStyle1.SetFont(hFont);
                    hStyle1.FillForegroundColor = IndexedColors.Pink.Index;
                    hStyle1.FillPattern = FillPattern.SolidForeground;
                    row1.CreateCell(0).SetCellValue("");
                    row1.CreateCell(1).SetCellValue("Present - Present Days + Comp Off + Holiday + OnDuty + WeekOff + BL");
                    sheet1.AddMergedRegion(new CellRangeAddress(rowIndex1, rowIndex1, 1, 10));
                    row1.GetCell(1).CellStyle = hStyle;
                    rowIndex1++;
                    row1 = sheet1.CreateRow(rowIndex1);
                    row1.CreateCell(0).SetCellValue("");
                    row1.CreateCell(1).SetCellValue(" Others - Regional Holidays + LOP + ESI");
                    sheet1.AddMergedRegion(new CellRangeAddress(rowIndex1, rowIndex1, 1, 10));
                    row1.GetCell(1).CellStyle = hStyle;
                    rowIndex1++;
                    ExportToExcel(workbook, "DetailedAttendanceReport");
                }
            }
        }
        catch (Exception ex)
        {
            Response.Write(ex);
        }
    }
    protected void btn_XMl_Click(object sender, EventArgs e)
    {
        try
        {
            DataSet dsEmp = new DataSet();
            int payrollConfig = 0;
            string strEmpAutoId = "0";
            if (Page.IsValid == true)
            {
                if (Session["ReportsBasedOn"] != null)
                {
                    if (Convert.ToString(Session["ReportsBasedOn"]) == "False")
                    {
                        strEmpAutoId = "0";
                    }
                    else
                    {
                        strEmpAutoId = Convert.ToString(Session["EmpAutoID"]);
                    }
                }
                string dtFrom = "", dtTo = "";
                if (txtFromDate.Text != "")
                    dtFrom = strFromdate;
                if (txtToDate.Text != "")
                    dtTo = strTodate;
                string empName = "", empId = "";
                string employeeName = string.Empty;
                string Level = string.Empty;
                if (intIndividualUser >= 1)
                {
                    empName = string.Empty;
                    Level = string.Empty;
                    empId = Convert.ToString(Session["EmployeeCodeId"]);
                }
                else
                {
                    empName = Convert.ToString(txtEmployeeName.Text);
                    empId = Convert.ToString(txtEmpId.Text).Trim();
                    employeeName = this.txtEmployeeName.Text.Replace("'", "''");
                    Level = rptcommon.getNodes(Convert.ToInt16(Session["parentLevelId"]), Convert.ToString(Session["LevelRights"]));
                }
                if (rbtNormalReport.Checked == true)
                {
                    blnNormal = true;
                }
                else
                {
                    blnNormal = false;
                }
                //Create the datatable ,that holds the header information
                dsEmp = rptEmp.Select_DetailAttendanceforExportTally(dtFrom, dtTo, empId, employeeName, Level, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text, Convert.ToInt16(Session["parentLevelId"]), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt16(ddlEmpCatagory.SelectedValue), Convert.ToInt32(ddlEmpType.SelectedValue), Convert.ToInt32(Session["EmpAutoID"]));
                DataTable dtLevelName = new DataTable();
                if (Convert.ToInt16(Session["parentLevelId"]) != 0)
                {
                    dtLevelName = rptEmp.getHeader(Convert.ToInt16(Session["parentLevelId"]));
                }
                //dsEmp = rptEmp.SelectDetailAttend(dtFrom, dtTo, empId, employeeName, Level, Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]), txtSwipeCard.Text, Convert.ToInt64(strEmpAutoId), Convert.ToInt32(ddlDesignation.SelectedValue), ddlGender.SelectedValue, Convert.ToInt16(Session["parentLevelId"]), 1);
                if (dsEmp.Tables["Table"] == null || dsEmp.Tables["Table"].Rows.Count == 0)
                {
                    string strMsg;
                    strMsg = "<script language='javascript'>";
                    strMsg = strMsg + "alert('" + rm.GetString("Alert_Thereisnorecord", ci) + "');window.close();";
                    strMsg = strMsg + "</script>";
                    Page.RegisterStartupScript("Display Message", strMsg);
                    return;
                }
                else
                {
                    string strXML = string.Empty;
                    strXML = "<ENVELOPE><HEADER><TALLYREQUEST>Import Data</TALLYREQUEST></HEADER><BODY><IMPORTDATA><REQUESTDATA>";
                    intXML = 1;
                    foreach (DataRow DR in dsEmp.Tables[0].Rows)
                    {
                        strXML = strXML + "<TALLYMESSAGE xmlns:UDF=\"TallyUDF\"><VOUCHER><DATE>" + Convert.ToDateTime(dtFrom).ToString("yyyyMMdd") + "</DATE><EFFECTIVEDATE>" + Convert.ToDateTime(dtTo).ToString("yyyyMMdd") + "</EFFECTIVEDATE><VOUCHERTYPENAME>Attendance</VOUCHERTYPENAME><VOUCHERNUMBER>" + Convert.ToString(intXML) + "</VOUCHERNUMBER><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>Absent</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["Absent"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>WeeklyOff</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["WeeklyOff"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>Holiday</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["Holiday"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>Leave</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["Leave"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>LOP</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["LOP"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>OverTime</ATTENDANCETYPE><ATTDTYPEVALUE>" + Convert.ToString(DR["Total OT Hours"]) + "</ATTDTYPEVALUE></ATTENDANCEENTRIES.LIST><ATTENDANCEENTRIES.LIST><NAME>" + Convert.ToString(DR["Employee Name"]) + "</NAME><ATTENDANCETYPE>Present</ATTENDANCETYPE><ATTDTYPETIMEVALUE>" + Convert.ToString(DR["Present"]) + "</ATTDTYPETIMEVALUE></ATTENDANCEENTRIES.LIST></VOUCHER></TALLYMESSAGE>";
                        intXML = intXML + 1;
                    }
                    strXML = strXML + "</REQUESTDATA></IMPORTDATA></BODY></ENVELOPE>";
                    //XmlDocument xmlDoc = new XmlDocument();
                    //xmlDoc.LoadXml(strXML);
                    string strFilePath = Server.MapPath("Uploads").ToString();
                    File.WriteAllText(strFilePath + "/DayBook.xml", strXML);
                    string strFullPath = strFilePath + "/DayBook.xml";
                    string strContents = null;
                    System.IO.StreamReader objReader = default(System.IO.StreamReader);
                    objReader = new System.IO.StreamReader(strFullPath);
                    strContents = objReader.ReadToEnd();
                    objReader.Close();
                    string attachment = "attachment; filename=DayBook.xml";
                    Response.ClearContent();
                    Response.ContentType = "application/xml";
                    Response.AddHeader("content-disposition", attachment);
                    Response.Write(strContents);
                    Response.End();

                }
            }
        }
        catch (Exception ex)
        {
            //Response.Write(ex);
        }
    }
    #endregion
}
