<%@ Page Language="C#" EnableEventValidation="false" AutoEventWireup="true" CodeFile="ImportEmployee.aspx.cs"
    MasterPageFile="~/MasterFile/TimeCheck.master" Inherits="System_Settings_ImportEmployee" %>

<%@ Register Assembly="DevExpress.Web.v14.2" Namespace="DevExpress.Web"
    TagPrefix="dxe" %>
<%@ Register TagPrefix="dxGridview" Namespace="DevExpress.Web" Assembly="DevExpress.Web.v14.2" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>
<%--Added for progress Bar--%>
<asp:Content ID="Content1" ContentPlaceHolderID="BodyContentPH" runat="server">
    <link rel="stylesheet" type="text/css" href="../css/ProgressBar.css" />
    <%--Added for progress Bar--%>
    <script src="../plugins/datepicker/jquery-1.11.1.min.js"></script>
    <script type="text/javascript" src="../js/maxLength.js"></script>
    <script src="../js/maxLength.js" type="text/javascript"></script>
    <%--    <script src="../plugins/datepicker/bootstrap-datepicker.js"></script>
    <script type="text/javascript">
        function DynamicDatePicker(txtBoxId) {
            try {
                $("#" + txtBoxId).datetimepicker({ format: 'DD-MMM-YYYY' });
            }
            catch (err) {
            }
        }
    </script>--%>
    <style type="text/css">
        .fupload {
            font-family: "FontAwesome";
        }

        .mycontent-left {
            border-right: 1px dashed #333;
        }
    </style>
    <style type="text/css">
        .FixedHeader {
            position: absolute;
            font-weight: bold;
        }

        .divgrid {
            /*height: 500px;*/
            width: 10080px !important;
            overflow: auto;
        }

            .divgrid table {
                width: 10000px !important;
            }
        /* .divgrid table th {
                    background-color: Green;
                    color: #fff;
                }*/
    </style>
    <div class="content-header">
        <h1 style="background-image: url('../dist/img/import.png'); background-repeat: no-repeat; padding-left: 35px">
            <asp:Label ID="lbl_ImportEmployeeHeader" runat="server"></asp:Label>
        </h1>
        <asp:SiteMapPath ID="site" runat="server" CssClass="breadcrumb">
            <NodeStyle CssClass="active" />
        </asp:SiteMapPath>
    </div>
    <%--Added for progress Bar--%>
    <asp:UpdatePanel ID="upLeave" runat="server">
        <ContentTemplate>
            <asp:Panel ID="pnlProgress" runat="server" Style="display: none;">
                <asp:Panel ID="pnlLoading" runat="server" HorizontalAlign="center">
                    <div class="InsideProgressBar">
                        <div class="row" style="margin-top: 10px">
                            <img src="../dist/img/logo-Progress.png" />
                        </div>
                        <div class="row" style="min-width: 280px">
                            <img src="../dist/img/default.gif" style="width: 100px" />
                        </div>
                        <div class="row" style="margin-bottom: 10px">
                            <asp:Label ID="lblLoading" runat="server" ForeColor="black" Style="text-align: center"
                                Text="Processing...Please wait!" Font-Bold="true" Font-Size="12px" Font-Italic="true" Font-Family="Arial"></asp:Label>
                        </div>
                        <div class="clear clearfix">
                        </div>
                    </div>
                </asp:Panel>
            </asp:Panel>
            <asp:HiddenField ID="hdnProgress" runat="server" />
            <cc1:ModalPopupExtender ID="popupProgress" runat="server" TargetControlID="hdnProgress"
                BackgroundCssClass="ModalPopup" PopupControlID="pnlProgress" BehaviorID="popupProgress">
            </cc1:ModalPopupExtender>
        </ContentTemplate>
        <Triggers>
            <asp:PostBackTrigger ControlID="btn_Upload" />
        </Triggers>
    </asp:UpdatePanel>
    <%--end--%>
    <div class="content">
        <div class="inr-ftr">
            <div class="row">
                <div class="col-sm-6 col-xs-5">
                </div>
                <div class="col-sm-6 col-xs-7">
                    <div class="leave-manda">
                        <span>|</span>
                        <asp:Label ID="lbl_IndicatesMandatoryFields" Visible="True" runat="server"
                            ForeColor="black"></asp:Label>
                        (2 No.)
                    </div>
                </div>
            </div>
        </div>
        <div class="emp-filter">
            <div class="row">
                <div class="col-md-12">
                    <div class="row" id="licDetails" runat="server">
                        <div class="col-md-3">
                            <asp:Label ID="lblempAdded" runat="server" Font-Size="Small"></asp:Label>&nbsp;&nbsp;
                            <asp:Label ID="lblempAddedvalue" runat="server" CssClass="badge bg-light-blue"></asp:Label>
                        </div>
                        <div class="col-md-3">
                            <asp:Label ID="lblempActive" runat="server" Font-Size="Small"></asp:Label>&nbsp;&nbsp;
                                <asp:Label ID="lblempActivevalue" runat="server" CssClass="badge bg-light-blue"></asp:Label>
                        </div>
                        <div class="col-md-3">
                            <asp:Label ID="lblempInActive" runat="server" Font-Size="Small"></asp:Label>&nbsp;&nbsp;
                                <asp:Label ID="lblempInActivevalue" runat="server" CssClass="badge bg-light-blue"></asp:Label>
                        </div>
                        <div class="col-md-3">
                            <asp:Label ID="lblliccount" runat="server" Font-Size="Small"></asp:Label>&nbsp;&nbsp;
                                <asp:Label ID="lblliccountvalue" runat="server" CssClass="badge bg-light-blue"></asp:Label>
                        </div>
                    </div>
                    <div class="form-horizontal">
                        <div class="row">
                            <div class="row">
                                <div class="line16">
                                </div>
                            </div>
                        </div>
                        <div class="row" runat="server">
                            <div class="col-md-12">
                                <div class="col-md-6 src-padRightBorder">
                                    <div class="row form-group">
                                        <div class="col-md-4">
                                            <span style="color: Red">|</span>
                                            <asp:Label ID="lbl_Type" runat="server"></asp:Label>
                                        </div>
                                        <div class="col-md-8">
                                            <asp:RadioButtonList ID="rblType" runat="server" RepeatDirection="Horizontal" CssClass="radio radio-primary">
                                                <asp:ListItem Text="Simple" Value="0"></asp:ListItem>
                                                <asp:ListItem Text="Advanced" Selected="True" Value="1"></asp:ListItem>
                                            </asp:RadioButtonList>
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <div class="col-md-4">
                                            <span style="color: Red">|</span>
                                            <asp:Label ID="lbl_ImportFilePath" runat="server" Style="padding-left: 1px"></asp:Label>
                                        </div>
                                        <div class="col-md-8">
                                            <asp:FileUpload ID="fp_ImportFilePath" runat="server" CssClass="form-control" />
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="pull-right-button">
                                                <asp:LinkButton ID="btnTemplate" CssClass="btn save-btn fa-download" runat="server"
                                                    OnClick="btnTemplate_Click" Style="margin-left: 0px" />
                                                <asp:LinkButton ID="btn_Upload" CssClass="btn save-btn fa-upload" runat="server"
                                                    OnClick="btn_Upload_Click" OnClientClick="$find('popupProgress').show();" />
                                                <%-- OnClientClick added for progress bar--%>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        &nbsp;
                                    </div>
                                    <div class="row">
                                        &nbsp;
                                    </div>
                                    <div class="row">
                                        &nbsp;
                                    </div>
                                    <div class="row">
                                        &nbsp;
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="col-md-12">
                                        <div class="callout callout-info" style="margin-bottom: 0!important;">
                                            <asp:Label ID="lblImportNote" runat="server"></asp:Label>
                                        </div>
                                        <br />
                                        <ul>
                                            <li>
                                                <asp:Label ID="lblnotes1" runat="server" Text="Don't remove / modify any field in the downloaded template file while importing. if you remove / modify any field in the downloaded template file, it will not allow to upload data."></asp:Label></li>
                                            <li>
                                                <asp:Label ID="lblcon" runat="server" Text="Kindly use <B>dd-MMM-yyyy</B> format for Master Data Import. Refer the sample data available with in the Downloaded template."></asp:Label>
                                            </li>
                                            <li>
                                                <asp:Label ID="lblnotes3" runat="server" Text="While importing, check whether the file has been closed."></asp:Label>
                                            </li>
                                            <li>
                                                <asp:Label ID="lblnotes4" runat="server" Text="Save the file as <B>.csv</B> format before import."></asp:Label>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                            </div>
                            <div class="clearfix">
                            </div>
                            <div class="row">
                                <div class="line16">
                                </div>
                            </div>
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="row form-group">
                                        <div class="col-md-12">
                                            <asp:Label ID="lbl_Mag" Visible="false" Text="List of Invalid employee details" runat="server" ForeColor="Red"></asp:Label>
                                        </div>
                                        <div class="col-md-12">
                                            <div style="padding-bottom: 10px; overflow: auto;">
                                                <div class="divgrid">
                                                    <asp:GridView ID="gvImportMaster" CssClass="table table-responsive table-bordered" OnRowDataBound="gvImportMaster_RowDataBound"
                                                        runat="server" AllowPaging="true" AllowSorting="true" AutoGenerateColumns="False"
                                                        Style="margin-top: 15px" DataKeyNames="id"
                                                        Width="10000px" EnableViewState="False">
                                                        <Columns>
                                                            <%--  <asp:TemplateField HeaderStyle-BorderStyle="Solid" HeaderStyle-BorderWidth="1px"
                                                HeaderStyle-BorderColor="#FFFFFF" ItemStyle-BorderStyle="Solid" ItemStyle-BorderColor="#FFFFFF"
                                                ItemStyle-BorderWidth="1px" >
                                                <HeaderTemplate>
                                                    <asp:CheckBox ID="checkall" runat="server" AutoPostBack="true" OnCheckedChanged="gvImportMaster_CheckAll_CheckedChanged" />
                                                </HeaderTemplate>
                                                <ItemTemplate>
                                                    <asp:CheckBox ID="deletethis" runat="server" OnCheckedChanged="gvImportMaster_Deletethis_CheckedChanged"
                                                        AutoPostBack="true"></asp:CheckBox>
                                                </ItemTemplate>
                                                <ItemStyle HorizontalAlign="Center" />
                                                <HeaderStyle HorizontalAlign="Center" />
                                            </asp:TemplateField>--%>
                                                            <asp:TemplateField HeaderText=" "
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:LinkButton ID="btnError" ToolTip='<%# Bind("Error") %>' runat="server" CssClass="fa fa-question-circle" Font-Size="X-Large" Enabled="false"></asp:LinkButton>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="50px" />
                                                                <ItemStyle Width="50px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField ItemStyle-Width="50px" HeaderStyle-Width="50px" HeaderText="Sl.No" HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:Label ID="lblslNo" runat="server" Style="word-wrap: normal" Text='<%# Bind("RowID") %>' MaxLength="50"></asp:Label>
                                                                </ItemTemplate>
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* First Name"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Emp_FirstName" runat="server"
                                                                        onkeypress="return acceptChars_MaxLength(event,this,50,MaxLength);"
                                                                        Text='<%# Bind("Emp_FirstName") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Middle Name"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Emp_MiddleName" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Emp_MiddleName") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Last Name"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Emp_LastName" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Emp_LastName") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Father Name"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Father_Name" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Father_Name") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Mother Name"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Mother_Name" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Mother_Name") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Date Of Birth<br/>(DD-MMM-YYYY)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_DateOfBirth" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,11,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("DateOfBirth") %>' CssClass="form-control" MaxLength="11" Style="min-width: 110px !important"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="130px" />
                                                                <ItemStyle Width="130px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Date Of Birth as Per Record<br/>(DD-MMM-YYYY)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_DateOfBirth_Record" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,11,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("DateOfBirth_Record") %>' CssClass="form-control" MaxLength="11" Style="min-width: 100px !important"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="150px" />
                                                                <ItemStyle Width="150px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Blood Group"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Blood_Group" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,5,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Blood_Group") %>' CssClass="form-control" MaxLength="5" Style="min-width: 50px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="100px" />
                                                                <ItemStyle Width="100px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Email Id"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Email_Id" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,100,MaxLength,MaxLength);"
                                                                        Text='<%# Bind("Email_Id") %>' CssClass="form-control" MaxLength="100" Style="min-width: 200px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="220px" />
                                                                <ItemStyle Width="220px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Contact Address"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Contact_Address" runat="server" TextMode="MultiLine"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,250,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Contact_Address") %>' CssClass="form-control" MaxLength="250" Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block; resize: none; min-width: 200px; height: 50px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="220px" />
                                                                <ItemStyle Width="220px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Permanent Address"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Permanent_Address" runat="server" TextMode="MultiLine"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,250,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Permanent_Address") %>' CssClass="form-control" MaxLength="250" Style="overflow-y: auto; overflow-x: auto; word-break: break-all; word-wrap: break-word; display: inline-block; resize: none; min-width: 200px; height: 50px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="220px" />
                                                                <ItemStyle Width="220px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Phone Number"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Phone_Number" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Phone_Number") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Mobile Number"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Mobile_Number" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Mobile_Number") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText=" * Gender<br/>(Male | Female)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Gender" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Gender") %>' CssClass="form-control" MaxLength="50" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText=" Marital Status<br/>(Single | Married) "
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Marital_Status" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Marital_Status") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Nationality"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Nationality" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Nationality") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="170px" />
                                                                <ItemStyle Width="170px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Religion"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Religion" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Religion") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Personal EmailID"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Personal_EmailID" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,100,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Personal_EmailID") %>' CssClass="form-control" MaxLength="100" Style="min-width: 200px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="220px" />
                                                                <ItemStyle Width="220px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Passport No"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Passport_No" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,100,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Passport_No") %>' CssClass="form-control" MaxLength="100" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="180px" />
                                                                <ItemStyle Width="180px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Passport Expiry Date<br/>(DD-MMM-YYYY)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Passport_ExpiryDate" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,11,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Passport_ExpiryDate") %>' CssClass="form-control" MaxLength="11" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="150px" />
                                                                <ItemStyle Width="150px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Visa No"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Visa_No" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,100,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Visa_No") %>' CssClass="form-control" MaxLength="100" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="180px" />
                                                                <ItemStyle Width="180px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Visa Expiry Date<br/>(DD-MMM-YYYY)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Visa_ExpiryDate" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,11,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Visa_ExpiryDate") %>' CssClass="form-control" MaxLength="11" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="130px" />
                                                                <ItemStyle Width="130px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Employee Code"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Employee_Code" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,25,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Employee_Code") %>' CssClass="form-control" MaxLength="25" Style="min-width: 120px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="150px" />
                                                                <ItemStyle Width="150px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Date Of Joining<br/>(DD-MMM-YYYY)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_DateOfJoining" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,11,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("DateOfJoining") %>' CssClass="form-control" MaxLength="11" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="130px" />
                                                                <ItemStyle Width="130px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Qualification At The Time Of Joining"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Qualification_joiningtime" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,25,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Qualification_joiningtime") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Qualification During Employment"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Qualification_Employement" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,25,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Qualification_Employement") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="CompOff Eligible<br/>(0 | 1)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_CompOff_Eligible" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,1,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("CompOff_Eligible") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="OT Eligible<br/>(0 | 1)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_OT_Eligible" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,1,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("OT_Eligible") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Report Exclude<br/>(0 | 1)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Report_Exclude" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,1,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Report_Exclude") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Employee Status<br/>(0 | 1)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Employee_Status" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,1,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Employee_Status") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Is Deleted<br/>(0 | 1)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_IsDeleted" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("IsDeleted") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Hostel"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Hostel" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,1,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Hostel") %>' CssClass="form-control" MaxLength="1" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Designation"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Designation" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Designation") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="170px" />
                                                                <ItemStyle Width="170px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Grade<br/>(Grade Name)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Grade" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Grade") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* GradeNo<br/>(Grade Level)"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_GradeNo" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("GradeNo") %>' CssClass="form-control" MaxLength="50" Style="min-width: 100px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="120px" />
                                                                <ItemStyle Width="120px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Employee Type"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Employee_Type" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Employee_Type") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Employee Category"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Employee_Category" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Employee_Category") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Basic Salary"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_BasicSalary" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("BasicSalary") %>' CssClass="form-control" MaxLength="50" Style="min-width: 80px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="150px" />
                                                                <ItemStyle Width="150px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="* Level1"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level1" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,100,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level1") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level2"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level2" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level2") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level3"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level3" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level3") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level4"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level4" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level4") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level5"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level5" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level5") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level6"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level6" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level6") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level7"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level7" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level7") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level8"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level8" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level8") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level9"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level9" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level9") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Level10"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:TextBox onpaste="return true" ID="txt_Level10" runat="server"
                                                                        onkeyPress="return acceptChars_MaxLength(event,this,50,MaxLength,MaxLength)"
                                                                        Text='<%# Bind("Level10") %>' CssClass="form-control" MaxLength="50" Style="min-width: 150px"></asp:TextBox>
                                                                </ItemTemplate>
                                                                <HeaderStyle Width="200px" />
                                                                <ItemStyle Width="200px" />
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Error" Visible="false"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:Label ID="lbl_Error" runat="server" Text='<%# Bind("Error") %>'></asp:Label>
                                                                </ItemTemplate>
                                                            </asp:TemplateField>
                                                            <asp:TemplateField HeaderText="Id" Visible="false"
                                                                HeaderStyle-CssClass="empheader" ItemStyle-CssClass="table-icons" HeaderStyle-ForeColor="black">
                                                                <ItemTemplate>
                                                                    <asp:Label ID="lbl_Id" runat="server" Text='<%# Bind("id") %>'></asp:Label>
                                                                </ItemTemplate>
                                                            </asp:TemplateField>
                                                        </Columns>
                                                        <%-- <EmptyDataTemplate>
                                                <asp:Label ID="lblNoRecords" runat="server" OnLoad="GetEmptyText"></asp:Label>
                                            </EmptyDataTemplate>--%>
                                                        <RowStyle Height="30px" CssClass="table-bg" BorderColor="#C5DFFC" />
                                                        <PagerStyle Font-Overline="False" HorizontalAlign="Right" CssClass="GridPager" />
                                                        <PagerSettings FirstPageText="<<" LastPageText=">>" Mode="NumericFirstLast" NextPageText=">"
                                                            PreviousPageText="<" />
                                                        <AlternatingRowStyle BackColor="white" />
                                                    </asp:GridView>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="pull-right-button">
                                                <asp:LinkButton ID="btn_UploadGrid" CssClass="btn save-btn fa-upload" runat="server"
                                                    OnClick="btn_UploadGrid_Click" Style="margin-left: 0px" />
                                                <asp:LinkButton ID="btnDelete" CssClass="btn del-btn fa-trash-o" runat="server"
                                                    OnClick="btnDelete_Click" Style="margin-left: 0px" OnClientClick="return validate();" />
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <script type="text/javascript" language="javascript">
                        function validate() {
                            var r = confirm('Are you sure, to remove invalid employee details?');
                            if (r == true) {
                                $find('popupProgress').show();
                                return true;
                            }
                            else {
                                return false;
                            }
                        }
                    </script>
                    <script language="javascript">
                        $(document).ready(function () {
                            try {
                                $(".divgrid").each(function () {
                                    var grid = $(this).find("table")[0];
                                    var ScrollHeight = 500;
                                    var gridWidth = $(this).width() - 50;
                                    var headerCellWidths = new Array();
                                    for (var i = 0; i < grid.getElementsByTagName('TH').length; i++) {
                                        headerCellWidths[i] = grid.getElementsByTagName('TH')[i].offsetWidth;
                                    }
                                    grid.parentNode.appendChild(document.createElement('div'));
                                    var parentDiv = grid.parentNode; var table = document.createElement('table');
                                    for (i = 0; i < grid.attributes.length; i++) {
                                        if (grid.attributes[i].specified && grid.attributes[i].name != 'id') {
                                            table.setAttribute(grid.attributes[i].name, grid.attributes[i].value);
                                        }
                                    }
                                    table.style.cssText = grid.style.cssText;
                                    table.style.width = gridWidth + 'px';
                                    table.appendChild(document.createElement('tbody'));
                                    table.getElementsByTagName('tbody')[0].appendChild(grid.getElementsByTagName('TR')[0]);
                                    var cells = table.getElementsByTagName('TH');
                                    var gridRow = grid.getElementsByTagName('TR')[0];
                                    //for (var i = 0; i < cells.length; i++) {
                                    //    var width; if (headerCellWidths[i] > gridRow.getElementsByTagName('TD')[i].offsetWidth) {
                                    //        width = headerCellWidths[i];
                                    //    } else {
                                    //        width = gridRow.getElementsByTagName('TD')[i].offsetWidth;
                                    //    } cells[i].style.width = parseInt(width - 3) + 'px';
                                    //    gridRow.getElementsByTagName('TD')[i].style.width = parseInt(width - 3) + 'px';
                                    //}
                                    var gridHeight = grid.offsetHeight;
                                    if (gridHeight < ScrollHeight)
                                        ScrollHeight = gridHeight;
                                    parentDiv.removeChild(grid);
                                    var dummyHeader = document.createElement('div');
                                    dummyHeader.appendChild(table); parentDiv.appendChild(dummyHeader);
                                    var scrollableDiv = document.createElement('div');
                                    if (parseInt(gridHeight) > ScrollHeight) {
                                        gridWidth = parseInt(gridWidth) + 17;
                                    }
                                    scrollableDiv.style.cssText = 'overflow:auto;height:' + ScrollHeight + 'px;width:' + gridWidth + 'px';
                                    scrollableDiv.appendChild(grid);
                                    parentDiv.appendChild(scrollableDiv);
                                });
                            }
                            catch (err) { }
                        }
                        );
                    </script>
                </div>
            </div>
        </div>
    </div>
</asp:Content>
