﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class UserDashboard : Base.BasePage
{
    protected override void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
            bindData();
    }
    public void bindData()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Date", typeof(string));
        dt.Columns.Add("InTime", typeof(string));
        dt.Columns.Add("OutTime", typeof(string));
        dt.Columns.Add("HoursWorked", typeof(string));
        dt.Columns.Add("LateBy", typeof(string));
        dt.Columns.Add("EarlyExit", typeof(string));
        dt.Columns.Add("Status", typeof(string));
        for (int i = 0; i < 7; i++)
        {
            dt.Rows.Add(DateTime.Now.AddDays(-i).ToShortDateString(), DateTime.Now.ToShortTimeString(), DateTime.Now.ToShortTimeString(), i, i, i, "Present / Absent");
        }
        gvBoardDetails.DataSource = dt;
        gvBoardDetails.DataBind();
    }
}