using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for cls_master_levels
/// </summary>
public class cls_master_levels
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public DataSet getLevel(int para)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_get_level_one", para);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet getOrgLevelUpdated(int para1, string LevelID, int ParentId, string UserGroupName)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_get_level_Org_Updated", para1, LevelID, ParentId, UserGroupName);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet getOrgLevel(int para1)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_get_level_Org", para1);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int getNoLevel()
    {
        DataSet ds = new DataSet();
        int count = 0;
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_get_Total_Level");
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0][0] != DBNull.Value)
                {
                    count = Convert.ToInt32(ds.Tables[0].Rows[0][0]);
                }
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int getMaxLevel()
    {
        DataSet ds = new DataSet();
        int maxId = 0;
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_Ta_GetMaxLevel");
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0][0] != DBNull.Value)
                {                    
                    maxId = Convert.ToInt32(ds.Tables[0].Rows[0][0]);
                }
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return maxId;
    }
    public cls_master_levels()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
