using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for Cls_CheckUser
/// </summary>
public class Cls_CheckUser
{
    Database DBCon = DatabaseFactory.CreateDatabase("DbConnection");
    public DataSet checkRights(int pageId, int groupId, string prev)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckUserRights", new object[] { pageId, groupId, prev });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int CheckIndividualUser(string UserGroupName)
    {
        int intInduser = 0;
        try
        {
            intInduser = (int)DBCon.ExecuteScalar("Proc_TA_CheckIndividualUser", new object[] { UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return intInduser;
    }
    public Cls_CheckUser()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
