using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class LoginListEventData
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public DataSet Select_LoginDetails()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = objDataAccess.ExecuteDataSet("Proc_TA_SelectLoginDetails");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public void LogoutUser(string ConcurrentUserId)
    {
        try
        {
            htable.Clear();
            htable.Add("@ConcurrentUserId", ConcurrentUserId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_LogoutUser");
        }
        catch (Exception e)
        {
            throw e;
        }
    }
    public DataSet LoginOrNot(string userId, string ipAddress, string sessionId)
    {
        DataSet ds = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@userId", userId);
            htable.Add("@ipAddress", ipAddress);
            htable.Add("@sessionId", sessionId);
            ds = objDataAccess.GetStoredProcCommand("Proc_TA_LoginOrNot", htable);
        }
        catch (Exception e)
        {
            throw e;
        }
        return ds;
    }
}
